<?php
/*****************************************************************************\
+-----------------------------------------------------------------------------+
| X-Cart                                                                      |
| Copyright (c) 2001-2010 Ruslan R. Fazliev <rrf@rrf.ru>                      |
| All rights reserved.                                                        |
+-----------------------------------------------------------------------------+
| PLEASE READ  THE FULL TEXT OF SOFTWARE LICENSE AGREEMENT IN THE "COPYRIGHT" |
| FILE PROVIDED WITH THIS DISTRIBUTION. THE AGREEMENT TEXT IS ALSO AVAILABLE  |
| AT THE FOLLOWING URL: http://www.x-cart.com/license.php                     |
|                                                                             |
| THIS  AGREEMENT  EXPRESSES  THE  TERMS  AND CONDITIONS ON WHICH YOU MAY USE |
| THIS SOFTWARE   PROGRAM   AND  ASSOCIATED  DOCUMENTATION   THAT  RUSLAN  R. |
| FAZLIEV (hereinafter  referred to as "THE AUTHOR") IS FURNISHING  OR MAKING |
| AVAILABLE TO YOU WITH  THIS  AGREEMENT  (COLLECTIVELY,  THE  "SOFTWARE").   |
| PLEASE   REVIEW   THE  TERMS  AND   CONDITIONS  OF  THIS  LICENSE AGREEMENT |
| CAREFULLY   BEFORE   INSTALLING   OR  USING  THE  SOFTWARE.  BY INSTALLING, |
| COPYING   OR   OTHERWISE   USING   THE   SOFTWARE,  YOU  AND  YOUR  COMPANY |
| (COLLECTIVELY,  "YOU")  ARE  ACCEPTING  AND AGREEING  TO  THE TERMS OF THIS |
| LICENSE   AGREEMENT.   IF  YOU    ARE  NOT  WILLING   TO  BE  BOUND BY THIS |
| AGREEMENT, DO  NOT INSTALL OR USE THE SOFTWARE.  VARIOUS   COPYRIGHTS   AND |
| OTHER   INTELLECTUAL   PROPERTY   RIGHTS    PROTECT   THE   SOFTWARE.  THIS |
| AGREEMENT IS A LICENSE AGREEMENT THAT GIVES  YOU  LIMITED  RIGHTS   TO  USE |
| THE  SOFTWARE   AND  NOT  AN  AGREEMENT  FOR SALE OR FOR  TRANSFER OF TITLE.|
| THE AUTHOR RETAINS ALL RIGHTS NOT EXPRESSLY GRANTED BY THIS AGREEMENT.      |
|                                                                             |
| The Initial Developer of the Original Code is Ruslan R. Fazliev             |
| Portions created by Ruslan R. Fazliev are Copyright (C) 2001-2010           |
| Ruslan R. Fazliev. All Rights Reserved.                                     |
+-----------------------------------------------------------------------------+
\*****************************************************************************/

#
# $Id: catalog_request.php, v 1.0.0 2010/12/08 13:22:53 koronit Exp $
#

if ( !defined('XCART_SESSION_START') ) { header('Location: ../'); die('Access denied'); }

$location[] = array(func_get_langvar_by_name('lbl_catalog_request'), 'catalog_request.php');

x_load('mail', 'user');

if (!empty($login)) {
    $userinfo = func_userinfo($login,$login_type);
}

/**
 * Prepare name if user is registered
 */
if (!empty($userinfo['login'])) {
	$name = '';
	if (isset($userinfo['title'])) {
		$name .= $userinfo['title'];
	}

	if (isset($userinfo['firstname'])) {
		$name .= (!empty($name)) ? ' ' . $userinfo['firstname'] : $userinfo['firstname'];
	}

	if (isset($userinfo['lastname'])) {
		$name .= (!empty($name)) ? ' ' . $userinfo['lastname'] : $userinfo['lastname'];
	}

	$userinfo['name'] = $name;
}

/**
 * This variable will contain form data
 */
x_session_register('store_catalog_request');

/**
 * Define form fields
 */
$catalog_request_fields = array(
	'name'		=> array(
		'name'		=> 'name',
		'title'		=> func_get_langvar_by_name('lbl_name', null, false, true),
		'required'	=> 'Y',
		'avail'		=> 'Y'
	),
	'b_address'	=> array(
		'name'		=> 'b_address',
		'title'		=> func_get_langvar_by_name('lbl_street_address', null, false, true),
		'required'	=> 'Y',
		'avail'		=> 'Y'
	),
	'po_box'	=> array(
		'name'		=> 'po_box',
		'title'		=> func_get_langvar_by_name('lbl_po_box', null, false, true),
		'required'	=> 'N',
		'avail'		=> 'Y'
	),
	'b_city'		=> array(
		'name'		=> 'b_city',
		'title'		=> func_get_langvar_by_name('lbl_city', null, false, true),
		'required'	=> 'Y',
		'avail'		=> 'Y'
	),
	'b_state'		=> array(
		'name'		=> 'b_state',
		'title'		=> func_get_langvar_by_name('lbl_state', null, false, true),
		'required'	=> 'Y',
		'avail'		=> 'Y'
	),
	'b_zipcode'	=> array(
		'name'		=> 'b_zipcode',
		'title'		=> func_get_langvar_by_name('lbl_zip_code', null, false, true),
		'required'	=> 'Y',
		'avail'		=> 'Y'
	),
	'email'		=> array(
		'name'		=> 'email',
		'title'		=> func_get_langvar_by_name('lbl_email', null, false, true),
		'required'	=> 'N',
		'avail'		=> 'Y'
	),
	'how_did_you_find_us'	=> array(
		'name'		=> 'how_did_you_find_us',
		'title'		=> func_get_langvar_by_name('lbl_how_did_you_find_us', null, false, true),
		'required'	=> 'N',
		'avail'		=> 'Y'
	)
);

/**
 * Possible values for "How did you find us?" question
 * This values are taken from 'option_how_did_you_find_us' language variable
 * The variable must be set in appropriate format:
 * 1. Each line - one select option
 * 2. Line syntax: select_value=select_caption
 * 3. select_value - anything excep '=' (will be escaped by Smarty)
 * 4. select_caption - anything (will be escaped by Smarty)
 */
$how_did_you_find_us_array = explode("\n", func_get_langvar_by_name('option_how_did_you_find_us', null, false, true));
foreach ($how_did_you_find_us_array as $old_key => $old_value) {
	if (preg_match("/([^=]*)=(.*)/", $old_value, $new_values)) {
		$how_did_you_find_us_array[$old_key] = array($new_values[1], $new_values[2]);
	}
}

include $xcart_dir . '/include/states.php';

if (isset($err) && !empty($store_catalog_request)) {
	$userinfo = $store_catalog_request;
	if ($userinfo['fillerror']) {
		$fillerror = $userinfo['fillerror'];
	}

	if ($userinfo['antibot_catalog_req_err']) {
		$antibot_catalog_req_err = $userinfo['antibot_catalog_req_err'];
	}

	func_unset($userinfo, 'fillerror', 'antibot_catalog_req_err');
}

if ($REQUEST_METHOD == 'POST') {


	foreach ($_POST as $key => $val) {
		$catalog_request[$key] = $val;
	}

	x_session_register('antibot_catalog_req_err');
	$antibot_catalog_req_err = (!empty($active_modules['Image_Verification']) && func_validate_image('on_catalog_req', $antibot_input_str));

	/**
	 * Check on errors
	 */
	$fillerror = false;
	foreach ($catalog_request_fields as $k => $v) {
		if ($k == 'b_state' && $v['avail'] == 'Y' && ($v['required'] == 'Y' || !empty($catalog_request['b_state']))) {

			if (is_array($states) && !func_check_state($states, stripslashes($catalog_request['b_state']), 'US')) {
				$fillerror = true;
			}

		} elseif ($k == 'b_zipcode' && $v['avail'] == 'Y' && ($v['required'] == 'Y' || !empty($catalog_request['b_zipcode']))) {

			if (!func_check_zip($catalog_request['b_zipcode'], 'US')) {
				$fillerror = true;
			}

		} elseif ($k == 'email' && $v['avail'] == 'Y' && ($v['required'] == 'Y' || !empty($catalog_request['email']))) {

			if (!func_check_email($catalog_request['email'])) {
				$fillerror = true;
			}

		} elseif ($k == 'how_did_you_find_us' && $v['avail'] == 'Y' && ($v['required'] == 'Y' || !empty($catalog_request['how_did_you_find_us']))) {

			$fillerror = true;
			foreach ($how_did_you_find_us_array as $value) {
				if ($catalog_request['how_did_you_find_us'] == $value[0]) {
					$fillerror = false;
				}
			}

		} elseif (empty($catalog_request[$k]) && $v['required'] == 'Y' &&  $v['avail'] == 'Y') {

			$fillerror = true;
		}
	}

	/**
	 * Register the request if the data are valid
	 */
	if (!$fillerror && !$antibot_catalog_req_err) {

		$catalog_request = func_unhtml($catalog_request);

		/**
		 * Place request into database
		 */

		$cat_req_fields = array(
			'name' 			=> (!empty($catalog_request['name']) ? $catalog_request['name'] : ''),
			'address1'		=> (!empty($catalog_request['b_address']) ? $catalog_request['b_address'] : ''),
			'address2'		=> (!empty($catalog_request['po_box']) ? $catalog_request['po_box'] : ''),
			'city'			=> (!empty($catalog_request['b_city']) ? $catalog_request['b_city'] : ''),
			'state'			=> (!empty($catalog_request['b_state']) ? $catalog_request['b_state'] : ''),
			'zipcode'		=> (!empty($catalog_request['b_zipcode']) ? $catalog_request['b_zipcode'] : ''),
			'email'			=> (!empty($catalog_request['email']) ? $catalog_request['email'] : ''),
			'code'			=> (!empty($catalog_request['how_did_you_find_us']) ? $catalog_request['how_did_you_find_us'] : ''),
			'new_request'	=> 'Y'
		);

		func_array2insert($sql_tbl['catalog_requests'], $cat_req_fields);

		/**
		 * Send request to orders department via email
		 */
		if ('Y' == $config['Email_Note']['enable_cat_req_notif']) {
			unset($cat_req_fields['new_request']);
			$cat_req_fields = func_stripslashes($cat_req_fields);

			$mail_smarty->assign('cat_req_fields', $cat_req_fields);

			func_send_mail($config["Company"]["orders_department"], "mail/catalog_request_subj.tpl", "mail/catalog_request.tpl", $cat_req_fields['email'], false);
		}

		/**
		 * Go to the confirmation page
		 */
		x_session_unregister('store_catalog_request');

		func_header_location('catalog_request.php?mode=requested');

	} else {
        /**
         * Prepare for redirection if the data are not valid
         */

		$userinfo = func_stripslashes($_POST);
		$userinfo['login'] = $userinfo['uname'];
		$userinfo['fillerror'] = $fillerror;
		$userinfo['antibot_catalog_req_err'] = $antibot_catalog_req_err;
		$store_catalog_request = $userinfo;

		$top_message = array(
			'type' => 'E',
			'content' => func_get_langvar_by_name(($fillerror) ? 'txt_registration_error' : 'msg_err_antibot')
		);
	}

	func_header_location('catalog_request.php?err=1');

}

$smarty->assign('userinfo', @$userinfo);
$smarty->assign('fillerror', @$fillerror);
if (!empty($active_modules['Image_Verification']) && !empty($antibot_catalog_req_err)) {
	$smarty->assign('antibot_catalog_req_err', @$antibot_catalog_req_err);
	x_session_unregister('antibot_catalog_req_err');
}


$smarty->assign('catalog_request_fields', @$catalog_request_fields);
if ('Y' == $catalog_request_fields['how_did_you_find_us']['avail']) {
	$smarty->assign('how_did_you_find_us_array', @$how_did_you_find_us_array);
}

$smarty->assign('main', 'catalog_request');
?>
