<?php
/*****************************************************************************\
+-----------------------------------------------------------------------------+
| X-Cart                                                                      |
| Copyright (c) 2001-2010 Ruslan R. Fazlyev <rrf@x-cart.com>                  |
| All rights reserved.                                                        |
+-----------------------------------------------------------------------------+
| PLEASE READ  THE FULL TEXT OF SOFTWARE LICENSE AGREEMENT IN THE "COPYRIGHT" |
| FILE PROVIDED WITH THIS DISTRIBUTION. THE AGREEMENT TEXT IS ALSO AVAILABLE  |
| AT THE FOLLOWING URL: http://www.x-cart.com/license.php                     |
|                                                                             |
| THIS  AGREEMENT  EXPRESSES  THE  TERMS  AND CONDITIONS ON WHICH YOU MAY USE |
| THIS SOFTWARE   PROGRAM   AND  ASSOCIATED  DOCUMENTATION   THAT  RUSLAN  R. |
| FAZLYEV (hereinafter  referred to as "THE AUTHOR") IS FURNISHING  OR MAKING |
| AVAILABLE TO YOU WITH  THIS  AGREEMENT  (COLLECTIVELY,  THE  "SOFTWARE").   |
| PLEASE   REVIEW   THE  TERMS  AND   CONDITIONS  OF  THIS  LICENSE AGREEMENT |
| CAREFULLY   BEFORE   INSTALLING   OR  USING  THE  SOFTWARE.  BY INSTALLING, |
| COPYING   OR   OTHERWISE   USING   THE   SOFTWARE,  YOU  AND  YOUR  COMPANY |
| (COLLECTIVELY,  "YOU")  ARE  ACCEPTING  AND AGREEING  TO  THE TERMS OF THIS |
| LICENSE   AGREEMENT.   IF  YOU    ARE  NOT  WILLING   TO  BE  BOUND BY THIS |
| AGREEMENT, DO  NOT INSTALL OR USE THE SOFTWARE.  VARIOUS   COPYRIGHTS   AND |
| OTHER   INTELLECTUAL   PROPERTY   RIGHTS    PROTECT   THE   SOFTWARE.  THIS |
| AGREEMENT IS A LICENSE AGREEMENT THAT GIVES  YOU  LIMITED  RIGHTS   TO  USE |
| THE  SOFTWARE   AND  NOT  AN  AGREEMENT  FOR SALE OR FOR  TRANSFER OF TITLE.|
| THE AUTHOR RETAINS ALL RIGHTS NOT EXPRESSLY GRANTED BY THIS AGREEMENT.      |
|                                                                             |
| The Initial Developer of the Original Code is Ruslan R. Fazlyev             |
| Portions created by Ruslan R. Fazlyev are Copyright (C) 2001-2010           |
| Ruslan R. Fazlyev. All Rights Reserved.                                     |
+-----------------------------------------------------------------------------+
\*****************************************************************************/

#
# $Id: categories.php,v 1.116.2.3 2010/01/21 09:20:32 ferz Exp $
#

if ( !defined('XCART_SESSION_START') ) { header("Location: ../"); die("Access denied"); }

x_load('category');

$cat = isset($cat) ? intval($cat) : 0;

if ($cat > 0) {
#
# Get the current category data
#
	if ($current_category = func_get_category_data($cat)) {
		list($current_category['image_x'], $current_category['image_y']) = func_crop_dimensions(
			$current_category['image_x'], $current_category['image_y'],
			$config['Appearance']['thumbnail_width'], $config['Appearance']['thumbnail_height']
		);
		$smarty->assign("current_category", $current_category);

	} elseif ($current_area == "A") {
		$top_message = array(
			"content" => func_get_langvar_by_name("msg_category_not_exist"),
			"type" => "E"
		);
		func_header_location("categories.php");

	} elseif ($main != "product") {
		$category_is_exists = func_query_first_cell("SELECT COUNT(*) FROM $sql_tbl[categories] WHERE categoryid = '$cat'") > 0;
		if ($category_is_exists) 
			func_header_location($current_location.DIR_CUSTOMER."/home.php");

		func_page_not_found();
	}
}

#
# Gather the array of categories and extract into separated arrays:
# $all_categories, $categories and $subcategories
#
if (($current_area == "C" && defined("GET_ALL_CATEGORIES")) || defined('MANAGE_CATEGORIES')) {
	$_categories = func_get_categories_list($cat);

} elseif ($current_area == 'C' && !empty($active_modules["Flyout_Menus"]) && (!func_fc_use_cache() || !func_fc_has_cache())) {
	$_categories = func_get_categories_list($cat);

} elseif ($current_area == "C" && defined("GET_ALL_CATEGORIES_SHORT")) {
    $_categories = func_get_categories_list($cat, X_CATEGORIES_FOR_SELECT_BOX);

} elseif($current_area == "C") {
	$_categories = func_get_categories_list($cat, true, "current");

} else {
	$_categories = func_get_categories_list($cat, true, "all");
}

extract($_categories);
unset($_categories);

#
# Prepare data for FancyCategories module
#
if ($current_area == "C" && !empty($active_modules["Flyout_Menus"]))
	@include $xcart_dir."/modules/Flyout_Menus/fancy_categories.php";

if (!empty($all_categories))
	$smarty->assign("allcategories", $all_categories);

if (!empty($categories))
	$smarty->assign("categories", $categories);

if ($cat == 0)
	$subcategories = $categories;

#
# Override subcategory_count for Admin area
#
if(!empty($subcategories) && ($current_area == 'A' || ($current_area == 'P' && $active_modules['Simple_Mode']))) {
	$product_counts = func_query_hash("SELECT categoryid, COUNT(*) FROM $sql_tbl[products_categories] WHERE categoryid IN ('".implode("','", array_keys($subcategories))."') GROUP BY categoryid", "categoryid", false, true);
	foreach ($subcategories as $k => $v) {
		$subcategories[$k]['subcategory_count'] = func_query_first_cell("SELECT COUNT(subcat.categoryid) as subc FROM $sql_tbl[categories] USE INDEX (PRIMARY) LEFT JOIN $sql_tbl[categories] as subcat ON subcat.categoryid_path LIKE CONCAT($sql_tbl[categories].categoryid_path, '/%') WHERE $sql_tbl[categories].categoryid = '$k' GROUP BY $sql_tbl[categories].categoryid");
		$subcategories[$k]['product_count_global'] = $subcategories[$k]['product_count'];
		$subcategories[$k]['product_count'] = isset($product_counts[$k]) ? intval($product_counts[$k]) : 0;
	}
}

if (!empty($subcategories)) {

	$subcat_div_height = 0;
	$subcat_div_width = 100;
	foreach ($subcategories as $k_sub => $subcat) {
		# Set minimum image size
		$subcategories[$k_sub]['image_x'] = max($subcategories[$k_sub]['image_x'], 1);
		$subcategories[$k_sub]['image_y'] = max($subcategories[$k_sub]['image_y'], 1);

		# Decrease images size if its real size is greater than maximum
		if ($subcat['is_icon']) {
			list($subcategories[$k_sub]['image_x'], $subcategories[$k_sub]['image_y']) = func_crop_dimensions(
				$subcategories[$k_sub]['image_x'], $subcategories[$k_sub]['image_y'],
				$config['Appearance']['thumbnail_width'], $config['Appearance']['thumbnail_height']
			);
		}

		# Set div size
		$subcat_div_height = max($subcat_div_height, $subcategories[$k_sub]['image_y']);
		$subcat_div_width = max($subcat_div_width, $subcategories[$k_sub]['image_x']);
	}

	if ($subcat_div_height == 0)
		$subcat_div_height = 100;

	$smarty->assign("subcat_div_width", $subcat_div_width);
	$smarty->assign("subcat_div_height", $subcat_div_height + 70);
	$smarty->assign("subcat_img_height", $subcat_div_height);
	$smarty->assign("subcategories", $subcategories);
}

$smarty->assign("cat", $cat);

if ($config['General']['root_categories'] == 'Y') {
	$smarty->assign("categories_menu_list", $categories);

} else {
	$smarty->assign("categories_menu_list", $subcategories);
}
?>
