<?php
/*****************************************************************************\
+-----------------------------------------------------------------------------+
| X-Cart                                                                      |
| Copyright (c) 2001-2010 Ruslan R. Fazliev <rrf@rrf.ru>                      |
| All rights reserved.                                                        |
+-----------------------------------------------------------------------------+
| PLEASE READ  THE FULL TEXT OF SOFTWARE LICENSE AGREEMENT IN THE "COPYRIGHT" |
| FILE PROVIDED WITH THIS DISTRIBUTION. THE AGREEMENT TEXT IS ALSO AVAILABLE  |
| AT THE FOLLOWING URL: http://www.x-cart.com/license.php                     |
|                                                                             |
| THIS  AGREEMENT  EXPRESSES  THE  TERMS  AND CONDITIONS ON WHICH YOU MAY USE |
| THIS SOFTWARE   PROGRAM   AND  ASSOCIATED  DOCUMENTATION   THAT  RUSLAN  R. |
| FAZLIEV (hereinafter  referred to as "THE AUTHOR") IS FURNISHING  OR MAKING |
| AVAILABLE TO YOU WITH  THIS  AGREEMENT  (COLLECTIVELY,  THE  "SOFTWARE").   |
| PLEASE   REVIEW   THE  TERMS  AND   CONDITIONS  OF  THIS  LICENSE AGREEMENT |
| CAREFULLY   BEFORE   INSTALLING   OR  USING  THE  SOFTWARE.  BY INSTALLING, |
| COPYING   OR   OTHERWISE   USING   THE   SOFTWARE,  YOU  AND  YOUR  COMPANY |
| (COLLECTIVELY,  "YOU")  ARE  ACCEPTING  AND AGREEING  TO  THE TERMS OF THIS |
| LICENSE   AGREEMENT.   IF  YOU    ARE  NOT  WILLING   TO  BE  BOUND BY THIS |
| AGREEMENT, DO  NOT INSTALL OR USE THE SOFTWARE.  VARIOUS   COPYRIGHTS   AND |
| OTHER   INTELLECTUAL   PROPERTY   RIGHTS    PROTECT   THE   SOFTWARE.  THIS |
| AGREEMENT IS A LICENSE AGREEMENT THAT GIVES  YOU  LIMITED  RIGHTS   TO  USE |
| THE  SOFTWARE   AND  NOT  AN  AGREEMENT  FOR SALE OR FOR  TRANSFER OF TITLE.|
| THE AUTHOR RETAINS ALL RIGHTS NOT EXPRESSLY GRANTED BY THIS AGREEMENT.      |
|                                                                             |
| The Initial Developer of the Original Code is Ruslan R. Fazliev             |
| Portions created by Ruslan R. Fazliev are Copyright (C) 2001-2010           |
| Ruslan R. Fazliev. All Rights Reserved.                                     |
+-----------------------------------------------------------------------------+
\*****************************************************************************/

#
# $Id: export_cat_req.php, v 1.0.0 2010/12/10 10:00:24 koronit Exp $
#

if ( !defined('XCART_SESSION_START') ) { header('Location: ../'); die('Access denied'); }

x_load('export');

/**
 * Define the data for the navigation within section
 */
include $xcart_dir.'/include/import_tools.php';

/**
 * The export log file name
 * File with log of export
 * URL of the file with log of export
 */
$export_log_filename = 'x-errors_' . EXPORT_CAT_REQ_FILE_PREFIX . '-' .preg_replace('!'.func_login_validation_regexp(true).'!', '', $login).'-'.date('ymd').'.php';
$export_log = $var_dirs['log'].'/'.$export_log_filename;
$export_log_url = 'get_log.php?file='.$export_log_filename;

$new_export_log_file = (file_exists($export_log))
                        ? false
                        : true;

$md5_login = md5($login);

if ($REQUEST_METHOD == 'POST' && !empty($data)) {
    /**
     * Save export data
     */
    if ($data['delimiter'] == 'tab') {
        $data['delimiter'] = "\t";
    }

    $data['delimiter'] = (in_array($data['delimiter'], array(';',',',"\t")))
        ? $data['delimiter']
        : ',';

    $data['new'] = (in_array($data['new'], array('Y', 'N')))
        ? $data['new']
        : 'Y';

    $data['rows_per_file'] = intval($data['rows_per_file']);

    $export_data = $data;
    $action = 'export';

} elseif ($REQUEST_METHOD == 'POST' && !empty($packs) && $action == 'delete_pack') {
    /**
     * Delete export pack
     */
    $is_delete = false;
    foreach ($packs as $key) {
        if (!preg_match('/^(\d{8})(\d{6})$/S', $key, $found)) {
            continue;
        }

        $filename = EXPORT_CAT_REQ_FILE_PREFIX . '_' . $found[1] . '_' . $found[2];
        $dp = @opendir($export_dir);
        if (!$dp) {
            continue;
        }

        while ($file = readdir($dp)) {
            if ($file == '.' || $file == '..') {
                continue;
            }

            if (preg_match('/^'.$filename.'/S', $file)) {
                $is_delete = true;
                if (is_dir($export_dir.DIRECTORY_SEPARATOR.$file)) {
                    func_rm_dir($export_dir.DIRECTORY_SEPARATOR.$file);
                } else {
                    unlink($export_dir.DIRECTORY_SEPARATOR.$file);
                }
            }
        }
        closedir($dp);
    }

    if ($is_delete) {
        $top_message['content'] = (count($packs) > 1) 
            ? func_get_langvar_by_name('txt_export_packs_has_been_successfully_removed')
            : func_get_langvar_by_name('txt_export_pack_has_been_successfully_removed');
        $top_message['type'] = 'I';
    }
    func_header_location('import.php?mode=export_cat_req&status=success#packs');
}

/**
 * Export data
 */
if ($action == 'export') {

    /**
     * Open the log file for writing
     */
    if (!($logf = @fopen($export_log, (($new_export_log_file) ? 'w+' : 'a+')))) {
        $top_message['content'] = func_get_langvar_by_name('msg_err_import_log_writing');
        $top_message['type'] = 'E';
        func_header_location('import.php?mode=export_cat_req');
    }
    func_chmod_file($export_log);
    
    func_display_service_header();

    /**
     * Start log file writing...
     */
    $current_date = date('d-M-Y H:i:s', mktime() + $config['Appearance']['timezone_offset']);
    $message = <<<OUT
Date: $current_date
Launched by: $login

OUT;
    $message = constant('X_LOG_SIGNATURE').$message;

    if (!empty($message) && $logf && $new_export_log_file) {
        fwrite($logf, $message."\n");
    }

    $export_data['prefix'] = $export_dir . '/' . EXPORT_CAT_REQ_FILE_PREFIX . '_' . date('Ymd_His');
    $export_data['data_dir'] = $export_data['prefix'];

    /**
     * Display export header
     */
    $message = func_get_langvar_by_name('lbl_exporting_data_', null, false, true);
    if (!empty($message)) {
        echo '<b>'.$message."</b><br />\n";
        func_flush();
    }

    $message = <<<OUT
<script type="text/javascript">
<!--
    loaded = false;

    function refresh() {
        window.scroll(0, 100000);
        if (loaded == false)
            setTimeout('refresh()', 1000);
    }

    setTimeout('refresh()', 1000);
-->
</script>
OUT;

    func_flush($message);

    $end_message = <<<OUT
<script type="text/javascript">
<!--
    loaded = true;
-->
</script>
OUT;

    func_flush($end_message);


    /**
     * Get MySQL-resource
     */
    $where = ($export_data['new'] == 'Y')
        ? ' WHERE new_request = \'Y\''
        : '';

    $data = func_query("SELECT * FROM $sql_tbl[catalog_requests]$where");

    if (empty($data)) {
        $message = ('Y' == $export_data['new'])
            ? 'txt_no_new_catalog_requests'
            : 'txt_no_any_catalog_requests';
        $top_message['content'] = func_get_langvar_by_name($message);
        $top_message['type'] = 'I';
        func_header_location('import.php?mode=export_cat_req');
    }

    /**
     * Unmark all new requests (new_request='N')
     */
    $new_requestids = array();
    foreach ($data as $value) {
        if ('Y' == $value['new_request']) {
            $new_requestids[] = $value['requestid'];
        }
        unset($value['requestid']);
        unset($value['new_request']);
    }
    if (!empty($new_requestids)) {
        $new_requestids = '('.implode(', ', $new_requestids).')';
        db_query("UPDATE $sql_tbl[catalog_requests] SET new_request = 'N' WHERE requestid IN $new_requestids");
    }

    $exported_lines = 0;
    $current_file_lines = 0;

    $is_new_export_file = true;
    $add_part = 0;
    $add_part_string = '';

    $csv_header = func_query_column("SHOW COLUMNS FROM $sql_tbl[catalog_requests]");

    foreach ($csv_header as $key => $value) {
        if ('requestid' == $value) {
            unset($csv_header[$key]);
        } else if ('new_request' == $value) {
            unset($csv_header[$key]);
        }
    }

    $csv_header = X_LOG_SIGNATURE . implode($export_data['delimiter'], $csv_header) . "\n";
    
    /**
     * Write rows to file
     */
    foreach ($data as $row) {
        if ($is_new_export_file) {
            if (!($export_file = @fopen($export_data['prefix'].$add_part_string.'_'.$md5_login.'.csv.php', 'w+'))) {
                $top_message['content'] = func_get_langvar_by_name('msg_err_exoprt_cat_req_writing');
                $top_message['type'] = 'E';
                func_header_location('import.php?mode=export_cat_req');
            }
            fwrite($export_file, $csv_header);
            $is_new_export_file = false;
        }
        unset($row['requestid']);
        unset($row['new_request']);
        foreach ($row as $key => $value) {
            $row[$key] = func_value_normalize($value, true);
        }
        fwrite($export_file, implode($export_data['delimiter'], $row)."\n");
        ++$current_file_lines;
        if ($current_file_lines >= $export_data['rows_per_file'] && $export_data['rows_per_file'] != 0) {
            $is_new_export_file = true;
            $exported_lines += $current_file_lines;
            $current_file_lines = 0;
            ++$add_part;
            $add_part_string = sprintf('_%03d', $add_part);
        }
    }
    
    if (0 == $exported_lines) {
        $exported_lines = $current_file_lines;
    } else if ($current_file_lines != 0) {
        $exported_lines += $current_file_lines;
    }

    /**
     * Display export footer
     */
    $message = func_get_langvar_by_name('lbl_rows', null, false, true).': '.$exported_lines;
    if (!empty($message) && $logf) {
        fwrite($logf, $message."\n");
    }
    func_flush("<br />\n".$message."<br />\n<br />\n");

    fclose($logf);
    fclose($export_file);

    $export_data = array();
    $top_message['content'] = func_get_langvar_by_name('lbl_export_success');
    $top_message['type'] = 'I';
    func_html_location('import.php?mode=export_cat_req&status=success', 3);
}


/**
 * Get export packs list
 */
if (($dp = @opendir($export_dir))) {
    $export_packs = array();
    /**
     * Read all files from export dir
     */
    while ($file = readdir($dp)) {

        if (is_dir($export_dir.DIRECTORY_SEPARATOR.$file)) {
            continue;
        }

        if (!empty($active_modules['Simple_Mode'])) {
            $pattern = '/^' . EXPORT_CAT_REQ_FILE_PREFIX . '_(\d{4})(\d{2})(\d{2})_(\d{2})(\d{2})(\d{2})/S';
        } else {
            $pattern = '/^' . EXPORT_CAT_REQ_FILE_PREFIX . '_(\d{4})(\d{2})(\d{2})_(\d{2})(\d{2})(\d{2})(_\d{3})?_' . $md5_login . '/S';
        }

        /**
         * If correct export file, continue
         */
        if (!preg_match($pattern, $file, $found)) {
            continue;
        }

        if (isset($found[7])) {
            unset($found[7]);
        }

        /**
         * Withdraw file name
         * Make key string
         */
        $fn = array_shift($found);
        $found = array_values($found);
        $key = implode('', $found);
        /**
         * Define initial data
         */
        if (!isset($export_packs[$key])) {

            $export_packs[$key] = array(
                'date'  => mktime($found[3], $found[4], $found[5], $found[1], $found[2], $found[0]),
                'files' => array(),
                'count' => 0
            );
        }
        /**
         * Get the export filenames that will be send to admin 
         */
        if ($fe = @fopen($export_dir.DIRECTORY_SEPARATOR.$file, 'r')) {
            $file = str_replace('.php', '', $file);
            $file_name = preg_replace('/^' . EXPORT_CAT_REQ_FILE_PREFIX . '_(\d{8})(_\d{6})(_\d{3})?(_\w{32}).csv/S', EXPORT_CAT_REQ_FILE_PREFIX . '_$1$2$3.csv', $file);

            $export_packs[$key]['files'][$file] = array(
                'file_name' => $file_name,
            );

            ++$export_packs[$key]['count'];
            fclose($fe);
        }

    }
    closedir($dp);

    foreach ($export_packs as $key => $ep) {
        if (!empty($ep['files'])) {
            continue;
        }
        unset($export_packs[$key]);
    }

    if (!empty($export_packs)) {
        krsort($export_packs, SORT_NUMERIC);
        $smarty->assign('export_packs', $export_packs);
    }
}

/**
 * Get last log url
 */
$filename = $var_dirs['log'].'/'.$export_log_filename;
if (($fe = @fopen($filename, 'r')) !== false) {
    $smarty->assign('export_log_url', $export_log_url);
}

$smarty->assign('export_data', $export_data);

$smarty->assign('mode', $mode);
?>
