<?php
/*****************************************************************************\
+-----------------------------------------------------------------------------+
| X-Cart                                                                      |
| Copyright (c) 2001-2010 Ruslan R. Fazlyev <rrf@x-cart.com>                  |
| All rights reserved.                                                        |
+-----------------------------------------------------------------------------+
| PLEASE READ  THE FULL TEXT OF SOFTWARE LICENSE AGREEMENT IN THE "COPYRIGHT" |
| FILE PROVIDED WITH THIS DISTRIBUTION. THE AGREEMENT TEXT IS ALSO AVAILABLE  |
| AT THE FOLLOWING URL: http://www.x-cart.com/license.php                     |
|                                                                             |
| THIS  AGREEMENT  EXPRESSES  THE  TERMS  AND CONDITIONS ON WHICH YOU MAY USE |
| THIS SOFTWARE   PROGRAM   AND  ASSOCIATED  DOCUMENTATION   THAT  RUSLAN  R. |
| FAZLYEV (hereinafter  referred to as "THE AUTHOR") IS FURNISHING  OR MAKING |
| AVAILABLE TO YOU WITH  THIS  AGREEMENT  (COLLECTIVELY,  THE  "SOFTWARE").   |
| PLEASE   REVIEW   THE  TERMS  AND   CONDITIONS  OF  THIS  LICENSE AGREEMENT |
| CAREFULLY   BEFORE   INSTALLING   OR  USING  THE  SOFTWARE.  BY INSTALLING, |
| COPYING   OR   OTHERWISE   USING   THE   SOFTWARE,  YOU  AND  YOUR  COMPANY |
| (COLLECTIVELY,  "YOU")  ARE  ACCEPTING  AND AGREEING  TO  THE TERMS OF THIS |
| LICENSE   AGREEMENT.   IF  YOU    ARE  NOT  WILLING   TO  BE  BOUND BY THIS |
| AGREEMENT, DO  NOT INSTALL OR USE THE SOFTWARE.  VARIOUS   COPYRIGHTS   AND |
| OTHER   INTELLECTUAL   PROPERTY   RIGHTS    PROTECT   THE   SOFTWARE.  THIS |
| AGREEMENT IS A LICENSE AGREEMENT THAT GIVES  YOU  LIMITED  RIGHTS   TO  USE |
| THE  SOFTWARE   AND  NOT  AN  AGREEMENT  FOR SALE OR FOR  TRANSFER OF TITLE.|
| THE AUTHOR RETAINS ALL RIGHTS NOT EXPRESSLY GRANTED BY THIS AGREEMENT.      |
|                                                                             |
| The Initial Developer of the Original Code is Ruslan R. Fazlyev             |
| Portions created by Ruslan R. Fazlyev are Copyright (C) 2001-2010           |
| Ruslan R. Fazlyev. All Rights Reserved.                                     |
+-----------------------------------------------------------------------------+
\*****************************************************************************/

#
# $Id: func.category.php,v 1.34.2.4 2010/03/24 14:19:14 aim Exp $
#

if ( !defined('XCART_START') ) { header("Location: ../"); die("Access denied"); }

x_load('files','image');

define("X_CATEGORIES_FOR_SELECT_BOX", 1);

#
# Delete category recursively and all subcategories and products
#
function func_delete_category($cat, $tick = 0) {
	global $sql_tbl, $active_modules;

	$catpair = func_query_first("SELECT categoryid_path, parentid FROM $sql_tbl[categories] WHERE categoryid='$cat'");
	if ($catpair === false) # category is missing
		return 0;

	#
	# Delete products from subcategories
	#
	$categoryid_path = $catpair["categoryid_path"];
	$parent_categoryid = $catpair["parentid"];
	$prods = db_query("SELECT $sql_tbl[products_categories].productid FROM $sql_tbl[categories], $sql_tbl[products_categories] WHERE ($sql_tbl[categories].categoryid='$cat' OR $sql_tbl[categories].categoryid_path LIKE '$categoryid_path/%') AND $sql_tbl[products_categories].categoryid=$sql_tbl[categories].categoryid AND $sql_tbl[products_categories].main='Y'");

	if ($prods) {
		x_load('product');

		if ($tick > 0) {
			func_display_service_header("lbl_deleting_category_products");
		}

		$i = 0;
		while ($prod = db_fetch_array($prods)) {
			$i++;
			func_delete_product($prod["productid"], false);
			if ($tick > 0 && $i % $tick == 0) {
				func_flush(".");
				if ($i % ($tick * 50) == 0) {
					func_flush("<br />\n");
				}
			}
		}

		if ($tick > 0) {
			func_flush("<br />\n");
		}

		db_free_result($prods);
	}

	#
	# Delete subcategories
	#
	$subcats = func_query_column("SELECT categoryid FROM $sql_tbl[categories] WHERE categoryid='$cat' OR categoryid_path LIKE '$categoryid_path/%'");

	if (is_array($subcats) && !empty($subcats)) {
		 x_load('image');

		db_exec("DELETE FROM $sql_tbl[categories] WHERE categoryid IN (?)", array($subcats));
		db_exec("DELETE FROM $sql_tbl[products_categories] WHERE categoryid IN (?)", array($subcats));
		db_exec("DELETE FROM $sql_tbl[categories_subcount] WHERE categoryid IN (?)", array($subcats));
		db_exec("DELETE FROM $sql_tbl[featured_products] WHERE categoryid IN (?)", array($subcats));
		db_exec("DELETE FROM $sql_tbl[categories_lng] WHERE categoryid IN (?)", array($subcats));
		db_exec("DELETE FROM $sql_tbl[category_memberships] WHERE categoryid IN (?)", array($subcats));

		if (!empty($active_modules['Special_Offers'])) {
			db_query("DELETE FROM $sql_tbl[offer_bonus_params] WHERE param_type = 'C' AND param_id IN ('".implode("','", $subcats)."')");
			db_query("DELETE FROM $sql_tbl[offer_condition_params] WHERE param_type = 'C' AND param_id IN ('".implode("','", $subcats)."')");
		}

		func_delete_image($subcats, 'C');
	}

	$path = explode("/", $categoryid_path);
	array_pop($path);
	if (!empty($path)) {
		if ($tick > 0) {
			func_recalc_subcat_count($path, 10);
		}
	}

	# Delete Clean URLs data.
	db_exec("DELETE FROM $sql_tbl[clean_urls] WHERE resource_type = 'C' AND resource_id IN (?)", array($subcats));
	db_exec("DELETE FROM $sql_tbl[clean_urls_history] WHERE resource_type = 'C' AND resource_id IN (?)", array($subcats));

	return $parent_categoryid;
}

#
# Recalculate product count in Categories table and Categories counts table
#
function func_recalc_product_count($categoryid = false, $tick = 0) {
	global $sql_tbl, $config, $single_mode;

	$forsale_condition = "($sql_tbl[products].forsale = 'Y' OR $sql_tbl[products].forsale = '' OR $sql_tbl[products].forsale = 'B')";

	# Get mysql resource
	$where = "";
	if ($categoryid !== false) {
		if (empty($categoryid))
			return false;

		if (is_array($categoryid)) {
			if (is_array(current($categoryid))) {
				foreach ($categoryid as $k => $v) {
					$categoryid[$k] = $v['categoryid'];
				}
			}
			$where = "WHERE $sql_tbl[categories].categoryid IN ('".implode("','", $categoryid)."')";

		} elseif (!is_array($categoryid) && !is_resource($categoryid)) {
			$where = "WHERE $sql_tbl[categories].categoryid = '$categoryid'";
			
		}

		if (!is_resource($categoryid))
			$categoryid = db_query("SELECT categoryid, categoryid_path FROM $sql_tbl[categories] ".$where);

	} else {
		$categoryid = db_query("SELECT categoryid, categoryid_path FROM $sql_tbl[categories]");

	}

	if (!$categoryid)
		return false;

	# Get membership levels
	$lvl = func_query_column("SELECT membershipid FROM $sql_tbl[memberships] WHERE area = 'C'");
	$lvl[] = 0;

	if ($tick > 0)
		func_display_service_header();

	$finished = false;
	$cnt = 0;
	while ($c = db_fetch_array($categoryid)) {

		# Get category path
		if (isset($c['path'])) {
			$path = $c['path']."/%";
		} else {
			$path = func_query_first_cell("SELECT categoryid_path FROM $sql_tbl[categories] WHERE categoryid = '$c[categoryid]'")."/%";
		}
		$c = $c['categoryid'];

		# Get common counter
		if (!$single_mode) {
			$res = db_query("SELECT COUNT(*) FROM $sql_tbl[customers], $sql_tbl[products], $sql_tbl[products_categories], $sql_tbl[categories] WHERE $sql_tbl[customers].login=$sql_tbl[products].provider AND $sql_tbl[customers].activity='Y' AND $sql_tbl[products].productid=$sql_tbl[products_categories].productid AND $forsale_condition AND $sql_tbl[products_categories].categoryid = $sql_tbl[categories].categoryid AND $sql_tbl[categories].categoryid_path LIKE '$path' AND $sql_tbl[categories].avail = 'Y' GROUP BY $sql_tbl[products].productid");
			$res_top = db_query("SELECT COUNT(*) FROM $sql_tbl[customers], $sql_tbl[products], $sql_tbl[products_categories], $sql_tbl[categories] WHERE $sql_tbl[customers].login=$sql_tbl[products].provider AND $sql_tbl[customers].activity='Y' AND $sql_tbl[products].productid=$sql_tbl[products_categories].productid AND $forsale_condition AND $sql_tbl[products_categories].categoryid = $sql_tbl[categories].categoryid AND $sql_tbl[categories].categoryid = '$c' GROUP BY $sql_tbl[products].productid");

		} else {
			$res = db_query("SELECT COUNT(*) FROM $sql_tbl[products], $sql_tbl[products_categories], $sql_tbl[categories] WHERE $sql_tbl[products].productid=$sql_tbl[products_categories].productid AND $forsale_condition AND $sql_tbl[products_categories].categoryid = $sql_tbl[categories].categoryid AND $sql_tbl[categories].categoryid_path LIKE '$path' AND $sql_tbl[categories].avail = 'Y' GROUP BY $sql_tbl[products].productid");
			$res_top = db_query("SELECT COUNT(*) FROM $sql_tbl[products], $sql_tbl[products_categories], $sql_tbl[categories] WHERE $sql_tbl[products].productid=$sql_tbl[products_categories].productid AND $forsale_condition AND $sql_tbl[products_categories].categoryid = $sql_tbl[categories].categoryid AND $sql_tbl[categories].categoryid = '$c' GROUP BY $sql_tbl[products].productid");
		}

		$product_count = 0;
		$top_product_count = 0;
		if ($res && $res_top) {
			$top_product_count = db_num_rows($res_top);
			$product_count = db_num_rows($res) + $top_product_count;
			db_free_result($res);
			db_free_result($res_top);
		}

		func_array2update(
			"categories",
			array(
				"product_count" => $product_count,
				"top_product_count" => $top_product_count
			),
			"categoryid = '$c'"
		);

		if (count($lvl) == 1) {

			# If membership list is empty
			$query_data = array(
				"product_count" => $product_count,
				"top_product_count" => $top_product_count
			);

			if (func_query_first_cell("SELECT COUNT(*) FROM $sql_tbl[categories_subcount] WHERE categoryid = '$c' AND membershipid = '0'") > 0) {
				func_array2update("categories_subcount", $query_data, "categoryid = '$c' AND membershipid = '0'");

			} else {
				$query_data['categoryid'] = $c;
				$query_data['membershipid'] = 0;
				func_array2insert("categories_subcount", $query_data);
			}

		} else {

			# If membeship list is not empty

			# Get product counter (common products)
			if (!$single_mode) {
				$res = db_query("SELECT COUNT(*) FROM $sql_tbl[customers], $sql_tbl[products_categories], $sql_tbl[categories], $sql_tbl[products] LEFT JOIN $sql_tbl[product_memberships] ON $sql_tbl[product_memberships].productid = $sql_tbl[products].productid WHERE $sql_tbl[customers].login=$sql_tbl[products].provider AND $sql_tbl[customers].activity='Y' AND $sql_tbl[products].productid=$sql_tbl[products_categories].productid AND $forsale_condition AND $sql_tbl[products_categories].categoryid = $sql_tbl[categories].categoryid AND $sql_tbl[categories].categoryid_path LIKE '$path' AND $sql_tbl[categories].avail = 'Y' AND $sql_tbl[product_memberships].productid IS NULL GROUP BY $sql_tbl[products].productid");
				$res_top = db_query("SELECT COUNT(*) FROM $sql_tbl[customers], $sql_tbl[products_categories], $sql_tbl[categories], $sql_tbl[products] LEFT JOIN $sql_tbl[product_memberships] ON $sql_tbl[product_memberships].productid = $sql_tbl[products].productid WHERE $sql_tbl[customers].login=$sql_tbl[products].provider AND $sql_tbl[customers].activity='Y' AND $sql_tbl[products].productid=$sql_tbl[products_categories].productid AND $forsale_condition AND $sql_tbl[products_categories].categoryid = $sql_tbl[categories].categoryid AND $sql_tbl[categories].categoryid = '$c' AND $sql_tbl[product_memberships].productid IS NULL GROUP BY $sql_tbl[products].productid");

			} else {
				$res = db_query("SELECT COUNT(*) FROM $sql_tbl[products_categories], $sql_tbl[categories], $sql_tbl[products] LEFT JOIN $sql_tbl[product_memberships] ON $sql_tbl[product_memberships].productid = $sql_tbl[products].productid WHERE $sql_tbl[products].productid=$sql_tbl[products_categories].productid AND $forsale_condition AND $sql_tbl[products_categories].categoryid = $sql_tbl[categories].categoryid AND $sql_tbl[categories].categoryid_path LIKE '$path' AND $sql_tbl[categories].avail = 'Y' AND $sql_tbl[product_memberships].productid IS NULL GROUP BY $sql_tbl[products].productid");
				$res_top = db_query("SELECT COUNT(*) FROM $sql_tbl[products_categories], $sql_tbl[categories], $sql_tbl[products] LEFT JOIN $sql_tbl[product_memberships] ON $sql_tbl[product_memberships].productid = $sql_tbl[products].productid WHERE $sql_tbl[products].productid=$sql_tbl[products_categories].productid AND $forsale_condition AND $sql_tbl[products_categories].categoryid = $sql_tbl[categories].categoryid AND $sql_tbl[categories].categoryid = '$c' AND $sql_tbl[product_memberships].productid IS NULL GROUP BY $sql_tbl[products].productid");
			}

			$add_product_count = 0;
			$add_top_product_count = 0;
			if ($res && $res_top) {
				$add_top_product_count = db_num_rows($res_top);
				$add_product_count = db_num_rows($res) + $add_top_product_count;;
				db_free_result($res);
			}

			# Get product counters (by mebership levels)
			$product_count_member = array();
			if ($add_product_count != $product_count) {
				$product_count_member = array();
				$top_product_count_member = array();
				if ($single_mode) {
					$res = db_query("SELECT IFNULL($sql_tbl[product_memberships].membershipid, 0) as membershipid, COUNT(*) as cnt FROM $sql_tbl[customers], $sql_tbl[products_categories], $sql_tbl[categories], $sql_tbl[products], $sql_tbl[product_memberships] WHERE $sql_tbl[product_memberships].productid = $sql_tbl[products].productid AND $sql_tbl[customers].login=$sql_tbl[products].provider AND $sql_tbl[customers].activity='Y' AND $sql_tbl[products].productid=$sql_tbl[products_categories].productid AND $forsale_condition AND $sql_tbl[products_categories].categoryid = $sql_tbl[categories].categoryid AND $sql_tbl[categories].categoryid_path LIKE '$path' AND $sql_tbl[categories].avail = 'Y' GROUP BY $sql_tbl[product_memberships].membershipid, $sql_tbl[products].productid");
					$res_top = db_query("SELECT IFNULL($sql_tbl[product_memberships].membershipid, 0) as membershipid, COUNT(*) as cnt FROM $sql_tbl[customers], $sql_tbl[products_categories], $sql_tbl[categories], $sql_tbl[products], $sql_tbl[product_memberships] WHERE $sql_tbl[product_memberships].productid = $sql_tbl[products].productid AND $sql_tbl[customers].login=$sql_tbl[products].provider AND $sql_tbl[customers].activity='Y' AND $sql_tbl[products].productid=$sql_tbl[products_categories].productid AND $forsale_condition AND $sql_tbl[products_categories].categoryid = $sql_tbl[categories].categoryid AND $sql_tbl[categories].categoryid = '$c' GROUP BY $sql_tbl[product_memberships].membershipid, $sql_tbl[products].productid");

				} else {
					$res = db_query("SELECT IFNULL($sql_tbl[product_memberships].membershipid, 0) as membershipid, COUNT(*) as cnt FROM $sql_tbl[products_categories], $sql_tbl[categories], $sql_tbl[products], $sql_tbl[product_memberships] WHERE $sql_tbl[product_memberships].productid = $sql_tbl[products].productid AND $sql_tbl[products].productid=$sql_tbl[products_categories].productid AND $forsale_condition AND $sql_tbl[products_categories].categoryid = $sql_tbl[categories].categoryid AND $sql_tbl[categories].categoryid_path LIKE '$path' AND $sql_tbl[categories].avail = 'Y' GROUP BY $sql_tbl[product_memberships].membershipid, $sql_tbl[products].productid");
					$res_top = db_query("SELECT IFNULL($sql_tbl[product_memberships].membershipid, 0) as membershipid, COUNT(*) as cnt FROM $sql_tbl[products_categories], $sql_tbl[categories], $sql_tbl[products], $sql_tbl[product_memberships] WHERE $sql_tbl[product_memberships].productid = $sql_tbl[products].productid AND $sql_tbl[products].productid=$sql_tbl[products_categories].productid AND $forsale_condition AND $sql_tbl[products_categories].categoryid = $sql_tbl[categories].categoryid AND $sql_tbl[categories].categoryid = '$c' GROUP BY $sql_tbl[product_memberships].membershipid, $sql_tbl[products].productid");
				}

				if ($res && $res_top) {
					while ($row = db_fetch_array($res)) {
						if (!isset($product_count_member[$row['membershipid']]))
							$product_count_member[$row['membershipid']] = 0;

						$product_count_member[$row['membershipid']]++;
					}
					db_free_result($res);

                    while ($row = db_fetch_array($res_top)) {
                        if (!isset($top_product_count_member[$row['membershipid']]))
                            $top_product_count_member[$row['membershipid']] = 0;

                        $top_product_count_member[$row['membershipid']]++;
                    }
                    db_free_result($res);

				}
			}

			foreach ($lvl as $l) {
				$query_data = array(
					"product_count" => $add_product_count,
					"top_product_count" => $add_top_product_count
				);
				if (isset($product_count_member[$l]))
					$query_data['product_count'] += $product_count_member[$l];

                if (isset($top_product_count_member[$l])) {
                    $query_data['product_count'] += $top_product_count_member[$l];
					$query_data['top_product_count'] += $top_product_count_member[$l];
				}

				if (func_query_first_cell("SELECT COUNT(*) FROM $sql_tbl[categories_subcount] WHERE categoryid = '$c' AND membershipid = '$l'") > 0) {
					func_array2update("categories_subcount", $query_data, "categoryid = '$c' AND membershipid = '$l'");

				} else {
					$query_data['categoryid'] = $c;
					$query_data['membershipid'] = $l;
					func_array2insert("categories_subcount", $query_data);
				}
			}
		}

		$cnt++;
		if ($tick > 0 && $cnt % $tick == 0) {
			func_flush(". ");
		}
	}

	db_free_result($categoryid);

	return true;
}

#
# Recalculate child categories count in Categories counts table
#
function func_recalc_subcat_count($categoryid = false, $tick = 0) {
	global $sql_tbl, $config;

	$where = "";
	if ($categoryid !== false) {
		if (empty($categoryid)) {
			return false;

		} elseif (!is_array($categoryid)) {
			$where = "categoryid = '$categoryid'";

		} elseif (is_array($categoryid)) {
			if (is_array(current($categoryid))) {
				foreach ($categoryid as $k => $v) {
					$categoryid[$k] = $v['categoryid'];
				}
			}
			$where = "categoryid IN ('".implode("','", $categoryid)."')";

		}
	}

	$dwhere = '';
	if ($where)
		$dwhere = ' WHERE ' . $where;
	db_query("DELETE FROM $sql_tbl[categories_subcount]" . $dwhere);

	$swhere = '';
	if ($where)
		$swhere = " WHERE $sql_tbl[categories]." . $where;
	$res = db_query("SELECT $sql_tbl[categories].categoryid, $sql_tbl[categories].categoryid_path, IF($sql_tbl[category_memberships].categoryid IS NULL, '', 'Y') as mexists FROM $sql_tbl[categories] LEFT JOIN $sql_tbl[category_memberships] ON $sql_tbl[category_memberships].categoryid = $sql_tbl[categories].categoryid".$swhere." GROUP BY $sql_tbl[categories].categoryid");

	if (!$res)
		return false;

	if ($tick > 0)
		func_display_service_header("lbl_recalc_subcat_count");

	$lvl = func_query_column("SELECT membershipid FROM $sql_tbl[memberships] WHERE area = 'C'");
	$cnt = 0;
	$cat_limit = 100;
	$cat_collector = array();
	while ($c = db_fetch_array($res)) {
		$mexists = $c['mexists'];
		$path = $c['categoryid_path']."/%";
		$c = $c['categoryid'];

		# Category is common
		if (empty($mexists)) {
			$subcat_count = func_query_first_cell("SELECT COUNT(*) FROM $sql_tbl[categories] USE INDEX (pa) WHERE $sql_tbl[categories].categoryid_path LIKE '$path' AND $sql_tbl[categories].avail = 'Y'");
			$query_data = array(
				"categoryid" => $c,
				"subcategory_count" => $subcat_count,
				"membershipid" => 0
			);
			func_array2insert("categories_subcount", $query_data);
			if (!empty($lvl)) {
				foreach ($lvl as $v) {
					$query_data['membershipid'] = $v;
					func_array2insert("categories_subcount", $query_data);
				}
			}

		} elseif (!empty($lvl)) {

			# Category is limited by memberships
			$subcat_count = func_query_hash("SELECT COUNT(*) as subcategory_count, IFNULL($sql_tbl[category_memberships].membershipid, 0) as membershipid FROM $sql_tbl[categories] USE INDEX (pa) LEFT JOIN $sql_tbl[category_memberships] ON $sql_tbl[category_memberships].categoryid = $sql_tbl[categories].categoryid WHERE $sql_tbl[categories].categoryid_path LIKE '$path' AND $sql_tbl[categories].avail = 'Y' GROUP BY $sql_tbl[category_memberships].membershipid", "membershipid", false, true);

			if (!empty($subcat_count)) {
				$zero_count = intval($subcat_count[0]);
				foreach ($lvl as $l) {
					func_array2insert(
						"categories_subcount",
						array(
							"membershipid" => $l,
							"subcategory_count" => (isset($subcat_count[$l]) ? $subcat_count[$l] : 0) + $zero_count,
							"categoryid" => $c
						)
					);
				}
			}
		}

		$cat_collector[] = $c;
		if (count($cat_collector) > $cat_limit) {	
			func_recalc_product_count($cat_collector, $tick);
			$cat_collector = array();
		}

		$cnt++;
		if ($tick > 0 && $cnt % $tick == 0) {
			func_flush(". ");
		}
	}

	db_free_result($res);

	if (!empty($cat_collector))
		func_recalc_product_count($cat_collector, $tick);

	return true;
}

#
# Get a category path consisting of category names on the basis of a category
# path consisting of categoryid's
#
function func_categoryid_path2category_path($categoryid_path) {
	global $sql_tbl;

	$categoryid_path = explode("/", $categoryid_path);
	if (empty($categoryid_path))
		return false;

	$cnt = 1;
	$parentid = 0;
	$where = "";
	foreach ($categoryid_path as $v) {
		$where .= " WHEN categoryid = '$v' AND parentid = '$parentid' THEN ".($cnt++);
		$parentid = $v;
	}

	$data = func_query_column("SELECT category FROM $sql_tbl[categories] WHERE categoryid IN ('".implode("','", $categoryid_path)."') ORDER BY CASE $where ELSE 0 END LIMIT ".count($categoryid_path));
	if (empty($data) || count($data) != count($categoryid_path))
		$data = false;

	return $data;
}

#
# Get parent categories chain
#
function func_get_category_parents($categoryid) {
	global $sql_tbl;

	if (!is_array($categoryid))
		$categoryid = array($categoryid);

	$res = db_query("SELECT categoryid_path FROM $sql_tbl[categories] WHERE categoryid IN ('".implode("','", $categoryid)."')");
	if (!$res)
		return false;

	$cats = array();
	while ($c = db_fetch_row($res)) {
		$cats = array_unique(func_array_merge($cats, explode("/", array_pop($c))));
	}
	db_free_result($res);

	return $cats;
}

#
# Get category's title
#
function func_get_category_title($categoryid, $category = null) {
	global $sql_tbl, $config;

	if (!is_int($categoryid) || $categoryid < 1 || (!is_null($category) && !is_array($category)))
		return false;

	if (!is_array($category) || !isset($category['title_tag']) || !isset($category['categoryid_path']))
		$category = func_query_first("SELECT title_tag, categoryid_path FROM $sql_tbl[categories] WHERE categoryid = '$categoryid'");

	if (!is_array($category) || !isset($category['title_tag']))
		return false;

	$category['title_tag'] = trim($category['title_tag']);

	$parents = array();
	$ids = array();
	if (empty($category['title_tag'])) {
		$ids = array_reverse(explode("/", $category['categoryid_path']));
		array_shift($ids);
		$parents = func_query_hash("SELECT categoryid, title_tag FROM $sql_tbl[categories] WHERE categoryid IN ('".implode("', '", $ids)."') AND override_child_meta = 'Y'", "categoryid", false);

		while ((list(, $cid) = each($ids)) && empty($category['title_tag'])) {
			$parents[$cid]['title_tag'] = trim($parents[$cid]['title_tag']);

			if (empty($category['title_tag']) && !empty($parents[$cid]['title_tag']))
				$category['title_tag'] = $parents[$cid]['title_tag'];
		}
	}

	if (empty($category['title_tag']))
		$category['title_tag'] = trim($config['SEO']['site_title']);

	return $category['title_tag'];
}

#
# Get category's meta description and meta keywords data
#
function func_get_category_meta($categoryid, $category = null) {
	global $sql_tbl, $config;

	if (!is_int($categoryid) || $categoryid < 1 || (!is_null($category) && !is_array($category)))
		return false;

	if (!is_array($category) || !isset($category['meta_description']) || !isset($category['meta_keywords']) || !isset($category['categoryid_path']))
		$category = func_query_first("SELECT meta_description, meta_keywords, categoryid_path FROM $sql_tbl[categories] WHERE categoryid = '$categoryid'");

	if (!is_array($category) || !isset($category['meta_description']))
		return false;

	$category['meta_description'] = trim($category['meta_description']);
	$category['meta_keywords'] = trim($category['meta_keywords']);

	$parents = array();
	$ids = array();
	if (empty($category['meta_description']) || empty($category['meta_keywords'])) {
		$ids = array_reverse(explode("/", $category['categoryid_path']));
		array_shift($ids);
		$parents = func_query_hash("SELECT categoryid, meta_description, meta_keywords FROM $sql_tbl[categories] WHERE categoryid IN ('".implode("', '", $ids)."') AND override_child_meta = 'Y'", "categoryid", false);

		while ((list(,$cid) = each($ids)) && (empty($category['meta_description']) || empty($category['meta_keywords']))) {
			$parents[$cid]['meta_description'] = trim($parents[$cid]['meta_description']);
			$parents[$cid]['meta_keywords'] = trim($parents[$cid]['meta_keywords']);

			if (empty($category['meta_description']) && !empty($parents[$cid]['meta_description']))
				$category['meta_description'] = $parents[$cid]['meta_description'];

            if (empty($category['meta_keywords']) && !empty($parents[$cid]['meta_keywords']))
                $category['meta_keywords'] = $parents[$cid]['meta_keywords'];
		}
	}

	if (empty($category['meta_description']))
		$category['meta_description'] = trim($config['SEO']['meta_descr']);

    if (empty($category['meta_keywords']))
        $category['meta_keywords'] = trim($config['SEO']['meta_keywords']);

	return array($category['meta_description'], $category['meta_keywords']);
}

#
# This function builds the categories list within specified category ($cat)
#
function func_get_categories_list($cat = 0, $short_list = true, $flag = NULL) {
	global $current_area, $sql_tbl, $shop_language, $active_modules, $config;

	$cat = intval($cat);

	$all_categories = array();
	$categories = array();
	$subcategories = array();

	$search_condition = array();
	$sort_condition = "";

	if ($flag == "root")
		$search_condition[] = "$sql_tbl[categories].parentid = '0'";
	elseif ($flag == "level")
		$search_condition[] = "$sql_tbl[categories].parentid = '$cat'";
	elseif ($flag == "current")
		$search_condition[] = "$sql_tbl[categories].parentid IN ('0','$cat')";

	if ($current_area == "C" || $current_area == "B") {
		global $user_account;
		$search_condition[] = "$sql_tbl[categories].avail = 'Y'";
		$search_condition[] = "($sql_tbl[category_memberships].membershipid IS NULL OR $sql_tbl[category_memberships].membershipid = '$user_account[membershipid]')";
		if ($flag == "all")
			$sort_condition = " ORDER BY category";
		else
			$sort_condition = " ORDER BY $sql_tbl[categories].order_by, category";
	} elseif (defined('MANAGE_CATEGORIES')) {
		$sort_condition = " ORDER BY $sql_tbl[categories].order_by, $sql_tbl[categories].category";
	}

	if ($short_list === X_CATEGORIES_FOR_SELECT_BOX) {
		$to_search = "$sql_tbl[categories].categoryid as cid, $sql_tbl[categories].categoryid, $sql_tbl[categories].parentid, $sql_tbl[categories].categoryid_path, $sql_tbl[categories].category";

	} elseif ($short_list) {
		$to_search = "$sql_tbl[categories].categoryid as cid, $sql_tbl[categories].categoryid, $sql_tbl[categories].parentid, $sql_tbl[categories].categoryid_path, $sql_tbl[categories].category, $sql_tbl[categories].avail, $sql_tbl[categories].order_by";

	} else {
		$to_search = "$sql_tbl[categories].categoryid as cid, $sql_tbl[categories].*";
	}

	$join_tbl = '';
	if ($current_area == "C" || $current_area == "B") {
		$join_tbl .= " LEFT JOIN $sql_tbl[categories_lng] USE INDEX (PRIMARY) ON $sql_tbl[categories_lng].code='$shop_language' AND $sql_tbl[categories_lng].categoryid=$sql_tbl[categories].categoryid ";
		$join_tbl .= " LEFT JOIN $sql_tbl[category_memberships] ON $sql_tbl[category_memberships].categoryid = $sql_tbl[categories].categoryid ";
		$to_search .= ", IF($sql_tbl[categories_lng].categoryid IS NOT NULL AND $sql_tbl[categories_lng].category != '', $sql_tbl[categories_lng].category, $sql_tbl[categories].category) as category";
	}

	#
	# Count the subcategories for "root" and "level" flag values
	#
	if ($flag == "level" || $flag == "root" || $flag == "current" || is_null($flag)) {
		if ($current_area == "C" || $current_area == "B") {
			$join_tbl .= " LEFT JOIN $sql_tbl[categories_subcount] USE INDEX (PRIMARY) ON $sql_tbl[categories_subcount].categoryid = $sql_tbl[categories].categoryid AND $sql_tbl[categories_subcount].membershipid = '$user_account[membershipid]' ";
			$to_search .= ", $sql_tbl[categories_subcount].subcategory_count, $sql_tbl[categories_subcount].product_count";

			if (!empty($active_modules['Flyout_Menus']))
				$to_search .= ", $sql_tbl[categories_subcount].top_product_count";

		} else {
			$join_tbl .= " LEFT JOIN $sql_tbl[categories_subcount] USE INDEX (PRIMARY) ON $sql_tbl[categories_subcount].categoryid = $sql_tbl[categories].categoryid ";
			$to_search .= ", MAX($sql_tbl[categories_subcount].subcategory_count) as subcategory_count, MAX($sql_tbl[categories_subcount].product_count) as product_count";
		}

	} elseif ($short_list) {
		$to_search .= ",$sql_tbl[categories].product_count";
	}

	#
	# Check category icons
	#
	if ($flag == "level" || $flag == "root" || $flag == "current" || is_null($flag)) {
		$to_search .= ", $sql_tbl[images_C].image_path, $sql_tbl[images_C].image_x, $sql_tbl[images_C].image_y, $sql_tbl[images_C].imageid";
		$join_tbl .= " LEFT JOIN $sql_tbl[images_C] ON $sql_tbl[categories].categoryid = $sql_tbl[images_C].id ";
	}

	if (defined('NEED_PRODUCT_CATEGORIES')) {
		global $productid;
		$all_categories = func_query_hash("SELECT $to_search, $sql_tbl[products_categories].productid, $sql_tbl[products_categories].main FROM $sql_tbl[categories] $join_tbl LEFT JOIN $sql_tbl[products_categories] ON $sql_tbl[categories].categoryid=$sql_tbl[products_categories].categoryid AND $sql_tbl[products_categories].productid='$productid' AND $sql_tbl[products_categories].main != 'Y' GROUP BY $sql_tbl[categories].categoryid", "cid", false);
	} else {
		$all_categories = func_query_hash("SELECT $to_search FROM $sql_tbl[categories] USE INDEX (avail) $join_tbl ".(!empty($search_condition) ? "WHERE ".implode(" AND ", $search_condition) : "").(strlen($join_tbl) > 0 ? " GROUP BY $sql_tbl[categories].categoryid" : "")." ".$sort_condition, "cid", false);
	}

	if (!is_array($all_categories) || empty($all_categories))
		return array("all_categories" => array(), "categories" => array(), "subcategories" => array());

	foreach ($all_categories as $k => $category) {
		#
		# Get the full path for category name
		#
		if ($flag == "all" || is_null($flag)) {
			$category["category_path"] = array();
			foreach (explode("/", $category["categoryid_path"]) as $i => $catid) {
				if (isset($all_categories[$catid]))
					$category["category_path"][] = $all_categories[$catid]['category'];
			}
			if (count($category["category_path"]) - 1 != $i) {
				unset($all_categories[$k]);
				continue;
			}

			$category["category_path"] = implode("/", $category["category_path"]);
		}

		$category['is_icon'] = !is_null($category["image_path"]);
		$category["icon_url"] = func_get_image_url($k, 'C', $category["image_path"]);
		$category_level = count(explode("/" ,$category["categoryid_path"]));
		if ($category['is_icon'] && !empty($active_modules['Flyout_Menus']) && 
			$config['Flyout_Menus']['icons_mode'] == 'E' &&
			$config['Flyout_Menus']['icons_icons_in_categories'] >= $category_level 
		) {
			$thumb_url = func_image_cache_get_image("C", "catthumbn", $category["imageid"]);
			if (!empty($thumb_url)) {
				$category["thumb_url"] = $thumb_url["url"];
				$category["thumb_x"] = $thumb_url["width"];
				$category["thumb_y"] = $thumb_url["height"];
				unset($thumb_url);
			}
		}

		if (($flag == "root" || $flag == "current" || is_null($flag)) && $category["parentid"] == 0)
			$categories[$k] = $category;

		if (($flag == "level" || $flag == "current" || is_null($flag)) && $category["parentid"] == $cat)
			$subcategories[$k] = $category;

		if ($short_list === X_CATEGORIES_FOR_SELECT_BOX) {
			func_unset($category, 'parentid', 'categoryid_path', 'is_icon', 'icon_url', 'subcategory_count', 'product_count');
		}

		$all_categories[$k] = $category;
	}

	if ($short_list === X_CATEGORIES_FOR_SELECT_BOX) {
		if (!function_exists("func_categories_sb_filter")) {
			function func_categories_sb_filter($v) {
				unset($v['category']);
				return $v;
			}
		}
		$all_categories = array_map("func_categories_sb_filter", $all_categories);
	}

	if (($flag == "all" || is_null($flag)) && !empty($all_categories) && (($current_area != "C" && $current_area != "B") || empty($active_modules["Flyout_Menus"]))) {
		if (!function_exists("func_categories_sort")) {
			function func_categories_sort($a, $b) {
				return strcmp($a["category_path"], $b["category_path"]);
			}
		}
		uasort($all_categories, "func_categories_sort");
	}

	return array("all_categories" => $all_categories, "categories" => $categories, "subcategories" => $subcategories);
}

#
# This function gathering the current category data
#
function func_get_category_data($cat) {
	global $current_area, $sql_tbl, $shop_language, $user_account, $current_location, $config;

	$cat = intval($cat);

	$join_tbl = " LEFT JOIN $sql_tbl[images_C] ON $sql_tbl[images_C].id = $sql_tbl[categories].categoryid LEFT JOIN $sql_tbl[categories_subcount] ON $sql_tbl[categories_subcount].categoryid = $sql_tbl[categories].categoryid".(($current_area == "C" || $current_area == "B")?" AND $sql_tbl[categories_subcount].membershipid = '".@$user_account['membershipid']."'":"")." LEFT JOIN $sql_tbl[category_memberships] ON $sql_tbl[category_memberships].categoryid = $sql_tbl[categories].categoryid ";
	$to_search = ", $sql_tbl[categories].category, $sql_tbl[images_C].image_path, $sql_tbl[images_C].image_x, $sql_tbl[images_C].image_y";
	if ($current_area == "C" || $current_area == "B") {
		$to_search .= ", $sql_tbl[categories_subcount].subcategory_count";
	} else {
		$to_search .= ", MAX($sql_tbl[categories_subcount].subcategory_count) as subcategory_count";
	}

	$search_condition = "";
	if ($current_area == "C" || $current_area == "B") {
		$join_tbl .= " LEFT JOIN $sql_tbl[categories_lng] ON $sql_tbl[categories_lng].code='$shop_language' AND $sql_tbl[categories_lng].categoryid=$sql_tbl[categories].categoryid ";
		$to_search .= ", IF(($sql_tbl[categories_lng].category IS NOT NULL AND $sql_tbl[categories_lng].category != ''), $sql_tbl[categories_lng].category, $sql_tbl[categories].category) as category, IF(($sql_tbl[categories_lng].description IS NOT NULL AND $sql_tbl[categories_lng].description != ''), $sql_tbl[categories_lng].description, $sql_tbl[categories].description) as description, $sql_tbl[categories].category as category_name_orig";
		$search_condition = "AND $sql_tbl[categories].avail='Y' AND ($sql_tbl[category_memberships].membershipid = '".$user_account["membershipid"]."' OR $sql_tbl[category_memberships].membershipid IS NULL)";
	}

	$join_tbl .= " LEFT JOIN $sql_tbl[clean_urls] ON resource_type = 'C' AND resource_id = '$cat'";
	$to_search .= ", $sql_tbl[clean_urls].clean_url, $sql_tbl[clean_urls].mtime";

	$category = func_query_first("SELECT $sql_tbl[categories].* $to_search FROM $sql_tbl[categories] $join_tbl WHERE $sql_tbl[categories].categoryid='$cat' $search_condition".(strlen($join_tbl) > 0 ? "GROUP BY $sql_tbl[categories].categoryid " : "")."LIMIT 1");

	if (!empty($category)) {

		$tmp = func_query("SELECT membershipid FROM $sql_tbl[category_memberships] WHERE categoryid = '$cat'");
		if (!empty($tmp)) {
			$category['membershipids'] = array();
			foreach ($tmp as $v) {
				$category['membershipids'][$v['membershipid']] = 'Y';
			}
		}

		#
		# Get the array of all parent categories
		#
		$_cat_sequense = explode("/", $category["categoryid_path"]);

		#
		# Generate category sequence, i.e.
		# Books, Books/Poetry, Books/Poetry/Philosophy ...
		#
		if(!empty($_cat_sequense)) {
			$search_condition_2 = "";
			if ($current_area == "C" || $current_area == "B") {
				$search_condition_2 = " AND $sql_tbl[categories].avail = 'Y'";
			}

			$_cat_names = func_query_hash("SELECT $sql_tbl[categories].categoryid $to_search FROM $sql_tbl[categories] $join_tbl WHERE $sql_tbl[categories].categoryid IN ('".implode("','", $_cat_sequense)."')".$search_condition_2.(strlen($join_tbl) > 0 ? " GROUP BY $sql_tbl[categories].categoryid" : ""), "categoryid", false);
			if(count($_cat_names) != count($_cat_sequense))
				return false;

			foreach ($_cat_sequense as $_catid) {
				$_cat_name = $_cat_names[$_catid];
				$category["category_location"][] = array($_cat_name["category"], "home.php?cat=$_catid");
				if (is_null($category['image_path']) && !is_null($_cat_name['image_path'])) {
					$category['image_path'] = $_cat_name['image_path'];
					$category['image_x'] = $_cat_name['image_x'];
					$category['image_y'] = $_cat_name['image_y'];
				}
			}
		}

		$category['is_icon'] = !is_null($category["image_path"]);
		$category["icon_url"] = func_get_image_url($category['categoryid'], 'C', $category["image_path"]);

		if ($current_area == "C" || $current_area == "B") {
			if ($category["description"] == strip_tags($category["description"])) {
				$category["description"] = str_replace("\n", "<br />", $category["description"]);
			}
		}

		$category['clean_urls_history'] = func_query_hash("SELECT id, clean_url FROM $sql_tbl[clean_urls_history] WHERE resource_type = 'C' AND resource_id = '$cat' ORDER BY mtime DESC", "id", false, true);

		return $category;
	}

	return false;
}

?>
