<?php
/*****************************************************************************\
+-----------------------------------------------------------------------------+
| X-Cart                                                                      |
| Copyright (c) 2001-2010 Ruslan R. Fazlyev <rrf@x-cart.com>                  |
| All rights reserved.                                                        |
+-----------------------------------------------------------------------------+
| PLEASE READ  THE FULL TEXT OF SOFTWARE LICENSE AGREEMENT IN THE "COPYRIGHT" |
| FILE PROVIDED WITH THIS DISTRIBUTION. THE AGREEMENT TEXT IS ALSO AVAILABLE  |
| AT THE FOLLOWING URL: http://www.x-cart.com/license.php                     |
|                                                                             |
| THIS  AGREEMENT  EXPRESSES  THE  TERMS  AND CONDITIONS ON WHICH YOU MAY USE |
| THIS SOFTWARE   PROGRAM   AND  ASSOCIATED  DOCUMENTATION   THAT  RUSLAN  R. |
| FAZLYEV (hereinafter  referred to as "THE AUTHOR") IS FURNISHING  OR MAKING |
| AVAILABLE TO YOU WITH  THIS  AGREEMENT  (COLLECTIVELY,  THE  "SOFTWARE").   |
| PLEASE   REVIEW   THE  TERMS  AND   CONDITIONS  OF  THIS  LICENSE AGREEMENT |
| CAREFULLY   BEFORE   INSTALLING   OR  USING  THE  SOFTWARE.  BY INSTALLING, |
| COPYING   OR   OTHERWISE   USING   THE   SOFTWARE,  YOU  AND  YOUR  COMPANY |
| (COLLECTIVELY,  "YOU")  ARE  ACCEPTING  AND AGREEING  TO  THE TERMS OF THIS |
| LICENSE   AGREEMENT.   IF  YOU    ARE  NOT  WILLING   TO  BE  BOUND BY THIS |
| AGREEMENT, DO  NOT INSTALL OR USE THE SOFTWARE.  VARIOUS   COPYRIGHTS   AND |
| OTHER   INTELLECTUAL   PROPERTY   RIGHTS    PROTECT   THE   SOFTWARE.  THIS |
| AGREEMENT IS A LICENSE AGREEMENT THAT GIVES  YOU  LIMITED  RIGHTS   TO  USE |
| THE  SOFTWARE   AND  NOT  AN  AGREEMENT  FOR SALE OR FOR  TRANSFER OF TITLE.|
| THE AUTHOR RETAINS ALL RIGHTS NOT EXPRESSLY GRANTED BY THIS AGREEMENT.      |
|                                                                             |
| The Initial Developer of the Original Code is Ruslan R. Fazlyev             |
| Portions created by Ruslan R. Fazlyev are Copyright (C) 2001-2010           |
| Ruslan R. Fazlyev. All Rights Reserved.                                     |
+-----------------------------------------------------------------------------+
\*****************************************************************************/

#
# $Id: func.export.php,v 1.10.2.3 2010/01/21 09:20:35 ferz Exp $
#

if ( !defined('XCART_START') ) { header("Location: ../"); die("Access denied"); }

#
# Save export range
#
function func_export_range_save($section, $data) {
	global $sql_tbl, $export_ranges, $login;

	if (empty($data))
		return false;

	$section = strtoupper($section);
	if (is_string($data)) {
		$export_ranges[$section] = $data;
		db_query("DELETE FROM $sql_tbl[export_ranges] WHERE sec = '".addslashes($section)."' AND login='$login'");
	}
	elseif (is_array($data)) {
		func_unset($export_ranges, $section);
		db_query("DELETE FROM $sql_tbl[export_ranges] WHERE sec = '".addslashes($section)."' AND login='$login'");
		foreach ($data as $v) {
			func_array2insert("export_ranges", array("sec" => addslashes($section), "id" => $v, "login" => $login), true);
		}
	}
	else {
		return false;
	}

	return true;
}

# Get export range
function func_export_range_get($section) {
	global $sql_tbl, $export_ranges, $login;

	$type = func_export_range_type($section);
	if ($type == 'S') {
		return $export_ranges[$section];

	} elseif ($type == 'C') {
		#
		# Use numeric sorting for ORDERS ORDER_ITEMS PRODUCTS keys
		#
		if (in_array($section, array('ORDERS','ORDER_ITEMS','PRODUCTS')))
			return "SELECT (id+0) as id FROM $sql_tbl[export_ranges] WHERE sec = '".addslashes($section)."' AND login='$login' ORDER BY id";
		else
			return "SELECT id FROM $sql_tbl[export_ranges] WHERE sec = '".addslashes($section)."' AND login='$login' ORDER BY id";
	}

	return false;
}

#
# Get export range type
#
function func_export_range_type($section) {
	global $sql_tbl, $export_ranges, $login;

	$section = strtoupper($section);
	if (is_array($export_ranges) && isset($export_ranges[$section])) {
		return "S";
	}
	else {
		if (func_query_column("SELECT id FROM $sql_tbl[export_ranges] WHERE sec = '".addslashes($section)."' AND login='$login' ORDER BY id"))
			return "C";
	}
	return false;
}

#
# Get parent section with not empty export range
#
function func_export_range_detect($section, $last_range = "") {
	global $sql_tbl, $import_specification;

	$section = strtoupper($section);
	if (func_export_range_get_num($section) !== false)
		$last_range = $section;

	if (!empty($import_specification[$section]['parent']))
		return func_export_range_detect($import_specification[$section]['parent'], $last_range);

	return $last_range;
}

#
# Get count of export range
#
function func_export_range_get_num($section) {
	$tmp = func_export_range_get($section);
	if ($tmp === false)
		return false;

	if (is_string($tmp) && !zerolen($tmp)) {
		$res = db_query($tmp);
		if ($res) {
			$tmp = db_num_rows($res);
			db_free_result($res);

			return $tmp;
		}

		return 0;
	}

	return false;
}

# Erase export range
function func_export_range_erase($section, $id = false) {
	global $sql_tbl, $export_ranges, $login;

	func_unset($export_ranges, $section);
	db_query("DELETE FROM $sql_tbl[export_ranges] WHERE sec = '".addslashes($section)."' AND login='".$login."'".(($id !== false) ? " AND id = '".$id."'" : ""));

	return true;
}

?>
