<?php
/*****************************************************************************\
+-----------------------------------------------------------------------------+
| X-Cart                                                                      |
| Copyright (c) 2001-2010 Ruslan R. Fazlyev <rrf@x-cart.com>                  |
| All rights reserved.                                                        |
+-----------------------------------------------------------------------------+
| PLEASE READ  THE FULL TEXT OF SOFTWARE LICENSE AGREEMENT IN THE "COPYRIGHT" |
| FILE PROVIDED WITH THIS DISTRIBUTION. THE AGREEMENT TEXT IS ALSO AVAILABLE  |
| AT THE FOLLOWING URL: http://www.x-cart.com/license.php                     |
|                                                                             |
| THIS  AGREEMENT  EXPRESSES  THE  TERMS  AND CONDITIONS ON WHICH YOU MAY USE |
| THIS SOFTWARE   PROGRAM   AND  ASSOCIATED  DOCUMENTATION   THAT  RUSLAN  R. |
| FAZLYEV (hereinafter  referred to as "THE AUTHOR") IS FURNISHING  OR MAKING |
| AVAILABLE TO YOU WITH  THIS  AGREEMENT  (COLLECTIVELY,  THE  "SOFTWARE").   |
| PLEASE   REVIEW   THE  TERMS  AND   CONDITIONS  OF  THIS  LICENSE AGREEMENT |
| CAREFULLY   BEFORE   INSTALLING   OR  USING  THE  SOFTWARE.  BY INSTALLING, |
| COPYING   OR   OTHERWISE   USING   THE   SOFTWARE,  YOU  AND  YOUR  COMPANY |
| (COLLECTIVELY,  "YOU")  ARE  ACCEPTING  AND AGREEING  TO  THE TERMS OF THIS |
| LICENSE   AGREEMENT.   IF  YOU    ARE  NOT  WILLING   TO  BE  BOUND BY THIS |
| AGREEMENT, DO  NOT INSTALL OR USE THE SOFTWARE.  VARIOUS   COPYRIGHTS   AND |
| OTHER   INTELLECTUAL   PROPERTY   RIGHTS    PROTECT   THE   SOFTWARE.  THIS |
| AGREEMENT IS A LICENSE AGREEMENT THAT GIVES  YOU  LIMITED  RIGHTS   TO  USE |
| THE  SOFTWARE   AND  NOT  AN  AGREEMENT  FOR SALE OR FOR  TRANSFER OF TITLE.|
| THE AUTHOR RETAINS ALL RIGHTS NOT EXPRESSLY GRANTED BY THIS AGREEMENT.      |
|                                                                             |
| The Initial Developer of the Original Code is Ruslan R. Fazlyev             |
| Portions created by Ruslan R. Fazlyev are Copyright (C) 2001-2010           |
| Ruslan R. Fazlyev. All Rights Reserved.                                     |
+-----------------------------------------------------------------------------+
\*****************************************************************************/

#
# $Id: func.import.php,v 1.9.2.4 2010/01/21 09:20:35 ferz Exp $
#

if ( !defined('XCART_START') ) { header("Location: ../"); die("Access denied"); }

#
# Detect product by productid / productcode / product name
# Output: array
#		productid
#		variantid (if Product Options module is enabled)
#
function func_import_detect_product($values, $use_provider = true) {
	global $action, $active_modules, $sql_tbl, $import_data_provider, $single_mode, $import_file;

	$provider_condition = "";
	if (!$use_provider && !$single_mode && !empty($import_data_provider))
		$provider_condition = " AND $sql_tbl[products].provider='".$import_data_provider."'";

	$values_exists = 0;
	$values_not_added = 0;

	$_productid = $_variantid = NULL;
	if (!empty($values['productid'])) {
		$values_exists++;
		$_productid = func_import_get_cache("PI", $values["productid"]);
		if (is_null($_productid) || ($action == "do" && empty($_productid))) {
			$values_not_added++;
			$_productid = func_query_first_cell("SELECT productid FROM $sql_tbl[products] WHERE productid = '$values[productid]'".$provider_condition);
			if (!empty($_productid))
				func_import_save_cache("PI", $values["productid"], $_productid);
		}
		unset($values['productid']);
	}
	if (!empty($values['productcode']) && (is_null($_productid) || ($action == "do" && empty($_productid)))) {
		$values_exists++;
		$_productid = func_import_get_cache("PR", $values["productcode"]);
		if (is_null($_productid) || ($action == "do" && empty($_productid))) {
			$values_not_added++;
			$_productid = func_query_first_cell("SELECT productid FROM $sql_tbl[products] WHERE productcode = '".addslashes($values['productcode'])."'".$provider_condition);
			if (!empty($_productid))
				func_import_save_cache("PR", $values["productcode"], $_productid);
		}
		if ((is_null($_productid) || ($action == "do" && empty($_productid))) && !empty($active_modules['Product_Options'])) {
			$tmp = func_query_first("SELECT $sql_tbl[variants].variantid, $sql_tbl[products].productid FROM $sql_tbl[products], $sql_tbl[variants] WHERE $sql_tbl[products].productid = $sql_tbl[variants].productid AND $sql_tbl[variants].productcode = '".addslashes($values['productcode'])."'".$provider_condition);
			if (!empty($tmp)) {
				$_productid = $tmp['productid'];
				$_variantid = $tmp['variantid'];
			}
		}
		unset($values['productcode']);
	}
	if (!empty($values['product']) && (is_null($_productid) || ($action == "do" && empty($_productid)))) {
		$values_exists++;
		$_productid = func_import_get_cache("PN", $values["product"]);
		if (is_null($_productid) || ($action == "do" && empty($_productid))) {
			$values_not_added++;
			$_productid = func_query_first_cell("SELECT productid FROM $sql_tbl[products] WHERE product = '".addslashes($values['product'])."'".$provider_condition);
			if (!empty($_productid))
				func_import_save_cache("PN", $values["product"], $_productid);
		}
		unset($values['product']);
	}

	# Check: product MUST be added if section PRODUCTS will be droped
	if ($values_exists == $values_not_added && $import_file["drop"]["products"] == 'Y')
		func_import_module_error("msg_err_import_log_message_14");

	return array($_productid, $_variantid);
}

#
# Get standart product signature (productid / productcode / product)
#
function func_export_get_product($productid) {
	global $sql_tbl, $provider_sql;

	return func_query_first("SELECT productid, productcode, product FROM $sql_tbl[products] WHERE productid = '$productid'".(empty($provider_sql) ? "" : " AND $sql_tbl[products].provider = '$provider_sql'"));
}

#
# Get cell from import cache (product signature based)
#
function func_import_get_pb_cache($values, $type, $add_key = "", $force_save = false) {
	if (empty($type) || (empty($values['productid']) && empty($values['productcode']) && empty($values['product'])))
		return NULL;

	$key = "";
	if (!empty($add_key))
		$key = "\n".$add_key;


	list($_productid, $_variantid) = func_import_detect_product($values);

	$id = NULL;
	$do_force_save = false;
	if (!empty($values['productid'])) {
		$id = func_import_get_cache($type."i", $values['productid'].$key);
		if (is_null($id) && $force_save)
			$do_force_save = true;

		if (!is_null($id) && empty($id)) {
			list($_productid, $_variantid) = func_import_detect_product($values);
			if (!empty($_productid) && $values['productid'] != $_productid)
				$id = func_import_get_cache($type."i", $_productid.$key);
		}

	} elseif (!empty($values['productcode']) && (is_null($id) || $force_save)) {
		$id = func_import_get_cache($type."s", $values['productcode'].$key);
		if (is_null($id) && $force_save)
			$do_force_save = true;

	} elseif (!empty($values['product']) && (is_null($id) || $force_save)) {
		$id = func_import_get_cache($type."n", $values['product'].$key);
		if (is_null($id) && $force_save)
			$do_force_save = true;
	}

	if ($do_force_save)
		func_import_save_pb_cache($values, $type, $add_key, '');

	return $id;
}

#
# Save data to import cache (product signature based)
#
function func_import_save_pb_cache($values, $type, $add_key = NULL, $value, $force_save = false) {
	if (empty($type) || (empty($values['productid']) && empty($values['productcode']) && empty($values['product'])))
	return NULL;

	$key = "";
	if (!empty($add_key))
		$key = "\n".$add_key;

    if (!empty($values['productid'])) {
        func_import_save_cache($type."i", $values['productid'].$key, $value, $force_save);
    }
    if (!empty($values['productcode'])) {
        func_import_save_cache($type."s", $values['productcode'].$key, $value, $force_save);
    }
    if (!empty($values['product'])) {
        func_import_save_cache($type."n", $values['product'].$key, $value, $force_save);
    }
    return true;
}

function func_import_rebuild_product($productid) {
	func_build_quick_flags($productid);
	func_build_quick_prices($productid);
}

function func_import_detect_category($values) {
	global $action, $active_modules, $sql_tbl, $import_file;

	$values_exists = 0;
	$values_not_added = 0;
	$_categoryid = NULL;
	if (!empty($values['categoryid'])) {
		$values_exists++;
		$tmp = func_import_get_cache("CI", $values["categoryid"]);
		if (is_null($tmp) || ($action == "do" && empty($tmp))) {
			$values_not_added++;
			$c = func_query_first("SELECT categoryid, categoryid_path, category FROM $sql_tbl[categories] WHERE categoryid = '$values[categoryid]'");
			if (!empty($c)) {
				$_categoryid = $c['categoryid'];
				$ids = explode("/", $c['categoryid_path']);
				if (count($ids) == 1) {
					$cname = $c['category'];
				} else {
					$where = array();
					$orderby = "CASE categoryid ";
					for ($x = 0; $x < count($ids); $x++) {
						$where[] = "(categoryid = '".$ids[$x]."' AND parentid = '".(($x == 0) ? 0 : $ids[$x-1])."')";
						$orderby .= "WHEN ".$ids[$x]." THEN ".$x." ";
					}
					$orderby .= "END";
					$ids = func_query_column("SELECT category FROM $sql_tbl[categories] WHERE ".implode(" OR ", $where)." ORDER BY ".$orderby);
					$cname = implode($import_file['category_sep'], $ids);
				}
				if (!empty($cname) && !empty($_categoryid))
					func_import_save_cache("CI", $values["categoryid"], $cname);
			}
		} else {
			$_categoryid = $values["categoryid"];
		}
		unset($values['categoryid']);
	}
	if (!empty($values['category']) && (is_null($_categoryid) || ($action == "do" && empty($_categoryid)))) {
		$values_exists++;
		$_categoryid = func_import_get_cache("C", $values["category"]);
		if (is_null($_categoryid) || ($action == "do" && empty($_categoryid))) {
			$ids = explode($import_file['category_sep'], $values['category']);
			$_parentid = 0;
			for ($x = 0; $x < count($ids); $x++) {
				$_categoryid = func_query_first_cell("SELECT categoryid FROM $sql_tbl[categories] WHERE category = '".addslashes($ids[$x])."' AND parentid = '$_parentid'");
				if (empty($_categoryid))
					break;
				$_parentid = $_categoryid;
			}
			if (!empty($_categoryid))
				func_import_save_cache("C", $values["category"], $_categoryid);
		}
		unset($values['category']);
	}

    # Check: category MUST be added if section CATEGORIES will be droped
    if ($values_exists == $values_not_added && $import_file["drop"]["categories"] == 'Y')
        func_import_module_error("msg_err_import_log_message_18");

	return $_categoryid;
}

#
# Get standart category signature (categoryid / category)
#
function func_export_get_category($categoryid) {
	global $sql_tbl, $export_data;

	$cat = func_query_first("SELECT categoryid, categoryid_path FROM $sql_tbl[categories] WHERE categoryid = '$categoryid'");
	if (empty($cat))
		return false;

	$tmp = func_categoryid_path2category_path($cat['categoryid_path']);
	$cat['category'] = (empty($tmp) ? "" : implode($export_data['options']['category_sep'], $tmp));
	func_unset($cat, "categoryid_path");

	return $cat;
}

# Check uniqueness of clean URL in a CSV file.
function func_import_check_clean_url_uniqueness() {
	global $values, $action;

	if (!isset($values['clean_url']) || zerolen($values['clean_url'])) {
		return true;
	}

	$tmp = func_import_get_cache("CIU", $values['clean_url']);
	if (is_null($tmp)) {
		$check_result = true;
		func_import_save_cache("CIU", $values['clean_url']);
	} elseif ($tmp === false && $action == 'check') {
		# Clean URL is a unique value and can not be used by several entries in a CSV file.
		$check_result = false;
		func_import_module_error("msg_err_import_log_message_54");
		unset($values['clean_url']);
	}

	return $check_result;
}

#
# Get category_sep which is not used in category names
#
function func_import_get_category_sep($category_sep_local = '/') {
	global $mode, $action, $REQUEST_METHOD, $sql_tbl, $continue;

	if ($REQUEST_METHOD != 'GET')
		return $category_sep_local;

	$possible_category_seps = array('/','|','||','|||','#','##','###','|-|','--','@','@@','@@@','!!','!!!','$$','$$$','^^','!^^!','++','==','===','!==!','=!!=','||-||','=|-|=');

	$category_sep = empty($category_sep_local) ? '/': $category_sep_local;
	$i = 0;
	while (func_query_first_cell("SELECT COUNT(*) FROM $sql_tbl[categories] WHERE category LIKE '%".addslashes($category_sep)."%'") && $i < count($possible_category_seps)) 
		$category_sep = $possible_category_seps[++$i];

	return $category_sep;
}

#
# Check if there are some categories with category_sep in the name
#
function func_check_category_sep($category_sep_local) {
	global $top_message, $sql_tbl, $HTTP_REFERER, $mode;

	$category_sep_local = empty($category_sep_local) ? "/" : $category_sep_local;
	$bad_cat_names = func_query_column("SELECT CONCAT('<a href=\"category_modify.php?cat=', categoryid, '\">', category, '</a>') as
g FROM $sql_tbl[categories] WHERE category LIKE '%$category_sep_local%' LIMIT 10");
	if (!empty($bad_cat_names)) {
		$top_message["content"] = func_get_langvar_by_name("msg_err_import_category_sep", array("cats"=>implode('<br />', $bad_cat_names)), false, true);
		$top_message["type"] = "E";

		$redirect_to = 'import.php';
		if ($mode == 'import' || empty($mode))
			$redirect_to .= '?mode=import&open_options=Y';
		elseif ($mode == 'export')	
			$redirect_to .= '?mode=export';

		func_header_location($redirect_to);
	}

	return true;
}
?>
