<?php
/*****************************************************************************\
+-----------------------------------------------------------------------------+
| X-Cart                                                                      |
| Copyright (c) 2001-2010 Ruslan R. Fazlyev <rrf@x-cart.com>                  |
| All rights reserved.                                                        |
+-----------------------------------------------------------------------------+
| PLEASE READ  THE FULL TEXT OF SOFTWARE LICENSE AGREEMENT IN THE "COPYRIGHT" |
| FILE PROVIDED WITH THIS DISTRIBUTION. THE AGREEMENT TEXT IS ALSO AVAILABLE  |
| AT THE FOLLOWING URL: http://www.x-cart.com/license.php                     |
|                                                                             |
| THIS  AGREEMENT  EXPRESSES  THE  TERMS  AND CONDITIONS ON WHICH YOU MAY USE |
| THIS SOFTWARE   PROGRAM   AND  ASSOCIATED  DOCUMENTATION   THAT  RUSLAN  R. |
| FAZLYEV (hereinafter  referred to as "THE AUTHOR") IS FURNISHING  OR MAKING |
| AVAILABLE TO YOU WITH  THIS  AGREEMENT  (COLLECTIVELY,  THE  "SOFTWARE").   |
| PLEASE   REVIEW   THE  TERMS  AND   CONDITIONS  OF  THIS  LICENSE AGREEMENT |
| CAREFULLY   BEFORE   INSTALLING   OR  USING  THE  SOFTWARE.  BY INSTALLING, |
| COPYING   OR   OTHERWISE   USING   THE   SOFTWARE,  YOU  AND  YOUR  COMPANY |
| (COLLECTIVELY,  "YOU")  ARE  ACCEPTING  AND AGREEING  TO  THE TERMS OF THIS |
| LICENSE   AGREEMENT.   IF  YOU    ARE  NOT  WILLING   TO  BE  BOUND BY THIS |
| AGREEMENT, DO  NOT INSTALL OR USE THE SOFTWARE.  VARIOUS   COPYRIGHTS   AND |
| OTHER   INTELLECTUAL   PROPERTY   RIGHTS    PROTECT   THE   SOFTWARE.  THIS |
| AGREEMENT IS A LICENSE AGREEMENT THAT GIVES  YOU  LIMITED  RIGHTS   TO  USE |
| THE  SOFTWARE   AND  NOT  AN  AGREEMENT  FOR SALE OR FOR  TRANSFER OF TITLE.|
| THE AUTHOR RETAINS ALL RIGHTS NOT EXPRESSLY GRANTED BY THIS AGREEMENT.      |
|                                                                             |
| The Initial Developer of the Original Code is Ruslan R. Fazlyev             |
| Portions created by Ruslan R. Fazlyev are Copyright (C) 2001-2010           |
| Ruslan R. Fazlyev. All Rights Reserved.                                     |
+-----------------------------------------------------------------------------+
\*****************************************************************************/

#
# $Id: func.user.php,v 1.56.2.7 2010/03/26 08:18:24 aim Exp $
#

if ( !defined('XCART_START') ) { header("Location: ../"); die("Access denied"); }

#
# Delete profile from customers table + all associated information
#
function func_delete_profile($user, $usertype, $is_redirect = true, $not_in_list = true, $next_provider = false) {
	global $files_dir_name, $single_mode, $sql_tbl;
	global $active_modules, $xcart_dir;

	x_load('files','product');

	if (($usertype == "A" || (!empty($active_modules["Simple_Mode"]) && $usertype == "P")) && $not_in_list) {
		$flag = func_query_first_cell("SELECT flag FROM $sql_tbl[customers] LEFT JOIN $sql_tbl[memberships] ON $sql_tbl[customers].membershipid = $sql_tbl[memberships].membershipid WHERE $sql_tbl[customers].usertype='$usertype' AND $sql_tbl[customers].login = '$user'");
		$flag_condition = ($flag == "") ? "(flag IS NULL)" : "(flag='$flag')";
		$users_count = func_query_first_cell("SELECT COUNT(*) FROM $sql_tbl[customers] LEFT JOIN $sql_tbl[memberships] ON $sql_tbl[customers].membershipid = $sql_tbl[memberships].membershipid WHERE $sql_tbl[customers].usertype='$usertype' AND $flag_condition AND $sql_tbl[customers].status = 'Y' AND $sql_tbl[customers].activity = 'Y'");

		if ($users_count == 1) {
			if ($is_redirect)
				func_header_location("error_message.php?last_admin");
			return false;
		}
	}

	if ($usertype=="P" && !$single_mode) {
		# If user is provider delete some associated info to keep DB integrity
		# Delete products
		#
		$products = func_query("SELECT productid FROM $sql_tbl[products] WHERE provider='$user'");
		if (!empty($products)) {
			foreach($products as $product)
				func_delete_product($product["productid"]);
		}

		#
		# Delete Shipping, Discounts, Coupons, States/Tax, Countries/Tax
		#
		db_query("DELETE FROM $sql_tbl[shipping_rates] where provider='$user'");
		db_query("DELETE FROM $sql_tbl[discounts] where provider='$user'");
		db_query("DELETE FROM $sql_tbl[discount_coupons] where provider='$user'");
		db_query("DELETE FROM $sql_tbl[extra_fields] where provider='$user'");
		db_query("DELETE FROM $sql_tbl[tax_rates] where provider='$user'");

		# Search the zones created by provider...
		$zones_to_delete = db_query("SELECT zoneid FROM $sql_tbl[zones] where provider='$user'");
		if ($zones_to_delete) {
			while ($value = db_fetch_array($zones_to_delete)) {
				# Delete zone related information...
				db_query("DELETE FROM $sql_tbl[zone_element] where zoneid='$value[zoneid]'");
			}
			# Delete zone information...
			db_query("DELETE FROM $sql_tbl[zones] where provider='$user'");
		}

		#
		# Delete provider's file dir
		#
		@func_rm_dir ($files_dir_name.DIRECTORY_SEPARATOR.$user);

	} elseif (in_array($usertype, array("P", "A"))) {
		if (!is_string($next_provider))
			$next_provider = func_get_next_provider($user);

		$next_provider_data = array("provider" => addslashes($next_provider));
		func_array2update("products", $next_provider_data, "provider = '$user'");
		func_array2update("shipping_rates", $next_provider_data, "provider = '$user'");
		func_array2update("discounts", $next_provider_data, "provider = '$user'");
		func_array2update("discount_coupons", $next_provider_data, "provider = '$user'");
		func_array2update("extra_fields", $next_provider_data, "provider = '$user'");
		func_array2update("tax_rates", $next_provider_data, "provider = '$user'");
		func_array2update("zones", $next_provider_data, "provider = '$user'");
	}

	#
	# If it is partner, then remove all his information
	#
	if ($usertype == "B" && func_query_first_cell("SELECT COUNT(*) FROM $sql_tbl[modules] WHERE module_name='XAffiliate'") > 0) {
		$is_xaffiliate_avail = !empty($active_modules["XAffiliate"]);
		if (!$is_xaffiliate_avail && (@include $xcart_dir."/modules/XAffiliate/config.php")) {
			$is_xaffiliate_avail = true;
		}

		if ($is_xaffiliate_avail && !empty($sql_tbl['partner_clicks'])) {
			db_query("DELETE FROM $sql_tbl[partner_clicks] WHERE login='$user'");
			db_query("DELETE FROM $sql_tbl[partner_commissions] WHERE login='$user'");
			db_query("DELETE FROM $sql_tbl[partner_payment] WHERE login='$user'");
			db_query("DELETE FROM $sql_tbl[partner_views] WHERE login='$user'");
			db_query("UPDATE $sql_tbl[customers] SET parent = '' WHERE parent = '$user' AND usertype = '$usertype'");
		}
	}

	db_query("DELETE FROM $sql_tbl[register_field_values] WHERE login='$user'");
	db_query("DELETE FROM $sql_tbl[customers] WHERE login='$user' AND usertype='$usertype'");
	db_query("DELETE FROM $sql_tbl[login_history] WHERE login='$user'");
	db_query("DELETE FROM $sql_tbl[stats_customers_products] WHERE login='$user'");

	if (!empty($active_modules['Special_Offers'])) {
		db_query("DELETE FROM $sql_tbl[customer_bonuses] WHERE login = '$user'");
	}

	x_load("export");
	func_export_range_erase("USERS", $user);

}

function func_get_next_provider($exclude) {

	$list = func_get_next_providers($exclude);
	if (count($list) == 0)
		return "";

	$list = array_shift($list);
	return $list['login'];
}

function func_get_next_providers($exclude) {
	global $sql_tbl;

	if (is_string($exclude)) {
		$where = "!= '$exclude'";

	} elseif (is_array($exclude)) {
		$where = "NOT IN ('".implode("', '", $exclude)."')";

	} else {
		return array();
	}

	$list = func_query("SELECT * FROM $sql_tbl[customers] WHERE login $where AND usertype = 'P' AND activity = 'Y' AND status = 'Y'");

	if (empty($list))
		$list = func_query("SELECT * FROM $sql_tbl[customers] WHERE login $where AND usertype = 'P'");

	return empty($list) ? array() : $list;
}

function func_get_provider_counters($provider) {
	global $sql_tbl;

	$return = array(
		"parts" => array(
			"products" => func_query_first_cell("SELECT COUNT(*) FROM $sql_tbl[products] WHERE provider = '$provider'"),
			"shipping_rates" => func_query_first_cell("SELECT COUNT(*) FROM $sql_tbl[shipping_rates] WHERE provider = '$provider'"),
			"discounts" => func_query_first_cell("SELECT COUNT(*) FROM $sql_tbl[discounts] WHERE provider = '$provider'"),
			"discount_coupons" => func_query_first_cell("SELECT COUNT(*) FROM $sql_tbl[discount_coupons] WHERE provider = '$provider'"),
			"extra_fields" => func_query_first_cell("SELECT COUNT(*) FROM $sql_tbl[extra_fields] WHERE provider = '$provider'"),
			"tax_rates" => func_query_first_cell("SELECT COUNT(*) FROM $sql_tbl[tax_rates] WHERE provider = '$provider'"),
			"zones" => func_query_first_cell("SELECT COUNT(*) FROM $sql_tbl[zones] WHERE provider = '$provider'")
		)
	);
	$return['total'] = array_sum($return['parts']);

	return $return;
}

#
# Get information associated with user
#
function func_userinfo($user, $usertype=NULL, $need_password=false, $need_cc=false, $profile_area=NULL) {
	global $sql_tbl, $single_mode, $shop_language, $default_user_profile_fields, $config, $current_area;
	global $active_modules;
	global $store_cc, $store_cvv2;

	$force_need_cc = ($current_area == 'C' && $config['General']['disable_cc'] != 'Y');

    $need_password = (bool)$need_password;
    $need_cc = (bool)$need_cc;
    $usertype = addslashes($usertype);

	if ($need_password || $need_cc || $force_need_cc)
		x_load('crypt');

	$usertype_query = ($usertype === NULL) ? "" : " AND $sql_tbl[customers].usertype='$usertype'";

	$userinfo = func_query_first("SELECT $sql_tbl[customers].*, $sql_tbl[memberships].membership, pm.membership as pending_membership, $sql_tbl[memberships].flag FROM $sql_tbl[customers] LEFT JOIN $sql_tbl[memberships] ON $sql_tbl[memberships].membershipid = $sql_tbl[customers].membershipid LEFT JOIN $sql_tbl[memberships] as pm ON pm.membershipid = $sql_tbl[customers].pending_membershipid WHERE $sql_tbl[customers].login='$user' $usertype_query");

	if (!empty($userinfo) && $usertype === NULL) $usertype = $userinfo["usertype"];

	if (is_null($profile_area) || empty($profile_area))
		$profile_area = $usertype;

	if (!is_array($profile_area))
		$profile_area = array($profile_area);

	if (!empty($userinfo)) {
		$userinfo['titleid'] = func_detect_title(addslashes($userinfo['title']));
		$userinfo['b_titleid'] = func_detect_title(addslashes($userinfo['b_title']));
		$userinfo['s_titleid'] = func_detect_title(addslashes($userinfo['s_title']));
		$userinfo['title'] = func_get_title($userinfo['titleid']);
		$userinfo['b_title'] = func_get_title($userinfo['b_titleid']);
		$userinfo['s_title'] = func_get_title($userinfo['s_titleid']);

		if ($need_password) {
			$userinfo["passwd1"] = $userinfo["passwd2"] = $userinfo["password"] = text_decrypt($userinfo["password"]);
			if (is_null($userinfo["password"])) {
				x_log_flag("log_decrypt_errors", "DECRYPT", "Could not decrypt password for the user ".$userinfo['login'], true);
			} elseif ($userinfo["password"] !== false) {
				$userinfo["passwd1"] = $userinfo["passwd2"] = stripslashes($userinfo["password"]);
			}
		}

		$is_exist_card_type = false;
		if (!empty($config['card_types']) && $force_need_cc) {
			foreach($config['card_types'] as $v) {
				if ($v['code'] == $userinfo['card_type']) {
					$is_exist_card_type = true;
					break;
				}
			}
		}

		if (($store_cc && $need_cc) || $force_need_cc) {
			$card_number = text_decrypt($userinfo["card_number"]);
			if (is_null($card_number)) {
				x_log_flag("log_decrypt_errors", "DECRYPT", " Could not decrypt the field 'Card number' for the user ".$userinfo['login'], true);
			} elseif (strlen($card_number) > 10 && $store_cc && $is_exist_card_type) {
				#
				# Prepare wildcard card_number
				#
				$userinfo["card_number_w"] = str_repeat("*", strlen($card_number)-4) . substr($card_number, -4);
			}

			if ($store_cc && $need_cc) {
				$userinfo["card_number"] = $card_number;
			}

			if (!empty($userinfo['card_expire'])) {
				$userinfo['card_expire_time'] = strtotime((2000+substr($userinfo["card_expire"],2,2)).substr($userinfo["card_expire"],0,2).'01');
			}

			if (!empty($userinfo['card_valid_from'])) {
				$userinfo['card_valid_from_time'] = strtotime((2000+substr($userinfo["card_valid_from"],2,2)).substr($userinfo["card_valid_from"],0,2).'01');
			}
		}

		if (($store_cvv2 && $need_cc) || $force_need_cc) {
			$card_cvv2 = text_decrypt($userinfo["card_cvv2"]);
			if (is_null($card_cvv2)) {
				x_log_flag("log_decrypt_errors", "DECRYPT", " Could not decrypt the field 'Card CVV2' for the user ".$userinfo['login'], true);
			} elseif (strlen($card_cvv2) > 1 && $store_cvv2 && $is_exist_card_type) {
				$userinfo["card_cvv2_w"] = str_repeat("*", strlen($card_cvv2));
			}

			if ($store_cvv2 && $need_cc) {
				$userinfo["card_cvv2"] = $card_cvv2;
			}	
		}
	}

	#
	# Get seller address if user is provider
	#
	if ($usertype == 'P' && !$single_mode) {
		$seller_address = func_query_first("SELECT * FROM $sql_tbl[seller_addresses] WHERE login='$user'");
		if (!empty($seller_address)) {
			func_unset($seller_address, 'login');
			list($seller_address['address'], $seller_address['address_2']) = explode("\n", $seller_address['address']);
			foreach($seller_address as $k=>$v)
				$_seller_address['seller_'.$k] = $v;
			$_seller_address["seller_statename"] = func_get_state($_seller_address["seller_state"], $_seller_address["seller_country"]);
			$_seller_address["seller_countryname"] = func_get_country($_seller_address["seller_country"]);
		}
		$_seller_address["need_arb_info"] = (func_query_first_cell("SELECT active FROM $sql_tbl[shipping] WHERE active='Y' AND code='ARB' LIMIT 1") == 'Y') && ($config['Shipping']['realtime_shipping'] == 'Y');
		$userinfo = func_array_merge($userinfo, $_seller_address);
	}

	$_tmp = preg_split("/[\r\n]+/", $userinfo["b_address"]);
	$userinfo["b_address"] = @$_tmp[0];
	$userinfo["b_address_2"] = @$_tmp[1];
	$userinfo["b_statename"] = func_get_state($userinfo["b_state"], $userinfo["b_country"]);
	$userinfo["b_countryname"] = func_get_country($userinfo["b_country"]);
	$_tmp = preg_split("/[\r\n]+/", $userinfo["s_address"]);
	$userinfo["s_address"] = @$_tmp[0];
	$userinfo["s_address_2"] = @$_tmp[1];
	unset($_tmp);
	$userinfo["s_statename"] = func_get_state($userinfo["s_state"], $userinfo["s_country"]);
	$userinfo["s_countryname"] = func_get_country($userinfo["s_country"]);
	if ($config["General"]["use_counties"] == "Y") {
		$userinfo["b_countyname"] = func_get_county($userinfo["b_county"]);
		$userinfo["s_countyname"] = func_get_county($userinfo["s_county"]);
	}

	if ($userinfo["usertype"] == "B" && !empty($active_modules["XAffiliate"])) {
		$userinfo["plan_id"] = func_query_first_cell("SELECT plan_id FROM $sql_tbl[partner_commissions] WHERE login = '$userinfo[login]'");
	}

	$email = $userinfo["email"];

	$userinfo['field_sections'] = array();

	# Get additional fields
	$fields = func_query("SELECT $sql_tbl[register_fields].fieldid, $sql_tbl[register_fields].section, $sql_tbl[register_field_values].value FROM $sql_tbl[register_fields] LEFT JOIN $sql_tbl[register_field_values] ON $sql_tbl[register_fields].fieldid = $sql_tbl[register_field_values].fieldid AND $sql_tbl[register_field_values].login = '$user' WHERE ($sql_tbl[register_fields].avail LIKE '%".implode("%' OR $sql_tbl[register_fields].avail LIKE '%", $profile_area)."%') ORDER BY $sql_tbl[register_fields].section, $sql_tbl[register_fields].orderby");
	if (empty($fields)) {
		$userinfo['additional_fields'] = array();
	} else {
		foreach($fields as $k => $v) {
			$fields[$k]['title'] = func_get_languages_alt("lbl_register_field_".$v['fieldid'], $shop_language, true);
			$userinfo['field_sections'][$v['section']] = true;
		}

		$userinfo['additional_fields'] = $fields;
	}

	if (in_array("C", $profile_area) && !in_array("H", $profile_area)) 
		$profile_area[] = "H";
	elseif (in_array("H", $profile_area) && !in_array("C", $profile_area))
		$profile_area[] = "C";

	# Get default fields
	$default_fields = unserialize($config["User_Profiles"]["register_fields"]);

	if (empty($default_fields) || !is_array($default_fields)) {
		$default_fields = array();
		if (!empty($default_user_profile_fields) && is_array($default_user_profile_fields)) {
			foreach($default_user_profile_fields as $k => $v) {
				if (is_array($v["avail"])) {
					$field_is_available = false;
					foreach ($profile_area as $a) {
						if ($v["avail"][$a] == 'Y') {
							$field_is_available = true;
							break;
						}
					}

				} else {
					$field_is_available = ($v["avail"] == 'Y');
				}
				
				if ($field_is_available)
					$default_fields[$k] = true;
				else 
					unset($userinfo[$k]);
			}
		}

	} else {
		$tmp = array();
		foreach($default_fields as $k => $v) {
			$found = false;
			foreach ($profile_area as $a) {
				if ($a && strpos($v['avail'], $a) !== false) {
					$found = true;
					break;
				}
			}
			if (!$found) {
				unset($userinfo[$v['field']]);
				continue;
			}

			$tmp[$v['field']] = true;
		}

		$default_fields = $tmp;
		unset($tmp);
	}

	if ($default_fields) {
		if (!@$userinfo['field_sections']['P'] && (@$default_fields['title'] || @$default_fields['firstname'] || @$default_fields['lastname'] || @$default_fields['company'])) {
			$userinfo['field_sections']['P'] = true;
		}

		if (!@$userinfo['field_sections']['B'] && (@$default_fields['b_title'] || @$default_fields['b_firstname'] || @$default_fields['b_lastname'] || @$default_fields['b_address'] || @$default_fields['b_address_2'] || (@$default_fields['b_county'] && $config["General"]["use_counties"] == "Y") || @$default_fields['b_state'] || @$default_fields['b_city'] || @$default_fields['b_country'] || @$default_fields['b_zipcode'])) {
			$userinfo['field_sections']['B'] = true;
		}

		if (!@$userinfo['field_sections']['S'] && (@$default_fields['s_title'] || @$default_fields['s_firstname'] || @$default_fields['s_lastname'] || @$default_fields['s_address'] || @$default_fields['s_address_2'] || (@$default_fields['s_county'] && $config["General"]["use_counties"] == "Y") || @$default_fields['s_state'] || @$default_fields['s_city'] || @$default_fields['s_country'] || @$default_fields['s_zipcode'])) {
			$userinfo['field_sections']['S'] = true;
		}

		if (!@$userinfo['field_sections']['C'] && (@$default_fields['phone'] || @$default_fields['email'] || @$default_fields['fax'] || @$default_fields['url'])) {
			$userinfo['field_sections']['C'] = true;
		}

		$userinfo['default_fields'] = $default_fields;
	}

	return $userinfo;
}

#
# This function generates username for anonymous customers
#
function func_generate_anonymous_username () {
	global $anonymous_username_prefix;
	global $sql_tbl;

	$login = $anonymous_username_prefix.'-'.func_genid("U");
	while (func_query_first_cell("SELECT COUNT(*) FROM $sql_tbl[customers] WHERE login = '$login'") > 0) {
		$login = $anonymous_username_prefix.'-'.func_genid("U");
	}	

	return $login;
}

#
# This function generates password for anonymous customers
#
function func_generate_anonymous_password () {
	return md5(uniqid(rand(),true));
}

#
# This function suspends account
#
function func_suspend_account($login, $usertype, $reason='') {
	global $sql_tbl, $config;
	global $mail_smarty;

	$login = func_query_first_cell("SELECT login FROM $sql_tbl[customers] WHERE login='$login' AND usertype='$usertype' AND status='Y'");
	if (empty($login))
		return false;

	do {
		$activation_key = md5(uniqid(rand()));
	} while (func_query_first_cell("SELECT COUNT(activation_key) FROM $sql_tbl[customers] WHERE activation_key='$activation_key'"));
	db_query("UPDATE $sql_tbl[customers] SET status='N', activation_key='$activation_key', autolock='".($reason == 'autolock' ? 'Y' : '')."', suspend_date=".time()." WHERE login='$login'");

	switch ($usertype) {
		case "A":
			$redirect = 'admin'; break;
		case "P":
			$redirect = 'provider'; break;
		case "B":
			$redirect = 'partner'; break;
    	default:
			$redirect = '';
	}

	$userinfo = func_userinfo($login, $usertype);

	$mail_smarty->assign('activation_key', $activation_key);
	$mail_smarty->assign('redirect', $redirect);
	$mail_smarty->assign('userinfo', $userinfo);
	$mail_smarty->assign('reason', $reason);
	$mail_smarty->assign("usertype", $usertype);

	if (func_send_mail($userinfo["email"], "mail/account_activation_key_subj.tpl", "mail/account_activation_key.tpl", $config["Company"]["users_department"], false))
		return true;
	else
		return false;
}

#
# This function enables account
#
function func_enable_account($activation_key, $login='') {
	global $sql_tbl;

	if (empty($login) && !empty($activation_key))
		$login = func_query_first_cell("SELECT login FROM $sql_tbl[customers] WHERE activation_key='$activation_key'");

	if (empty($login))
		return false;

	if (empty($activation_key))
		db_query("UPDATE $sql_tbl[customers] SET status='Y', activation_key='', autolock='N', suspend_date='' WHERE login='$login'");
	else
		db_query("UPDATE $sql_tbl[customers] SET status='Y', activation_key='', autolock='N', suspend_date='' WHERE login='$login' AND activation_key='$activation_key'");

	return $login;
}

#
# This function checks password strength
#
# Returns true if password is weak.
#
function func_is_password_weak($password) {
	global $config;

	return $config['Security']['use_complex_pwd'] == 'Y' && !(preg_match('/.{7,}/s',$password) && preg_match('/[a-z]/is',$password) && preg_match('/[0-9]/s',$password) && preg_match('/\S/s',$password));
}

#
# This function validate accordance a county ID to a state and country code
#
function func_check_county($countyid, $statecode, $countrycode) {
	global $sql_tbl;

	$return = true;
	if (is_numeric($countyid)) {
		$statecode = addslashes($statecode);
		if (func_query_first_cell("SELECT COUNT(*) FROM $sql_tbl[states] WHERE code='$statecode' AND country_code='$countrycode'") > 0) {
			$return = (func_query_first_cell("SELECT COUNT(*) FROM $sql_tbl[counties], $sql_tbl[states] WHERE $sql_tbl[counties].stateid=$sql_tbl[states].stateid AND $sql_tbl[counties].countyid='$countyid' AND $sql_tbl[states].code='$statecode' AND $sql_tbl[states].country_code='$countrycode'") == 1);
		}
	}

	return $return;
}

#
# This function validate accordance a postal code to a country code
#
function func_check_zip($zipcode, $countrycode = '') {

	$countrycode = trim($countrycode);

	# Do not produce error code for empty zipcode
	if (empty($zipcode)) return true;

	# bt:83803 According http://en.wikipedia.org/wiki/Postal_codes#Character_sets
	if ($countrycode == 'UA')
		return $zipcode;

	$zip_code_rules = array();

	# Update check_zipcode_js.tpl after any changes
	$zip_code_rules['AT'] = '/^(\d{4})$/Si';
	$zip_code_rules['CA'] = '/^([ a-z0-9-]{6,7})$/Si';
	$zip_code_rules['CH'] = '/^(\d{4})$/Si';
	$zip_code_rules['DE'] = '/^(\d{5})$/Si';
	$zip_code_rules['LU'] = '/^(\d{4})$/Si';
	$zip_code_rules['US'] = '/^(\d{5})$/Si';

	$rule = $zip_code_rules[$countrycode];
	if (empty($rule))
		$rule = '/^([ a-z0-9-]+)$/Si';

	return preg_match($rule, $zipcode, $arr);
}

#
# This function validate accordance a state code to a country code
#
function func_check_state($states, $statecode, $countrycode) {
	$country_flag = $state_flag = false;
	$return = true;
	foreach ($states as $val) {
		if ($val["country_code"] == $countrycode) {
			$country_flag = true;
			if ($val["state_code"] == $statecode)
				$state_flag = true;
		}
	}

	if ($country_flag && !$state_flag)
		$return = false;

	return $return;
}

#
# Get default register fields settings
#
function func_get_default_fields($fields_area) {
	global $config, $default_user_profile_fields;

	$default_fields = unserialize($config["User_Profiles"]["register_fields"]);
	if (!$default_fields) {
		$default_fields = array();
		foreach ($default_user_profile_fields as $k => $v) {
			$default_fields[$k]["title"] = func_get_default_field($k);
			$default_fields[$k]['field'] = $k;
    
			foreach (array("avail", "required") as $fn) {
				if (is_array($v[$fn]) && is_array($fields_area)) {
					foreach ($fields_area as $fa) {
						if ($v[$fn][$fa] == 'Y') {
							$default_fields[$k][$fn] = 'Y';
							break;
						}
					}
    
				} else {
					$default_fields[$k][$fn] = is_array($v[$fn]) ? $v[$fn][$fields_area] : $v[$fn];
				}
			}
		}

	} else {
		$tmp = array();
	    foreach ($default_fields as $k => $v) {
			$is_avail = false;
			$is_required = false;
			if (is_array($fields_area)) {
				foreach ($fields_area as $fa) {
					if (strpos($v['avail'], $fa) !== FALSE)
						$is_avail = true;

					if (strpos($v['required'], $fa) !== FALSE)
						$is_required = true;
				}

			} else {
				$is_avail = strpos($v['avail'], $fields_area) !== FALSE;
				$is_required = strpos($v['required'], $fields_area) !== FALSE;
			}

	        $tmp[$v['field']] = array(
    	        "avail" => $is_avail ? "Y" : "",
        	    "required" => $is_required ? "Y" : "",
            	"title" => func_get_default_field($v['field'])
	        );
    	}

	    $default_fields = $tmp;
    	unset($tmp);
	}

	return $default_fields;
}

#
# Detect available profile areas
#
function func_get_profile_areas($default_fields, $additional_fields = false) {
	$is_areas = array(
		"P" => ($default_fields['title']['avail'] == 'Y' || $default_fields['firstname']['avail'] == 'Y' || $default_fields['lastname']['avail'] == 'Y' || $default_fields['company']['avail'] == 'Y' || $default_fields['ssn']['avail'] == 'Y'),
		"B" => ($default_fields['b_title']['avail'] == 'Y' || $default_fields['b_firstname']['avail'] == 'Y' || $default_fields['b_lastname']['avail'] == 'Y' || $default_fields['b_address']['avail'] == 'Y' || $default_fields['b_address_2']['avail'] == 'Y' || $default_fields['b_city']['avail'] == 'Y' || $default_fields['b_state']['avail'] == 'Y' || $default_fields['b_country']['avail'] == 'Y' || $default_fields['b_zipcode']['avail'] == 'Y' || ($default_fields['b_county']['avail'] == 'Y' && $config['General']['use_counties'] == "Y")),
		"S" => ($default_fields['s_title']['avail'] == 'Y' || $default_fields['s_firstname']['avail'] == 'Y' || $default_fields['s_lastname']['avail'] == 'Y' || $default_fields['s_address']['avail'] == 'Y' || $default_fields['s_address_2']['avail'] == 'Y' || $default_fields['s_city']['avail'] == 'Y' || $default_fields['s_state']['avail'] == 'Y' || $default_fields['s_country']['avail'] == 'Y' || $default_fields['s_zipcode']['avail'] == 'Y' || ($default_fields['s_county']['avail'] == 'Y') && $config['General']['use_counties'] == "Y"),
		"C" => ($default_fields['phone']['avail'] == 'Y' || $default_fields['email']['avail'] == 'Y' || $default_fields['fax']['avail'] == 'Y' || $default_fields['url']['avail'] == 'Y'),
		"A" => false
	);

	if ($additional_fields) {
		foreach ($is_areas as $k => $v) {
			if ($v)
				continue;

			foreach ($additional_fields as $v2) {
				if ($v2['section'] == $k && $v2['avail'] == 'Y') {
					$is_areas[$k] = true;
					break;
				}
			}
		}
	}

	return $is_areas;
}

#
# Get additional register fields settings
#
function func_get_additional_fields($area = '', $user = '') {
	global $sql_tbl, $shop_language;

	if ($area) {
		if (!is_array($area))
			$area = array($area);

		$avail_condition = "($sql_tbl[register_fields].avail LIKE '%".implode("%' OR $sql_tbl[register_fields].avail LIKE '%", $area)."%')";
		$required_condition = "($sql_tbl[register_fields].required LIKE '%".implode("%' OR $sql_tbl[register_fields].required LIKE '%", $area)."%')";

		$fields = func_query("SELECT $sql_tbl[register_fields].*, IF($avail_condition, 'Y', '') as avail, IF($required_condition, 'Y', '') as required, $sql_tbl[register_field_values].value FROM $sql_tbl[register_fields] LEFT JOIN $sql_tbl[register_field_values] ON $sql_tbl[register_fields].fieldid = $sql_tbl[register_field_values].fieldid AND $sql_tbl[register_field_values].login = '$user' ORDER BY $sql_tbl[register_fields].section, $sql_tbl[register_fields].orderby");

	} else {
		$fields = func_query("SELECT * FROM $sql_tbl[register_fields] ORDER BY section, orderby");
	}

	if ($fields) {
		foreach ($fields as $k => $v) {
			$fields[$k]['title'] = func_get_languages_alt("lbl_register_field_".$v['fieldid'], $shop_language);
			if (!$area) {
				$fields[$k]['avail'] = func_keys2hash($v['avail']);
				$fields[$k]['required'] = func_keys2hash($v['required']);

			} elseif ($v['type'] == 'S' && $v['variants']) {
				$fields[$k]['variants'] = @explode(";", $v['variants']);
			}
		}
	}

	return $fields;
}

#
# Get additional register fields settings
#
function func_get_add_contact_fields($area = '') {
	global $sql_tbl, $shop_language, $config;

	if (!empty($area)) {
		$fields = func_query("SELECT *, IF(avail LIKE '%$area%', 'Y', '') as avail, IF(required LIKE '%$area%', 'Y', '') as required FROM $sql_tbl[contact_fields] ORDER BY orderby");
	}
	else {
		$fields = func_query("SELECT * FROM $sql_tbl[contact_fields] ORDER BY orderby");
	}

	if (empty($fields))
		return false;

	foreach ($fields as $k => $v) {
		// Compatibility with old XC 4.1.8 format
		if ($v["variants"]) {
			$probe = @unserialize($v["variants"]);
			if (!is_array($probe) || count($probe) <= 0) {
				$v["variants"] = @serialize(array($shop_language => $v["variants"]));
			}
		}

		$fields[$k]['title'] = func_get_languages_alt("lbl_contact_field_".$v['fieldid']);
		if (empty($area)) {
			$fields[$k]['avail'] = func_keys2hash($v['avail']);
			$fields[$k]['required'] = func_keys2hash($v['required']);
		}

		if ($v['type'] == 'S' && !empty($v['variants'])) {
			$v['variants'] = unserialize($v['variants']);
			if (is_array($v['variants']) && !empty($v['variants'])) {
				if (!empty($v['variants'][$shop_language])) {
					$fields[$k]['variants'] = explode(";", $v['variants'][$shop_language]);

				} elseif (!empty($v['variants'][$config['default_customer_language']])) {
					$fields[$k]['variants'] = explode(";", $v['variants'][$config['default_customer_language']]);

				} else {
					$key = key($v['variants']);
					$fields[$k]['variants'] = empty($key) ? array() : explode(";", $v['variants'][$key]);
				}

			} else {
				unset($fields[$k]);
			}
		}
	}

	return $fields;
}

#
# Transform key string to hash-array
#
function func_keys2hash($str) {
	$tmp = array();

	if (strlen($str) == 0)
		return $tmp;

	for ($x = 0; $x < strlen($str); $x++)
		$tmp[$str[$x]] = 'Y';

	return $tmp;
}

#
# Update seller address for provider user
#
function func_update_seller_address($data) {
	global $sql_tbl;

	# Check all required fields
	if (empty($data['login']) || empty($data['city']) || empty($data['country']) || empty($data['zipcode']))
		return false;
	# Check if state is empty and country marked as 'country without states'
	elseif (empty($data['state'])) {
		$has_states = func_query_first_cell("SELECT display_states FROM $sql_tbl[countries] WHERE code='".$data['country']."'");
		if ($has_states == 'Y')
			return false;
	}

	if (!empty($data['address_2']))
		$data['address'] .= "\n".$data['address_2'];

	func_unset($data, 'address_2');

	func_array2insert('seller_addresses', $data, true);

	return true;
}

#
# Check customer required fields    
#
function func_check_required_fields($userinfo) {
	global $sql_tbl, $config;

	$default_fields = func_get_default_fields("H");
	$additional_fields = func_get_additional_fields("H", $userinfo['login']);

	if (!empty($additional_fields) && is_array($additional_fields)) {
		foreach ($additional_fields as $k => $v) {
			if ($v["required"] == "Y" && !isset($v["value"])) {
				return true;
			}
		}
	}

	# Do not take required county fields into account if the county feature is disabled bt:89518
	if ($config["General"]["use_counties"] != "Y") {
		if (isset($default_fields['b_county'])) $default_fields['b_county']['required'] = '';
		if (isset($default_fields['s_county'])) $default_fields['s_county']['required'] = '';
	}

	if (!empty($default_fields) && is_array($default_fields)) {
		foreach ($default_fields as $k => $v) {
			if ($v["required"] == "Y" && empty($userinfo[$k])) {
				if ($k == "b_state" || ($k == 'b_county' && $config["General"]["use_counties"] == "Y")) {
					$b_display_states = (func_query_first_cell("SELECT display_states FROM $sql_tbl[countries] WHERE code = '$userinfo[b_country]'") == 'Y');
					if ($b_display_states)
						return true;
				} elseif ($k == "s_state" || ($k == 's_county' && $config["General"]["use_counties"] == "Y")) {
					$s_display_states = (func_query_first_cell("SELECT display_states FROM $sql_tbl[countries] WHERE code = '$userinfo[s_country]'") == 'Y');
					if ($s_display_states)
						return true;
				} else {
					return true;
				}
			}
		}
	}

	return false;
}

?>
