<?php
/*****************************************************************************\
+-----------------------------------------------------------------------------+
| X-Cart                                                                      |
| Copyright (c) 2001-2010 Ruslan R. Fazlyev <rrf@x-cart.com>                  |
| All rights reserved.                                                        |
+-----------------------------------------------------------------------------+
| PLEASE READ  THE FULL TEXT OF SOFTWARE LICENSE AGREEMENT IN THE "COPYRIGHT" |
| FILE PROVIDED WITH THIS DISTRIBUTION. THE AGREEMENT TEXT IS ALSO AVAILABLE  |
| AT THE FOLLOWING URL: http://www.x-cart.com/license.php                     |
|                                                                             |
| THIS  AGREEMENT  EXPRESSES  THE  TERMS  AND CONDITIONS ON WHICH YOU MAY USE |
| THIS SOFTWARE   PROGRAM   AND  ASSOCIATED  DOCUMENTATION   THAT  RUSLAN  R. |
| FAZLYEV (hereinafter  referred to as "THE AUTHOR") IS FURNISHING  OR MAKING |
| AVAILABLE TO YOU WITH  THIS  AGREEMENT  (COLLECTIVELY,  THE  "SOFTWARE").   |
| PLEASE   REVIEW   THE  TERMS  AND   CONDITIONS  OF  THIS  LICENSE AGREEMENT |
| CAREFULLY   BEFORE   INSTALLING   OR  USING  THE  SOFTWARE.  BY INSTALLING, |
| COPYING   OR   OTHERWISE   USING   THE   SOFTWARE,  YOU  AND  YOUR  COMPANY |
| (COLLECTIVELY,  "YOU")  ARE  ACCEPTING  AND AGREEING  TO  THE TERMS OF THIS |
| LICENSE   AGREEMENT.   IF  YOU    ARE  NOT  WILLING   TO  BE  BOUND BY THIS |
| AGREEMENT, DO  NOT INSTALL OR USE THE SOFTWARE.  VARIOUS   COPYRIGHTS   AND |
| OTHER   INTELLECTUAL   PROPERTY   RIGHTS    PROTECT   THE   SOFTWARE.  THIS |
| AGREEMENT IS A LICENSE AGREEMENT THAT GIVES  YOU  LIMITED  RIGHTS   TO  USE |
| THE  SOFTWARE   AND  NOT  AN  AGREEMENT  FOR SALE OR FOR  TRANSFER OF TITLE.|
| THE AUTHOR RETAINS ALL RIGHTS NOT EXPRESSLY GRANTED BY THIS AGREEMENT.      |
|                                                                             |
| The Initial Developer of the Original Code is Ruslan R. Fazlyev             |
| Portions created by Ruslan R. Fazlyev are Copyright (C) 2001-2010           |
| Ruslan R. Fazlyev. All Rights Reserved.                                     |
+-----------------------------------------------------------------------------+
\*****************************************************************************/

#
# $Id: login.php,v 1.179.2.4 2010/03/16 07:50:18 ferz Exp $
#

include "../top.inc.php";

if (!defined('XCART_START')) die("ERROR: Can not initiate application! Please check configuration.");

if (!empty($_POST['usertype'])) {
	define('AREA_TYPE', $_POST['usertype']);
} elseif (!empty($_GET["usertype"])) {
	define('AREA_TYPE', $_GET['usertype']);
}

require $xcart_dir."/init.php";

switch ($redirect) {
	case "admin":
		$redirect_to = DIR_ADMIN;
		$current_type = 'A';
		break;

	case "provider":
		$redirect_to = DIR_PROVIDER;
		$current_type = 'P';
		break;

	case "partner":
		$redirect_to = DIR_PARTNER;
		$current_type = 'B';
		break;

    default:
		$redirect_to = DIR_CUSTOMER;
		$current_type = 'C';
}

require $xcart_dir."/include/nocookie_warning.php";

x_load("crypt", "mail", "user", "backoffice");

x_session_register("username");
x_session_register("login_antibot_on");
x_session_register("logout_user");
x_session_register("login");
x_session_register("login_type");
x_session_register("logged");
x_session_register("previous_login_date");

x_session_register("login_attempt");
x_session_register("cart");
x_session_register("intershipper_recalc");

x_session_register("merchant_password");

x_session_register("antibot_err");

$merchant_password = "";

$login_error = false;

$redirect_to = $current_location.$redirect_to;

if ($REQUEST_METHOD == "POST") {

	$intershipper_recalc = "Y";

	x_session_register("identifiers",array());

	if ($mode == "login") {

		if (!empty($login) && $login_type === $current_type) {
			func_header_location($redirect_to . "/home.php");
		}

		$is_username_len_err = strlen($_POST["username"]) > 32;
		$is_password_len_err = strlen($_POST["password"]) > 64;
		$username = $_POST["username"];
		$antibot_input_str = (!empty($_POST["antibot_input_str"])) ? $_POST["antibot_input_str"] : "";

		if (isset($_POST["login_antibot_on"])) {
			$login_antibot_on = $_POST["login_antibot_on"];
		}
		
		$antibot_err = (!empty($active_modules['Image_Verification']) && $login_antibot_on && func_validate_image("on_login", $antibot_input_str));

		# Check for suspended account
		$user_status = func_query_first("SELECT login, autolock, suspend_date FROM $sql_tbl[customers] WHERE login='$username' AND usertype='$usertype' AND status='N'");
		if (!empty($user_status) && is_array($user_status)) {
			if ($config['Security']['auto_unlock'] > 0 && $user_status['autolock'] == 'Y' && $user_status['suspend_date'] > 0) {

				x_session_register('top_message');
				# Automatic account unlock
				if (time() > ($user_status['suspend_date'] + 60*$config['Security']['auto_unlock'])) {
					if (func_enable_account('',$user_status['login'])) {
						$top_message = array(
							"type" => "I",
							"content" => func_get_langvar_by_name("txt_account_automatically_activated",array("username" => $user_status['login']),false,true)
						);
					}
				} elseif ($config['Security']['lock_login_attempts'] > 0) { # Check, if the lock feature is on

					# Inform customer about the auto unlock

					$minutes = intval(date('i',($user_status['suspend_date'] + 60*$config['Security']['auto_unlock']) - time()));
					if ($minutes < 1)
						$minutes = func_get_langvar_by_name('txt_less_than_1_minute');
					else
						$minutes = $minutes.' '.func_get_langvar_by_name($minutes > 1 ? 'lbl_minutes': 'lbl_minute');
					
					$top_message['type'] = 'I';
					$top_message['content'] = func_get_langvar_by_name("txt_account_automatically_locked",array("times" => $config['Security']['lock_login_attempts'], "minutes" => $minutes),false,true);

					func_header_location($redirect_to . "/home.php");
				}

			} else {
				x_session_register('top_message');
				$top_message = array(
					'content' => func_get_langvar_by_name('err_account_temporary_disabled')
				);
				func_header_location($redirect_to . "/home.php");
			}
		}
		unset($user_status);

		$user_data = func_query_first("SELECT * FROM $sql_tbl[customers] WHERE BINARY login='$username' AND usertype='$usertype' AND status='Y'");

		# Suspend admin account which was not logged in for N days
		if (
			($config['Security']['suspend_admin_after'] > 0) &&
			$user_data['login'] != '' &&
			($user_data['last_login'] > 0) &&
			(time() > ($user_data['last_login'] + $config['Security']['suspend_admin_after']*24*3600))
		) {

			if (($usertype == 'A' || ($usertype == "P" && !empty($active_modules["Simple_Mode"]))) && func_suspend_account($user_data['login'],$usertype,'long_unused')) {
				db_query("UPDATE $sql_tbl[customers] SET last_login='".time()."' WHERE login='$user_data[login]'");

				x_session_register('top_message');
				$top_message = array(
					"content" => func_get_langvar_by_name("txt_account_suspended", array("days"=>$config['Security']['suspend_admin_after']),false,true),
					"type" => 'I'
				);
				func_header_location($redirect_to."/home.php");
			}
		}

		# Force password change if non-customer password was not changed for 90 days
		if (
			($config['Security']['force_change_password_days'] > 0) &&
			$user_data['login'] != '' &&
			($user_data['change_password_date'] > 0) &&
			(time() > ($user_data['change_password_date'] + $config['Security']['force_change_password_days']*24*3600) && $user_data['change_password'] != 'Y')
		) {
			if ($usertype != 'C') {
				db_query("UPDATE $sql_tbl[customers] SET change_password='Y' WHERE login='$user_data[login]'");
				$user_data['change_password'] = 'Y';

				x_session_register('top_message');
				$top_message = array(
					"content" => func_get_langvar_by_name("txt_old_password"),
					"type" => 'E'
				);
			}
		}

		$allow_login = true;
		$allow_admin_ip = true;

		if ($usertype == 'A' || ($usertype == "P" && !empty($active_modules["Simple_Mode"]))) {
			$iplist = preg_grep("/^\d+\.\d+\.\d+\.\d+$/", array_unique(preg_split('/[ ,]+/', trim($admin_allowed_ip))));
			if (count($iplist) > 0)
				$allow_login = func_compare_ip($REMOTE_ADDR, $iplist);

			if ($allow_login) {
				if (!empty($config['allowed_ips']) && !func_check_allow_admin_ip()) {
					$allow_login = false;
					$allow_admin_ip = false;
					func_send_admin_ip_reg("L", $username);
				}
			}
		}

		$right_password = false;
		if (!empty($user_data)) {
			$right_password = text_decrypt($user_data["password"]);
			if (is_null($right_password)) {
				x_log_flag("log_decrypt_errors", "DECRYPT", str_replace("{{user}}", $username, func_get_langvar_by_name("lbl_cannot_decrypt_password", null, false, true)), true);
				if (!func_check_blowfish_key()) {
					x_log_add("BLOWFISH", func_get_langvar_by_name("txt_bf_key_internal_error", null, false, true));
					if ($usertype == "A" || ($usertype == "P" && !empty($active_modules["Simple_Mode"]))) {
						x_session_register('top_message');
						$top_message = array(
							"content" => func_get_langvar_by_name("txt_bf_key_internal_error"),
							"type" => "E"
						);
					} elseif ($config["Email_Note"]["eml_wrong_bf_key"] == "Y") {
						$mail_smarty->assign("username", $username);
						@func_send_mail($config["Company"]["site_administrator"], "mail/wrong_bf_key_subj.tpl", "mail/wrong_bf_key.tpl", $config["Company"]["site_administrator"], true);
					}
				}
			}
		}

		if (!empty($user_data) && $password == $right_password && !empty($password) && !$allow_login && !$allow_admin_ip && !$antibot_err && !$is_username_len_err && !$is_password_len_err && empty($user_data['first_login']) && empty($user_data['last_login'])) {

			# Register IP for new admin / provider
			func_register_admin_ip($REMOTE_ADDR);
			$allow_login = true;
			$allow_admin_ip = true;
		}

		if (!empty($user_data) && $password == $right_password && !empty($password) && $allow_login && !$antibot_err && !$is_username_len_err && !$is_password_len_err) {
			unset($right_password);
			$identifiers[$usertype] = array (
				'login' => $username,
				'login_type' => $usertype
			);

			if (!empty($active_modules['Simple_Mode'])) {
				if ($usertype == 'A') $identifiers['P'] = $identifiers[$usertype];
				if ($usertype == 'P') $identifiers['A'] = $identifiers[$usertype];
			}

			#
			# Success login
			#
			$login_antibot_on = false;
			$login_attempt = "";
			if ($user_data["change_password"] == "Y") {
				x_session_register("login_change");
				x_session_register('require_change_password');
				$require_change_password[$usertype] = true;
				$login_change[$usertype] = $user_data["login"];
				func_header_location($redirect_to."/change_password.php");
			} else {
				x_session_unregister("login_change");
			}

			$login = $user_data["login"];  //$username;
			$login_type = $usertype;
			$logged = "";
			if ($usertype == "C") {
				if (!empty($active_modules['SnS_connector']))
					func_generate_sns_action("Login");

				x_session_register("login_redirect");
				$login_redirect = 1;
			}

			#
			# 1) generate $last_login by current timestamp and update database
			# 2) insert entry into login history
			#
			$tm = time();

			if (empty($user_data['first_login'])) {
				db_query("UPDATE $sql_tbl[customers] SET first_login = '$tm' WHERE login='$login'");
			}

			$previous_login_date = $user_data['last_login'];
			if ($previous_login_date == 0)
				$previous_login_date = $tm;

			db_query("UPDATE $sql_tbl[customers] SET invalid_login_attempts='0', last_login='$tm' WHERE login='$login'");
			db_query("REPLACE INTO $sql_tbl[login_history] (login, date_time, usertype, action, status, ip) VALUES ('$username','$tm','$usertype','login','success','$REMOTE_ADDR')");
			if (in_array($usertype, array('A', 'P')))
				x_log_flag('log_activity', 'ACTIVITY', "'$username' user with '$usertype' usertype has logged in. remote ip '$REMOTE_ADDR'");

			#
			# Set cookie with username if Greet visitor module enabled
			#
			if (!empty($active_modules["Greet_Visitor"]) && $login_type == "C") {
				func_store_greeting($user_data['firstname'], $user_data['lastname']);
			}

			$logout_user = false;
			$redirect_url = false;

			if ($login_type == "C" && $user_data["cart"] && func_is_cart_empty($cart))
				$cart = unserialize($user_data["cart"]);

			if ($login_type == "C") {

				# Redirect to saved URL
				x_session_register("remember_data");
				if (isset($is_remember) && $is_remember == 'Y' && !empty($remember_data)) {
					if ($HTTPS && preg_match("/^http:\/\//", trim($remember_data['URL'])) && $config["Security"]["dont_leave_https"] == 'Y') {
						$remember_data['URL'] = preg_replace("/^".preg_quote($http_location, "/")."/", $https_location, trim($remember_data['URL']));
					}
					$redirect_url = $remember_data['URL'];
				}

				if ((!$redirect_url) && (!func_is_cart_empty($cart))) {

					# Redirect to cart page
					$login_redirect = false;
					if((strpos($HTTP_REFERER, "mode=auth") === false) && (strpos($HTTP_REFERER, "mode=checkout") === false)) {
						$redirect_url = $redirect_to."/cart.php";
					} else {
						$redirect_url = $redirect_to."/cart.php?mode=checkout";
					}

				} elseif ((!$redirect_url) && (!empty($HTTP_REFERER))) {

					# Redirect to HTTP_REFERER
					if (
						func_is_internal_url($HTTP_REFERER) &&
						!preg_match('/(error_message\.php|secure_login\.php|help\.php\?section=Password_Recovery)/s', $HTTP_REFERER) && 
						(preg_match('/\.php(?:\?|$)/s', $HTTP_REFERER) || $config['SEO']['clean_urls_enabled'] == 'Y')
					) {
						$redirect_url = $redirect_to.strrchr(func_qs_remove($HTTP_REFERER, $XCART_SESSION_NAME), "/");
					}
				}
				if (!$redirect_url)
					$redirect_url = $redirect_to."/home.php";
			}

			#
			# If shopping cart is not empty then user is redirected to cart.php
			# Default password alert
			#
			if ($login_type == "A" || $login_type == "P") {
				$to_url = (!empty($active_modules["Simple_Mode"]) || $login_type == "A" ? $xcart_catalogs["admin"] : $xcart_catalogs["provider"])."/home.php";

				# Return to saved last working URL if we have one for specified login type.
				$_tmp_last_working_url = func_url_get_last_working_url($login_type);
				if (!zerolen($_tmp_last_working_url)) {
					$to_url = $_tmp_last_working_url;
				}
				unset($_tmp_last_working_url);

				$current_area = $login_type;
				include $xcart_dir."/include/get_language.php";

				# Check expiration for preauth orders
				x_load("payment");
				func_check_preauth_expiration();

				x_session_register("show_adv");
				$show_adv = true;

			} else {
				$to_url = ($redirect_url)?$redirect_url:"$redirect_to/home.php";
			}

			if ($login_type == "P") {
				x_session_register("show_seller_address_warning");
				$show_seller_address_warning = true; 
			}

			if (!$redirect_url && !zerolen($to_url)) {
				$redirect_url = $to_url;
			}

			$default_accounts = func_check_default_passwords($login);
			$to_url_amp = func_convert_amp($to_url);

			if (!empty($default_accounts)) {
				$current_area = $login_type;
				$txt_message = strip_tags(func_get_langvar_by_name("txt_your_password_warning_js",false,false,true));
				$txt_continue = strip_tags(func_get_langvar_by_name("lbl_continue",false,false,true));
				$txt_message_js = func_js_escape($txt_message);
				$javascript_message = <<<JS
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<script type="text/javascript">
<!--
	alert('$txt_message_js');
	self.location = '$to_url';
-->
</script>
</head>
<body>
$txt_message
<br /><br />
<a href="$to_url_amp">$txt_continue</a>
</body>
</html>
JS;
			}
			elseif (($usertype == "A") || (($usertype == "P") && !empty($active_modules["Simple_Mode"]))) {
				$default_accounts = func_check_default_passwords();

				$is_allowed_membership = $user_data['membershipid'] <= 0 || func_query_first_cell("SELECT flag FROM $sql_tbl[memberships] WHERE membershipid  = '$user_data[membershipid]'") != 'FS';
				if (!empty($default_accounts) && $is_allowed_membership) {
					$txt_message = strip_tags(func_get_langvar_by_name("txt_default_passwords_warning_js", array("accounts"=>implode(", ", $default_accounts)),false,true));
					$txt_continue = strip_tags(func_get_langvar_by_name("lbl_continue",false,false,true));
					$javascript_message = <<<JS
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<script type="text/javascript">
	alert('$txt_message');
	self.location = '$to_url';
</script>
</head>
<body>
$txt_message
<br /><br />
<a href="$to_url_amp">$txt_continue</a>
</body>
</html>
JS;
				}
			}

			if (!empty($javascript_message) && $admin_safe_mode == false) {
				x_session_save();
				echo $javascript_message;
				exit;
			}
			
			func_header_location(($redirect_url)?$redirect_url:"$redirect_to/home.php");
		
		} else {

			# Login incorrect

			$login_status = "failure";
			unset($right_password);

			if (!$allow_login)
				$login_status = "restricted";

			if (!func_query_first("SELECT login FROM $sql_tbl[login_history] WHERE login='$username' AND date_time='".time()."'")) {
				db_query("REPLACE INTO $sql_tbl[login_history] (login, date_time, usertype, action, status, ip) VALUES ('$username','".time()."','$usertype','login','$login_status', '$REMOTE_ADDR')");
				if (in_array($usertype, array('A', 'P')))
					x_log_flag('log_activity', 'ACTIVITY', "Someone tried to login as '$username' user with '$usertype' usertype and got '$login_status' login status. remote ip '$REMOTE_ADDR'");
			}

			if (($usertype == 'A' || (!empty($active_modules["Simple_Mode"]) && $usertype == 'P')) && $config['Email_Note']['eml_login_error'] == 'Y' && (!isset($allow_admin_ip) || $allow_admin_ip)) {

				# Send security alert to website admin

				$mail_smarty->assign("failed_login", $username);
				$mail_smarty->assign("failed_password", $password);
				@func_send_mail($config["Company"]["site_administrator"], "mail/login_error_admin_subj.tpl", "mail/login_error.tpl", $config["Company"]["site_administrator"], true);

			}

			if (!($usertype == 'A' || (!empty($active_modules["Simple_Mode"]) && $usertype == 'P')) && $config['Email_Note']['eml_customer_login_error'] == 'Y') {

				# Send customer security alert to website admin

				switch ($usertype) {
					case 'P' : $userarea = 'provider'; break;
					case 'B' : $userarea = 'partner'; break;
					default : $userarea = 'customer';
				}
				$mail_smarty->assign("failed_login", $username);
				$mail_smarty->assign("failed_password", $password);
				$mail_smarty->assign("usertype", $usertype);
				$mail_smarty->assign("userarea", $userarea);
				@func_send_mail($config["Company"]["site_administrator"], "mail/login_error_subj.tpl", "mail/login_error.tpl", $config["Company"]["site_administrator"], true);

			}

			if (isset($allow_admin_ip) && !$allow_admin_ip) {
				x_session_register('top_message');
				$top_message = array(
					"content" => func_get_langvar_by_name("lbl_ip_blocked_for_admin_area_note"),
					"type" => "W"
				);

			} elseif ($is_username_len_err) {
				x_session_register('top_message');
				$top_message = array(
					"type" => "E",
					"content" => func_get_langvar_by_name("txt_wrong_username_len")
				);

			} elseif ($is_password_len_err) {
				x_session_register('top_message');
				$top_message = array(
					"type" => "E",
					"content" => func_get_langvar_by_name("txt_wrong_password_len")
				);
			}

			#
			# After 3 failures redirects to Recover password page
			#
			$login_attempt++;
			$max_login_attempts = 0;
			if (empty($config['Image_Verification']['spambot_arrest_login_attempts'])) {
				$max_login_attempts = 3;
			} else {
				$max_login_attempts = $config['Image_Verification']['spambot_arrest_login_attempts'];
			}

			if ($config['Security']['auto_unlock'] > 0)
				$autolock = 'autolock';
			else
				$autolock = '';

			if ($config['Security']['lock_login_attempts'] > 0 && func_query_first_cell("SELECT invalid_login_attempts FROM $sql_tbl[customers] WHERE login='$username'") >= $config['Security']['lock_login_attempts'] && func_suspend_account($username,$usertype,$autolock)) {

				x_session_register('top_message');

				if ($autolock) {
					$minutes = intval(date('i',(60*$config['Security']['auto_unlock'])));
					if ($minutes < 1)
						$minutes = func_get_langvar_by_name('txt_less_than_1_minute');
					else
						$minutes = $minutes.' '.func_get_langvar_by_name($minutes > 1 ? 'lbl_minutes': 'lbl_minute');
					$top_message['type'] = 'I';
					$top_message['content'] = func_get_langvar_by_name("txt_account_automatically_locked",array("times" => $config['Security']['lock_login_attempts'], "minutes"=> $minutes),false,true);
				} else {
					$top_message = array(
						'content' => func_get_langvar_by_name('err_account_temporary_disabled')
					);
					func_header_location($redirect_to . "/home.php");
				}

				db_query("UPDATE $sql_tbl[customers] SET invalid_login_attempts='0' WHERE login='$username'");

			} else
				db_query("UPDATE $sql_tbl[customers] SET invalid_login_attempts=invalid_login_attempts+1 WHERE login='$username' AND status='Y'");

			if ($login_attempt >= $max_login_attempts) {
				$login_attempt = 0;
				$login_antibot_on = 1;
				if (!$antibot_err) {
					func_header_location($redirect_to."/help.php?section=Password_Recovery");
				} else {
					func_header_location($redirect_to."/error_message.php?antibot_error");
				}
			} elseif (($antibot_err) && ($login_antibot_on)) {
				func_header_location($redirect_to."/error_message.php?antibot_error");
			} else {
				func_header_location($redirect_to."/error_message.php?login_incorrect");
			}
		}
	}
}

#
# Check for valid activation key and activate account on success
#
if (isset($activation_key) && preg_match("/^[a-f0-9]{32}$/i", $activation_key) && $username = func_enable_account($activation_key)) {
	x_session_register('top_message');
	$top_message = array(
		"type" => "I",
		"content" => func_get_langvar_by_name("txt_account_activated",array("username" => $username),false,true)
	);
	func_header_location($redirect_to."/error_message.php?need_login");
}

if ($mode == "logout") {
	$login_antibot_on = false;
	$login_attempt = "";
	x_session_register("identifiers",array());
	x_session_register("payment_cc_fields");
	$payment_cc_fields = array();
	func_unset($identifiers,$current_type);

	if ($current_type == 'C') {
		x_session_register("enter_as_anonymous");
		$enter_as_anonymous = false;

		x_load('paypal');
		func_paypal_clear_ec_token();
	}

	if (!empty($active_modules['Simple_Mode'])) {
		if ($current_type == 'A') func_unset($identifiers,'P');
		if ($current_type == 'P') func_unset($identifiers,'A');
	}

	#
	# Insert entry into login_history
	#
	$utype = func_query_first_cell("SELECT usertype FROM $sql_tbl[customers] WHERE login = '$login'");
	if (!empty($active_modules['Simple_Mode']) && $utype == 'A')
		$utype = 'P';
	db_query("REPLACE INTO $sql_tbl[login_history] (login, date_time, usertype, action, status, ip) VALUES ('$login','".time()."','$utype','logout','success','$REMOTE_ADDR')");

	x_log_flag('log_activity', 'ACTIVITY', "'$login' user, '$utype' user type has logged out. remote ip '$REMOTE_ADDR'");

	$old_login_type = $current_type;
	$login = "";
	$login_type = "";
	if ($utype == 'C')
		$cart = "";
	$access_status = "";
	$merchant_password = "";
	$logout_user = true;
	if ($current_type == 'A' || $current_type == 'P') {
		func_ge_erase();
		x_session_register("recent_payment_methods");
		$recent_payment_methods = array();
	}

	x_session_unregister("hide_security_warning");
	x_session_unregister("initial_state_orders");
	x_session_unregister("initial_state_show_notif");
	x_session_register("login_redirect");
	$login_redirect = 1;
}

if (
	$old_login_type == 'C' &&
	func_is_internal_url($HTTP_REFERER) &&
	!preg_match("/(mode=order_message|mode=wishlist|bonuses.php|returns.php|giftreg_manage.php|order.php|error_message.php|register.php?mode=delete|register.php?mode=update)/s", $HTTP_REFERER)
) {
	func_header_location($redirect_to . strrchr(func_qs_remove($HTTP_REFERER, $XCART_SESSION_NAME), "/"), false);
}

func_header_location($redirect_to . "/home.php", false);

?>
