<?php
/*****************************************************************************\
+-----------------------------------------------------------------------------+
| X-Cart                                                                      |
| Copyright (c) 2001-2010 Ruslan R. Fazlyev <rrf@x-cart.com>                  |
| All rights reserved.                                                        |
+-----------------------------------------------------------------------------+
| PLEASE READ  THE FULL TEXT OF SOFTWARE LICENSE AGREEMENT IN THE "COPYRIGHT" |
| FILE PROVIDED WITH THIS DISTRIBUTION. THE AGREEMENT TEXT IS ALSO AVAILABLE  |
| AT THE FOLLOWING URL: http://www.x-cart.com/license.php                     |
|                                                                             |
| THIS  AGREEMENT  EXPRESSES  THE  TERMS  AND CONDITIONS ON WHICH YOU MAY USE |
| THIS SOFTWARE   PROGRAM   AND  ASSOCIATED  DOCUMENTATION   THAT  RUSLAN  R. |
| FAZLYEV (hereinafter  referred to as "THE AUTHOR") IS FURNISHING  OR MAKING |
| AVAILABLE TO YOU WITH  THIS  AGREEMENT  (COLLECTIVELY,  THE  "SOFTWARE").   |
| PLEASE   REVIEW   THE  TERMS  AND   CONDITIONS  OF  THIS  LICENSE AGREEMENT |
| CAREFULLY   BEFORE   INSTALLING   OR  USING  THE  SOFTWARE.  BY INSTALLING, |
| COPYING   OR   OTHERWISE   USING   THE   SOFTWARE,  YOU  AND  YOUR  COMPANY |
| (COLLECTIVELY,  "YOU")  ARE  ACCEPTING  AND AGREEING  TO  THE TERMS OF THIS |
| LICENSE   AGREEMENT.   IF  YOU    ARE  NOT  WILLING   TO  BE  BOUND BY THIS |
| AGREEMENT, DO  NOT INSTALL OR USE THE SOFTWARE.  VARIOUS   COPYRIGHTS   AND |
| OTHER   INTELLECTUAL   PROPERTY   RIGHTS    PROTECT   THE   SOFTWARE.  THIS |
| AGREEMENT IS A LICENSE AGREEMENT THAT GIVES  YOU  LIMITED  RIGHTS   TO  USE |
| THE  SOFTWARE   AND  NOT  AN  AGREEMENT  FOR SALE OR FOR  TRANSFER OF TITLE.|
| THE AUTHOR RETAINS ALL RIGHTS NOT EXPRESSLY GRANTED BY THIS AGREEMENT.      |
|                                                                             |
| The Initial Developer of the Original Code is Ruslan R. Fazlyev             |
| Portions created by Ruslan R. Fazlyev are Copyright (C) 2001-2010           |
| Ruslan R. Fazlyev. All Rights Reserved.                                     |
+-----------------------------------------------------------------------------+
\*****************************************************************************/

#
# $Id: func.cc_protxdir.php,v 1.6.2.3 2010/01/21 09:20:36 ferz Exp $
#

if ( !defined('XCART_START') ) { header("Location: ../"); die("Access denied"); }

#
# Do Protx Direct transaction
#
function func_cc_protxdir_do($order, $txtype) {
	global $sql_tbl;

	x_load("http");

	$module_params = func_query_first("SELECT * FROM $sql_tbl[ccprocessors] WHERE processor = 'cc_protxdir.php'");
	list($vpstxid, $securitykey, $txauthno, $vendortxcode) = explode("\n", $order["order"]["extra"]["txnid"]);

	switch ($module_params['testmode']) {
		case 'S':
			$url = 'https://test.sagepay.com:443/Simulator/VSPServerGateway.asp?Service=Vendor{service}TX';
			$service = ucfirst(strtolower($txtype));
		break;
   
		case 'Y':
			$url = 'https://test.sagepay.com:443/gateway/service/{service}.vsp';
			$service = strtolower($txtype);
		break;
   
		default:
			$url = 'https://live.sagepay.com:443/gateway/service/{service}.vsp';
			$service = strtolower($txtype);
	}
   
	$post = array(
		"VPSProtocol=2.23",
		"TxType=" . $txtype,
		"Vendor=" . $module_params["param01"],
		"VendorTxCode=" . $vendortxcode,
		"VPSTxId=" . $vpstxid,
		"SecurityKey=" . $securitykey,
		"TxAuthNo=" . $txauthno
	);
   
	if ($txtype == 'RELEASE') {
		$post[] = "ReleaseAmount=" . $order['order']['total'];
	}

	$url = str_replace("{service}", $service, $url);

	list($a, $return) = func_https_request("POST", $url, $post);

	$ret = str_replace("\r\n", "&", $return);

	$ret_arr = explode("&",$ret);
	$response = array();
	foreach ($ret_arr as $ret) {
		if (preg_match("/([^=]+?)=(.+)/S", $ret, $matches))
			$response[$matches[1]] = trim($matches[2]);
	}

	$status = $response['Status'] == "OK";
	$err_msg = "";

	if (!$status)
		$err_msg = $response['Status'].": ".$response['StatusDetail'];

	$extra = array(
		"name" => "txnid",
		"value" => $order["order"]["extra"]["txnid"]
	);

	return array($status, $err_msg, $extra);
}

#
# Do Protx Direct Capture transaction
#
function func_cc_protxdir_do_capture($order) {
	return func_cc_protxdir_do($order, "RELEASE");
}

#
# Do Protx Direct Void transaction
#
function func_cc_protxdir_do_void($order) {
	return func_cc_protxdir_do($order, "ABORT");
}

?>
