<?php
/*****************************************************************************\
+-----------------------------------------------------------------------------+
| X-Cart                                                                      |
| Copyright (c) 2001-2010 Ruslan R. Fazlyev <rrf@x-cart.com>                  |
| All rights reserved.                                                        |
+-----------------------------------------------------------------------------+
| PLEASE READ  THE FULL TEXT OF SOFTWARE LICENSE AGREEMENT IN THE "COPYRIGHT" |
| FILE PROVIDED WITH THIS DISTRIBUTION. THE AGREEMENT TEXT IS ALSO AVAILABLE  |
| AT THE FOLLOWING URL: http://www.x-cart.com/license.php                     |
|                                                                             |
| THIS  AGREEMENT  EXPRESSES  THE  TERMS  AND CONDITIONS ON WHICH YOU MAY USE |
| THIS SOFTWARE   PROGRAM   AND  ASSOCIATED  DOCUMENTATION   THAT  RUSLAN  R. |
| FAZLYEV (hereinafter  referred to as "THE AUTHOR") IS FURNISHING  OR MAKING |
| AVAILABLE TO YOU WITH  THIS  AGREEMENT  (COLLECTIVELY,  THE  "SOFTWARE").   |
| PLEASE   REVIEW   THE  TERMS  AND   CONDITIONS  OF  THIS  LICENSE AGREEMENT |
| CAREFULLY   BEFORE   INSTALLING   OR  USING  THE  SOFTWARE.  BY INSTALLING, |
| COPYING   OR   OTHERWISE   USING   THE   SOFTWARE,  YOU  AND  YOUR  COMPANY |
| (COLLECTIVELY,  "YOU")  ARE  ACCEPTING  AND AGREEING  TO  THE TERMS OF THIS |
| LICENSE   AGREEMENT.   IF  YOU    ARE  NOT  WILLING   TO  BE  BOUND BY THIS |
| AGREEMENT, DO  NOT INSTALL OR USE THE SOFTWARE.  VARIOUS   COPYRIGHTS   AND |
| OTHER   INTELLECTUAL   PROPERTY   RIGHTS    PROTECT   THE   SOFTWARE.  THIS |
| AGREEMENT IS A LICENSE AGREEMENT THAT GIVES  YOU  LIMITED  RIGHTS   TO  USE |
| THE  SOFTWARE   AND  NOT  AN  AGREEMENT  FOR SALE OR FOR  TRANSFER OF TITLE.|
| THE AUTHOR RETAINS ALL RIGHTS NOT EXPRESSLY GRANTED BY THIS AGREEMENT.      |
|                                                                             |
| The Initial Developer of the Original Code is Ruslan R. Fazlyev             |
| Portions created by Ruslan R. Fazlyev are Copyright (C) 2001-2010           |
| Ruslan R. Fazlyev. All Rights Reserved.                                     |
+-----------------------------------------------------------------------------+
\*****************************************************************************/

#
# $Id: register.php,v 1.288.2.7 2010/04/12 07:09:17 ferz Exp $
#

if ( !defined('XCART_SESSION_START') ) { header("Location: ../"); die("Access denied"); }

x_load('cart','category','crypt','mail','user');

x_session_register ("intershipper_recalc");
x_session_unregister("secure_oid");

$country_where = (((isset($submode)) && ($submode == "seller_address")) ? " AND $sql_tbl[countries].code='".$config["Company"]["location_country"]."'" : "");

require $xcart_dir."/include/countries.php";
require $xcart_dir."/include/states.php";
if ($config["General"]["use_counties"] == "Y")
	include $xcart_dir."/include/counties.php";

x_session_register("profile_modified_data");
x_session_register("profile_modified_add_field");
x_session_register("ups_worked");

$user = (isset($user) && !empty($user)) ? (string)$user : '_';

if (!isset($card_expire) && isset($card_expire_Month)) {
	$card_expire_Month = sprintf("%02d",intval($card_expire_Month));
	$card_expire_Year = sprintf("%04d",intval($card_expire_Year));
	$card_expire = $card_expire_Month.substr($card_expire_Year, 2);
	$card_expire_time = mktime(0,0,0,$card_expire_Month,1,$card_expire_Year);
	if (isset($_POST['card_expire_Month'])) {
		$_POST['card_expire_time'] = $card_expire_time;
	}
} elseif (isset($card_expire)) {
	$card_expire = sprintf("%04d",intval($card_expire));
}	

if (!isset($card_valid_from) && isset($card_valid_from_Month)) {
	$card_valid_from_Month = sprintf("%02d", intval($card_valid_from_Month));
	$card_valid_from_Year = sprintf("%04d", intval($card_valid_from_Year));
	$card_valid_from = $card_valid_from_Month . substr($card_valid_from_Year, 2);
	$card_valid_from_time = mktime(0, 0, 0, $card_valid_from_Month, 1, $card_valid_from_Year);

	if (isset($_POST['card_valid_from_Month'])) {
		$_POST['card_valid_from_time'] = $card_valid_from_time;
	}

} elseif (isset($card_valid_from)) {
	$card_valid_from = sprintf("%04d", intval($card_valid_from));
}	

if ((isset($newbie) && $newbie == "Y") && (!isset($action) || $action != 'cart')) {
	#
	# Register/Modify own profile
	#
	$location[] = array(func_get_langvar_by_name("lbl_profile_details"), "");
}

if (empty($mode))
	$mode = "";

$is_admin_editor = false;
if ($current_area == 'A' || ($current_area == 'P' && !empty($active_modules['Simple_Mode'])) && ($login_type != $current_area)) {
	if ($login_type == 'C') {
		$fields_area = array("C", "H");
	} else {
		$fields_area = $login_type;
	}
	$is_admin_editor = true;
	$smarty->assign("is_admin_editor", true);

} elseif ($action == 'cart') {
	$fields_area = "H";

} else {
	$fields_area = $current_area;
}

if ($fields_area == 'P' && $current_area == 'A' && !empty($active_modules['Simple_Mode'])) {
	$fields_area = 'A';
}

$additional_fields = func_get_additional_fields($fields_area, $login);
$default_fields = func_get_default_fields($fields_area);

$is_areas = func_get_profile_areas($default_fields, $additional_fields);

$allow_pwd_modify = empty($login) ||
					(
						((!empty($active_modules['Simple_Mode']) && $current_area == 'P') || $current_area == 'A') &&
						(($REQUEST_METHOD == "POST" && $_POST['password_is_modified'] == 'Y') || $REQUEST_METHOD == 'GET')
					);

if ($REQUEST_METHOD == "POST" && isset($_POST['usertype'])) {
	#
	# Process the POST request and create/update profile
	#

	if (isset($cart_operation))
		return;

	#
	# Check if user have permissions to update/create profile
	#
	$allowed_registration = ($usertype == "C" || ($usertype == "B" && $config["XAffiliate"]["partner_register"] == "Y") || ($current_area == "P" && !empty($active_modules["Simple_Mode"])) || $current_area == "A");

	$allowed_update = (($usertype == $current_area && !empty($login) && !empty($uname) && $login == $uname) || ($current_area == "P" && !empty($active_modules["Simple_Mode"])) || $current_area == "A");

	if (($mode!="update" && !$allowed_registration) || ($mode=="update" && !$allowed_update)) {
		func_header_location("error_message.php?access_denied&id=36");
	}

	#
	# Anonymous registration (X-Cart generates username by itself)
	#
	$anonymous_user=false;

	$uname = trim($uname);
	$passed_uname = $uname;

	if ($anonymous && empty($uname) && $config["General"]["disable_anonymous_checkout"] != "Y") {
		$uname = func_generate_anonymous_username();

		#
		# All anonymous accounts must be customers
		#
		$usertype = "C";
		$passwd1 = func_generate_anonymous_password();
		$passwd2 = $passwd1;

		$anonymous_user=true;
	}
	
	if (!$anonymous) {
		$anonymous_user = func_is_anonymous($uname);
	}

	#
	# User registration info passed to register.php via POST method
	#
	$existing_user = func_query_first("select password, email from $sql_tbl[customers] where login='$uname'");
	$exerror = false;
	if (empty($existing_user)) {
		$existing_user = func_query_first("SELECT login FROM $sql_tbl[orders] WHERE login='$uname'");
		if (!empty($existing_user))
			$exerror = true;
	}

	if ($mode == "update") {
		$uerror = false;
	} else {
		$uerror = !(empty($uname)) && !empty($existing_user);
		$uerror = $uerror || func_is_anonymous($passed_uname);
		$uerror = $uerror || (strlen($uname) > 32);
	}

	#
	# Check for errors
	#
	$error = '';

	# Login will be checked only for new profiles
	if ($mode != "update") { 
		$uname_tmp = stripslashes($uname);
		if ((strcmp($uname_tmp, $uname) != 0) || (!preg_match("/^".func_login_validation_regexp()."$/is", $uname) && $uname != "")) 
			$error = "username";
	}		

	# Inherited first name and last name from Personalinformation to Billing / Shipping address
	foreach (array("firstname", "lastname") as $fn) {
		if ($default_fields[$fn]['avail'] == 'Y') {
			foreach (array('b_', 's_') as $fn_prefix) {
				if ($default_fields[$fn_prefix.$fn]['avail'] != 'Y')
					$_POST[$fn_prefix.$fn] = ${$fn_prefix.$fn} = $$fn;
			}
		}

		if (!empty($additional_fields)) {
			foreach ($additional_fields as $v_b) { 
				if ($v_b["section"] == "B") {
					foreach ($additional_fields as $v_s) {
						if ($v_s["section"] == "S" && $v_b["field"] == $v_s["field"] && ((empty($v_s["value"]) && !empty($v_b["value"])) || $ship2diff != 'Y')) {
							$additional_values[$v_s["fieldid"]] = $_POST["additional_values"][$v_s["fieldid"]] = $_POST["additional_values"][$v_b["fieldid"]];
						}
					}
				}
			}	
		}
	}

	if ($ship2diff != 'Y') {
		foreach (array('title','firstname','lastname','city','state','country','zipcode','address','address_2','county') as $v) {
			if ($default_fields['b_'.$v]['avail'] == 'Y') {
				$_POST['s_'.$v] = ${'s_'.$v} = ${'b_'.$v};

			} elseif (in_array($v, array("title", "firstname", "lastname")) && $default_fields[$v]['avail'] == 'Y') {
				$_POST['s_'.$v] = ${'s_'.$v} = $$v;
			}
		}
	}

	$trim_fields = array ('uname', 'firstname', 'lastname', 'b_address', 'b_city', 'b_state', 'b_country', 'b_zipcode', 'phone', 'email', 'b_title', 'b_firstname', 'b_lastname', 's_title', 's_firstname', 's_lastname', 'tax_number', 'card_type', 'card_name', 'card_number', 'card_expire', 'card_cvv2');
	foreach ($trim_fields as $k=>$v) {
		if (isset($$v)) $$v = trim($$v);
	}

	x_session_register("antibot_reg_err");
	if (!empty($login) || in_array($current_area, array('A','P')) || ($current_area == 'B' && !empty($login))) {
		$antibot_reg_err = false;
	}
	else {
		$antibot_reg_err = (!defined('USER_MODIFY') && !defined('USER_ADD') && !empty($active_modules['Image_Verification']) && func_validate_image("on_registration", $antibot_input_str));
	}	

	if ($ups_worked) {
		$antibot_reg_err = false;
		$ups_worked = false;
	}

	$fillerror = (empty($uname) || ($allow_pwd_modify && (!empty($error) || empty($passwd1) || empty($passwd2) || ($passwd1 != $passwd2) || strlen($passwd1) > 64 || strlen($passwd2) > 64)));

	if (!$anonymous_user && !$fillerror && $allow_pwd_modify) {

		$pass_error = $config['Security']['use_complex_pwd'] == 'Y' && (func_is_password_weak($passwd1) || $passwd1 == $uname || (!empty($login) && $login != $uname));

		$old_userinfo = func_userinfo($uname, $login_type, $allow_pwd_modify);
		if (!empty($old_userinfo)) {
			$old_userinfo["password"] = text_decrypt($old_userinfo["password"]);
			if ($config['Security']['check_old_passwords'] == 'Y') {
				$old_passwords_count = func_query_first_cell("SELECT COUNT(*) FROM $sql_tbl[old_passwords] WHERE login='".addslashes($login)."' AND password='".addslashes(md5($passwd1))."'");
				if ($passwd1 == $old_userinfo["password"])
					$old_passwords_count++;
			} else {
				$old_passwords_count = 0;
			}

			$pass_error = $old_passwords_count > 0 || $pass_error;
		}	
	}

    // Check default fields
	if (!$fillerror) {
		if ($default_fields['b_country']['avail'] != 'Y') {
			$b_country = $config['General']['default_country'];
			if ($default_fields['s_country']['avail'] != 'Y')
				$s_country = $config['General']['default_country'];
		}

		if ($default_fields['b_state']['avail'] != 'Y' && $b_country == $config['General']['default_country']) {
			$b_state = $config['General']['default_state'];
			if ($default_fields['s_state']['avail'] != 'Y' && $s_country == $config['General']['default_country'])
				$s_state = $config['General']['default_state'];
		}

		$s_address = trim($s_address);
		$s_address_2 = trim($s_address_2);
		$s_city = trim($s_city);
		$s_zipcode = trim($s_zipcode);

		foreach (array('city','state','country','zipcode') as $v) {
			if ($default_fields['b_'.$v]['avail'] != 'Y') {
				$_POST['b_'.$v] = ${'b_'.$v} = addslashes($config['General']['default_'.$v]);
			}

			if ($default_fields['s_'.$v]['avail'] != 'Y' && empty(${'s_'.$v})) {
				$_POST['s_'.$v] = ${'s_'.$v} = addslashes($config['General']['default_'.$v]);
			}
		}

		$s_display_states = (func_query_first_cell("SELECT display_states FROM $sql_tbl[countries] WHERE code = '$s_country'") == 'Y');
		$b_display_states = (func_query_first_cell("SELECT display_states FROM $sql_tbl[countries] WHERE code = '$b_country'") == 'Y');
		foreach ($default_fields as $k => $v) {
			if ($v['required'] == 'Y' && empty($$k) && $v['avail'] == 'Y' && !$is_admin_editor) {
				if ($k != 'b_state' && $k != 's_state' && $k != 'b_county' && $k != 's_county') {
					$fillerror = true;
					break;
				}
				elseif (($k == 's_state' || ($k == 's_county' && $config["General"]["use_counties"] == "Y")) && $s_display_states) {
					$fillerror = true;
					break;
				}
				elseif (($k == 'b_state' || ($k == 'b_county' && $config["General"]["use_counties"] == "Y")) && $b_display_states) {
					$fillerror = true;
					break;
				}
			}
		}
	}

    // Check additional fields
	if (!$fillerror && $additional_fields) {
		foreach ($additional_fields as $v) {
			if ($v['required'] == 'Y' && !isset($additional_values[$v['fieldid']]) && $v['avail'] == 'Y' && !$is_admin_editor) {
				$fillerror = true;
				break;
			}
		}
	}

    // Check email
	$emailerror = false;
	if (($default_fields['email']['required'] == 'Y' || !empty($email))&& $default_fields['email']['avail'] == 'Y') {
		$emailerror = !func_check_email($email);
		if ($default_fields['email']['required'] == 'Y' && $emailerror)
			$fillerror = $emailerror;

		if ($emailerror)
			$error = "email";
	}

    // Check state
	if ($default_fields['b_state']['avail'] == 'Y' && $default_fields['b_country']['avail'] == 'Y') {
		if (is_array($states) && !func_check_state($states, stripslashes($b_state), $b_country) && $b_display_states) {
			$error = "b_statecode";
		}
		elseif ($default_fields['b_county']['avail'] == 'Y' && $config["General"]["use_counties"] == "Y") {
			if (!func_check_county($b_county, stripslashes($b_state), $b_country)) {
				$error = "b_county";
			}
		}
	}
    
    // Check zipcode
    foreach (array('b_', 's_') as $prefix) {
        $zip_field = $prefix . 'zipcode';
        if (
            $default_fields[$zip_field]['avail'] == 'Y' 
            && !empty(${$zip_field})
            && !func_check_zip(${$zip_field}, ${$prefix . 'country'})
        ) {
            $section_title = func_get_langvar_by_name('lbl_' . ($prefix == 's_' ? 'shipping' : 'billing') . '_address', false, false, true);
            $error = func_get_langvar_by_name(
                'txt_error_' . strtolower(${$prefix . 'country'}) . '_zip_code', 
                array('address' => $section_title . ' '),
                false,
                true
            );

			# Common error message bt:0083803
			if (empty($error))
				$error = func_get_langvar_by_name('txt_error_common_zip_code', array('address' => $section_title . ' '), false, true);

            break;
        }
    }

	if (!(@$uerror || @$eerror || @$fillerror || @$error || @$antibot_reg_err || @$pass_error)) {
		#
		# Fields filled without errors. User registered successfully
		#
		if ($allow_pwd_modify)
			$crypted = addslashes(text_crypt($passwd1));

		if ($default_fields['s_state']['avail'] == 'Y' && $default_fields['s_country']['avail'] == 'Y') {
			if (is_array($states) && !func_check_state($states, stripslashes($s_state), $s_country) && $s_display_states) {
				$error = "s_statecode";
			}
			elseif ($default_fields['s_county']['avail'] == 'Y') {
				if ($config["General"]["use_counties"] == "Y" && !func_check_county($s_county, stripslashes($s_state), $s_country)) {
					$error = "s_county";
				}
			}
		}

		if (!@$error && $current_area == "C" && !empty($active_modules["UPS_OnLine_Tools"])) {
			#
			# Shipping Address Validation by UPS OnLine Tools module
			#
			include $xcart_dir."/modules/UPS_OnLine_Tools/ups_av.php";
		}

		#
		# Add new member to newsletter list
		#
		$cur_subs = array();
		if (!empty($existing_user)) {
			$tmp = func_query("SELECT DISTINCT($sql_tbl[newslist_subscription].listid) FROM $sql_tbl[newslist_subscription], $sql_tbl[newslists] WHERE $sql_tbl[newslist_subscription].email='".addslashes($existing_user["email"])."' AND $sql_tbl[newslist_subscription].listid=$sql_tbl[newslists].listid AND $sql_tbl[newslists].lngcode='$shop_language'");
			if (is_array($tmp)) {
				foreach ($tmp as $v)
					$cur_subs[] = $v["listid"];
			}
		}

		$ext_subs = array();
		$tmp = func_query("SELECT DISTINCT($sql_tbl[newslist_subscription].listid) FROM $sql_tbl[newslist_subscription], $sql_tbl[newslists] WHERE $sql_tbl[newslist_subscription].email='$email' AND $sql_tbl[newslist_subscription].listid=$sql_tbl[newslists].listid AND $sql_tbl[newslists].lngcode='$shop_language'");
		if (is_array($tmp)) {
			foreach ($tmp as $v)
				$ext_subs[] = $v["listid"];
		}

		$subs_keys = array();
		if (is_array($subscription)) $subs_keys = array_keys($subscription);

		$delid = array_diff($cur_subs,$subs_keys);
		$insid = array_diff($subs_keys,$cur_subs,$ext_subs);
		$updid = array_intersect($cur_subs, $subs_keys);
		$updid = array_diff($updid, $ext_subs);

		if (count($delid)>0)
			db_query("DELETE FROM $sql_tbl[newslist_subscription] WHERE email='$existing_user[email]' AND listid IN ('".implode("','",$delid)."')");

		if (count($updid)>0 && $existing_user["email"] != $email)
			db_query("UPDATE $sql_tbl[newslist_subscription] SET email='$email' WHERE email='$existing_user[email]' AND listid IN ('".implode("','",$updid)."')");

		foreach ($insid as $id) {
			db_query("INSERT INTO $sql_tbl[newslist_subscription] (listid, email, since_date) VALUES ('$id','$email', '".time()."')");
		}

		# URL normalization
		if (!empty($url)) {
			if(strpos($url, "http") !== 0) {
				$url = "http://".$url;
			}
		}

		if ($uname == $parent) { 
			$parent = "";
		} else {
			$parent = func_query_first_cell("SELECT login FROM $sql_tbl[customers] WHERE login='$parent' AND usertype = 'B'");
		}

		#
		# Update/Insert user info
		#

		$common_profile_fields = array('title', 'firstname', 'lastname', 'company', 'b_title', 'b_firstname', 'b_lastname', 'b_address', 'b_city', 'b_county', 'b_state', 'b_country', 'b_zipcode', 's_title', 's_firstname', 's_lastname', 's_address', 's_city', 's_county', 's_state', 's_country', 's_zipcode', 'phone', 'email', 'fax', 'url', 'pending_membershipid', 'ssn', 'parent');

		$profile_values = array();
		foreach ($common_profile_fields as $field) {
			$profile_values[$field] = isset($_POST[$field]) ? $_POST[$field] : '';
		}

		# Merge address line 2 with the first line 
		foreach ( array('s_', 'b_') as $addr_prefix) {
			if (isset($_POST[$addr_prefix.'address_2']) && !empty($_POST[$addr_prefix.'address_2']))
				$profile_values[$addr_prefix.'address'] .= "\n" . $_POST[$addr_prefix.'address_2'];
		}

		# Store new password
		if ($allow_pwd_modify) {
			$old_passwords_ids = func_query_column("SELECT id FROM $sql_tbl[old_passwords] WHERE login='".addslashes($uname)."' ORDER BY id DESC LIMIT 2");
			if (is_array($old_passwords_ids) && !empty($old_passwords_ids)) {
				$old_passwords_ids = implode("', '",$old_passwords_ids);
				db_query("DELETE FROM $sql_tbl[old_passwords] WHERE id NOT IN ('$old_passwords_ids') AND login='".addslashes($uname)."'");
			}
			if (!empty($old_userinfo["password"]))
				db_query("REPLACE INTO $sql_tbl[old_passwords] (login,password) VALUES ('".addslashes($uname)."','".addslashes(md5($old_userinfo["password"]))."')");
			$profile_values['password'] = $crypted;
			$profile_values['change_password_date'] = time();
		}

		if ($current_area == "C") {
			$profile_values['card_name'] = isset($card_name) ? $card_name : '';
			$profile_values['card_type'] = isset($card_type) ? $card_type : '';
			$profile_values['card_number'] = isset($card_number) ? addslashes(text_crypt($card_number)) : '';
			$profile_values['card_expire'] = isset($card_expire) ? $card_expire : '';
			$profile_values['card_valid_from'] = isset($card_valid_from) ? $card_valid_from : '';
			$profile_values['card_cvv2'] = isset($card_cvv2) ? addslashes(text_crypt($card_cvv2)) : '';

			$fields = array_keys($profile_values);
			foreach ($default_fields as $_field => $_avail) {
				if ($_avail['avail'] != 'Y' && in_array($_field, $fields)) {
					unset($profile_values[$_field]);
				}
			}
			unset($fields);

			if ($config["Taxes"]["allow_user_modify_tax_number"] == "Y" || empty($existing_user) || func_query_first_cell("SELECT tax_exempt FROM $sql_tbl[customers] WHERE login='$login' LIMIT 1") != "Y") {
				# Existing customer cannot edit 'tax_number' if
				# 'tax_exempt' == 'Y' and
				# 'allow_user_modify_tax_number' option == 'N'
				$profile_values['tax_number'] = @$tax_number;
			}
		}
		elseif ($current_area == 'A' || (!empty($active_modules['Simple_Mode']) && $current_area == "P")) {
			# Administrator can edit 'tax_number' and 'tax_exempt'
			$profile_values['tax_number'] = $tax_number;
			$profile_values['tax_exempt'] = (@$tax_exempt == 'Y' ? 'Y' : 'N');
		}

		$trusted_provider = ($trusted_provider == 'Y') ? 'Y' : 'N';
		$profile_values['trusted_provider'] = (empty($active_modules["Simple_Mode"]) && $current_area == 'A' && $login_type == 'P') ? $trusted_provider : 'Y';

		$activity_changed = false;

		if ((defined('USER_MODIFY') || defined('USER_ADD')) && @$login_ != @$login ) {
			# Currently logged admin cannot change self status or activity flag
			$profile_values['change_password'] = empty($change_password) ? 'N' : 'Y';

			$old_status = func_query_first_cell("SELECT status FROM $sql_tbl[customers] WHERE login='$uname' AND usertype='$login_type'");
			if (empty($status) && $old_status == 'A') {
				$status = 'A';
			}

			$profile_values['status'] = empty($status) ? 'N' : $status;
			$profile_values['suspend_date'] = ($old_status != $profile_values['status']) ? time() : '';

			if ($profile_values['status'] != 'N')
				$profile_values['activation_key'] = '';
			$profile_values['activity'] = empty($activity) ? 'N' : $activity;

			$old_activity = func_query_first_cell("SELECT activity FROM $sql_tbl[customers] WHERE login='$uname' AND usertype='$login_type'");
			$activity_changed = ($profile_values['activity'] != $old_activity);
		}

		if ($mode=="update") {

			$intershipper_recalc = "Y";

			if (isset($profile_values['password']) && $profile_values['password'] != func_query_first_cell("SELECT password FROM $sql_tbl[customers] WHERE login='$login' AND usertype='$login_type'")) {
				x_log_flag('log_activity', 'ACTIVITY', defined('USER_MODIFY') ? "'$login_' has changed password to '$login' user" : "'$login' has changed password");
			}

			func_array2update('customers', $profile_values, "login='$login' AND usertype='$login_type'");

			if (in_array($login_type, array('P', 'A')))
				x_log_flag('log_activity', 'ACTIVITY', defined('USER_MODIFY') ? "'$login_' user has updated '$login' profile" : "'$login' user has updated '$login' profile");

			db_query("DELETE FROM $sql_tbl[register_field_values] WHERE login = '$login'");

			if ($additional_values) {
				foreach ($additional_values as $k => $v)
					db_query("INSERT INTO $sql_tbl[register_field_values] (fieldid, login, value) VALUES ('$k', '$login', '$v')");
			}

			if ($login_type == 'B') {
				if (in_array(constant("AREA_TYPE"), array("A", "P"))) {
					if (!$plan_id) {
						$plan_id = $config['XAffiliate']['default_affiliate_plan'];
					}

					db_query("REPLACE INTO $sql_tbl[partner_commissions] VALUES ('$uname', '$plan_id')");

				} elseif ($config['XAffiliate']['partner_register_moderated'] != 'Y' && constant("AREA_TYPE") == 'B') {

					db_query("REPLACE INTO $sql_tbl[partner_commissions] VALUES ('$uname', '$pending_plan_id')");
				}
			}

			#
			# Update membership
			#
			if ($current_area=="A" || (!empty($active_modules["Simple_Mode"]) && $current_area=="P"))
				db_query("UPDATE $sql_tbl[customers] SET membershipid = '$membershipid' WHERE login='$login' AND usertype='$login_type'");

			$registered="Y";

			#
			# Send mail notifications to customer department and signed customer
			#
			if (!$anonymous_user) {

				$newuser_info = func_userinfo($login, $login_type, $allow_pwd_modify);
				$mail_smarty->assign("userinfo",$newuser_info);

				#
				# Send mail to registered user
				#
				$to_customer = $newuser_info["language"];

				if($config['Email_Note']['eml_profile_modified_customer'] == 'Y')
					func_send_mail($newuser_info["email"], "mail/profile_modified_subj.tpl", "mail/profile_modified.tpl", $config["Company"]["users_department"], false);
				#
				# Send mail to customers department
				#
				if($config['Email_Note']['eml_profile_modified_admin'] == 'Y')
					func_send_mail($config["Company"]["users_department"], "mail/profile_admin_modified_subj.tpl", "mail/profile_admin_modified.tpl", $newuser_info["email"], true);
			}

			if (!empty($active_modules["Greet_Visitor"]) && $login_type == "C" && $current_area == "C") {
				func_store_greeting($profile_values['firstname'], $profile_values['lastname']);
			}
		}
		else {
			#
			# Add new person to customers table
			#
			$intershipper_recalc = "Y";

			$profile_values['login'] = $uname;
			$profile_values['usertype'] = $usertype;

			if (!defined('USER_MODIFY') && !defined('USER_ADD')) {
				$profile_values['change_password'] = 'N';
				$profile_values['status'] = 'Y';
				$profile_values['activity'] = 'Y';
			}

			if (!isset($profile_values['cart']))
				$profile_values['cart'] = '';

			if (defined('AREA_TYPE') && in_array(constant('AREA_TYPE'), array('C', 'B')) && isset($_COOKIE["RefererCookie"]))
				$profile_values['referer'] = $_COOKIE["RefererCookie"];

			func_array2insert('customers', $profile_values, true);

			if (in_array($usertype, array('A', 'P')))
				x_log_flag('log_activity', 'ACTIVITY', defined('USER_ADD') ? "'$login_' user has added '$login' user, '$usertype' usertype" : "'$login' user has added '$login' user, '$usertype' usertype");

			db_exec("REPLACE INTO $sql_tbl[login_history] (login, date_time, usertype, action, status, ip) VALUES (?,?,?,?,?,?)",
				array ($uname,time(),$usertype,'login','success',$REMOTE_ADDR));

			$new_user_flag = true;

			db_query("DELETE FROM $sql_tbl[register_field_values] WHERE login = '$uname'");
			if ($additional_values) {
				foreach ($additional_values as $k => $v) {
					db_query("INSERT INTO $sql_tbl[register_field_values] (fieldid, login, value) VALUES ('$k', '$uname', '$v')");
				}
			}

			if ($usertype == 'B') {
				if ($config['XAffiliate']['partner_register_moderated'] == 'Y' && !defined('USER_MODIFY') && !defined('USER_ADD')) {
					db_query("UPDATE $sql_tbl[customers] SET status = 'Q' WHERE login = '$uname'");
				}

				if (in_array(constant("AREA_TYPE"), array("A", "P"))) {
					if (!$plan_id) {
						$plan_id = $config['XAffiliate']['default_affiliate_plan'];
					}
				} elseif ($config['XAffiliate']['partner_register_moderated'] != 'Y' && constant("AREA_TYPE") == 'B') {
					$plan_id = $pending_plan_id;
				}

				db_query("INSERT INTO $sql_tbl[partner_commissions] VALUES ('$uname', '$plan_id')");
			}

			#
			# Set prefered language for new customer
			#
			$_user_lngcode = "en";
			if (defined('USER_ADD')) {
				$_user_lngcode = $usertype == "C" ? $config["default_customer_language"] : $config["default_admin_language"];

			} elseif ($store_language) {
				$_user_lngcode = $store_language;
			}

			db_query ("UPDATE $sql_tbl[customers] SET language='$_user_lngcode' WHERE login='$uname'");

			#
			# Update membership
			#
			if ($current_area=="A" || (!empty($active_modules["Simple_Mode"]) && $current_area=="P"))
				db_query("UPDATE $sql_tbl[customers] SET membershipid = '$membershipid' WHERE login='$uname'");

			#
			# Set A-status
			#
			if ($anonymous_user) {
				db_query("UPDATE $sql_tbl[customers] SET status='A' WHERE login='$uname' AND usertype='$usertype'");
			}

			$registered="Y";

			#
			# Send mail notifications to customer department and signed customer
			#
			$newuser_info = func_userinfo($uname, $usertype, true);
			$mail_smarty->assign("userinfo",$newuser_info);

			#
			# Send mail to registered user (do not send to anonymous)
			#
			$mail_smarty->assign("full_usertype", func_get_langvar_by_name($usertype == "B" ? "lbl_partner" : "lbl_customer"));
			if (!$anonymous_user && $email) {
				if ($usertype == "B") {
					if (@$config['XAffiliate']['eml_signin_partner_notif'] == 'Y')
						func_send_mail($email, "mail/signin_notification_subj.tpl", "mail/signin_partner_notif.tpl", $config["Company"]["users_department"], false);
				}
				else {
					if ($config['Email_Note']['eml_signin_notif'] == 'Y')
						func_send_mail($email, "mail/signin_notification_subj.tpl", "mail/signin_notification.tpl", $config["Company"]["users_department"], false);
				}
			}

			#
			# Send mail to customers department
			#
			if (!$anonymous_user && $config['Email_Note']['eml_signin_notif_admin'] == 'Y') {
				func_send_mail($config["Company"]["users_department"], "mail/signin_admin_notif_subj.tpl", "mail/signin_admin_notification.tpl", $email, true);

			}

			#
			# Auto-log in
			#
			if ($usertype=="C" || ($usertype=="B" && $login=="")) {
				$_curtime = time();
				db_query("UPDATE $sql_tbl[customers] SET last_login='$_curtime', first_login='$_curtime' WHERE login = '$uname'");
				$auto_login = true;
				$login = $uname;
				$login_type = $usertype;
				$logged = "";
				x_session_register("identifiers",array());
				$identifiers[$usertype] = array (
					'login' => $login,
					'login_type' => $login_type,
				);

			}

		}

		if (!empty($active_modules['SnS_connector']) && $usertype == 'C' && defined("AREA_TYPE") && constant("AREA_TYPE") == 'C') {
			func_generate_sns_action("Register");
			if ($auto_login)
				func_generate_sns_action("Login");
		}

		if (!empty($active_modules['Special_Offers']) && $usertype=='C' && (defined('USER_MODIFY') || defined('USER_ADD'))) {
			include $xcart_dir."/modules/Special_Offers/register_customer.php";
		}

	}
	else {
		#
		# Fields filled with errors
		#

		if (!empty($fillerror)) $reg_error = "F";
		if (!empty($eerror)) $reg_error = "E";
		if (!empty($uerror)) $reg_error = $exerror ? "X" : "U";
		if (!empty($error)) $reg_error = "I";
		if (!empty($antibot_reg_err)) $reg_error = "A";
		if (!empty($pass_error)) $reg_error = "P";

	}

	if ($anonymous_user) {
		$uname = "";
		$passwd1 = "";
		$passwd2 = "";
	}

	#
	# Fill $userinfo array if error occured
	#
	$userinfo = $_POST;
	if (!empty($_POST['additional_values']) && !empty($additional_fields)) {
		foreach ($additional_fields as $k => $v) {
			$additional_fields[$k]['value'] =
				$_POST['additional_values'][$v['fieldid']];
		}
	}

	$profile_modified_data[$user] = func_stripslashes($userinfo);
	$profile_modified_add_field[$user] = $additional_fields;

	if (!empty($active_modules["News_Management"]) && is_array($_POST['subscription'])) {
		$profile_modified_data[$user]['subscription'] = $_POST['subscription'];
	}
	
	if (!empty($av_recheck)) {
		$top_message["type"] = "E";
		$top_message["content"] = func_get_langvar_by_name("txt_ups_av_reenter");
	}
	elseif ($reg_error || $error || $antibot_reg_err) {
		if ($reg_error == 'U' || $reg_error == 'X') {
			if (($current_area == 'A' || (!empty($active_modules['Simple_Mode']) && $current_area == "P")) && $reg_error == 'X')
				$top_message["content"] = func_get_langvar_by_name("txt_user_already_exists_in_orders");
			else
				$top_message["content"] = func_get_langvar_by_name("txt_user_already_exists");
		}
		elseif ($reg_error == 'E') {
			$top_message["content"] = func_get_langvar_by_name("txt_email_already_exists");
		} elseif ($antibot_reg_err) {
			$top_message["content"] = func_get_langvar_by_name("msg_err_antibot");
		} elseif ($reg_error == 'P' && $old_passwords_count > 0) {
			$top_message["content"] = func_get_langvar_by_name("txt_chpass_another");
		} elseif ($reg_error == 'P') {
			$top_message["content"] = func_get_langvar_by_name("txt_simple_password");
		} else {
			$top_message["content"] = func_get_langvar_by_name("msg_err_profile_upd");
		}

		$top_message["type"] = "E";
		$top_message["reg_error"] = $reg_error;
		$top_message["error"] = $error;
		$top_message["emailerror"] = $emailerror;
    
        if (!empty($error)) {
            $smarty->assign('error', $error);    
        }

	}
	else {
		if (@$new_user_flag && $anonymous_user) {
			# Anonymois profile is created
			$top_message["content"] = func_get_langvar_by_name("msg_anonymous_profile_add");
		}
		elseif (@$new_user_flag) {
			# Profile is created
			$top_message["content"] = func_get_langvar_by_name("msg_profile_add");
		}
		else {
			if ($anonymous_user) {
				# Anonymous profile is updated
				$top_message["content"] = func_get_langvar_by_name("msg_anonymous_profile_upd");
			}
			else {
				# Profile is updated
				$top_message["content"] = func_get_langvar_by_name("msg_profile_upd");
			}
		}

		$profile_modified_data = "";
		$profile_modified_add_field = "";
	}

	$script = basename($PHP_SELF)."?".$QUERY_STRING;

	if (defined('USER_MODIFY') || defined('USER_ADD')) {
		$login = $login_;
		$login_type = $login_type_;

		if (defined('USER_ADD') && !$reg_error && !$error) {
			$script = "user_modify.php?$QUERY_STRING&user=".urlencode($uname);
			if(($mode != "update") && ($usertype == "P") && ( !($uerror || $eerror || $fillerror || $antibot_reg_err || $pass_error) )) {
				func_mkdir(func_get_files_location($uname, $usertype));
			}
		}

		if ($usertype == 'P' && $activity_changed && !$single_mode) {
			$p_categories = db_query("SELECT $sql_tbl[products_categories].categoryid FROM $sql_tbl[products], $sql_tbl[products_categories] WHERE $sql_tbl[products].productid = $sql_tbl[products_categories].productid AND $sql_tbl[products].provider='$uname' GROUP BY $sql_tbl[products_categories].categoryid");
			if ($p_categories) {
				$cats = array();
				while ($row = db_fetch_array($p_categories)) {
					$cats[] = $row['categoryid'];

					if (count($cats) >= 100) {
						func_recalc_product_count(func_get_category_parents($cats));
						$cats = array();
					}
				}
				if (!empty($cats))
					func_recalc_product_count(func_get_category_parents($cats));

				db_free_result($p_categories);
			}
		}
	}
	elseif ($action == "cart") {
		if (!empty($reg_error) || !empty($av_error) || !empty($av_recheck)) {
			if (empty($login)) {
				# Anonymous checkout
				$script = "cart.php?mode=checkout";
			}
			elseif (!empty($paymentid)) {
				$script = "register.php?mode=update&action=cart&paymentid=".intval($paymentid);
			}
			else {
				$script = "register.php?mode=update&action=cart";
			}
		}
		elseif (empty($paymentid)) {
			$script = "cart.php?mode=checkout&registered=";
		}
		else {
			$script = "cart.php?mode=checkout&paymentid=".intval($paymentid);
		}
	}
	elseif ($current_area == "C" && !empty($cart)) {
		include_once $xcart_dir."/shipping/shipping.php";

		$shippings = func_get_shipping_methods_list($cart, $cart["products"], $userinfo);
		if (is_array($shippings)) {
			$found = false;
			$shippingid = $cart["shippingid"];
			for ($i = 0; $i < count($shippings); $i++) {
				if ($shippingid == $shippings[$i]["shippingid"]) {
					$found = true;
					break;
				}
			}

			if (!$found) {
				$shippingid = $shippings[0]["shippingid"];
			}
		}
		else {
			$shippingid = 0;
		}

		$cart["shippingid"] = $shippingid;
		$products = func_products_in_cart($cart, (!empty($userinfo["membershipid"]) ? $userinfo["membershipid"] : 0));
		$cart = func_array_merge($cart, func_calculate($cart, $products, $login, "C", (!empty($paymentid) ? intval($paymentid) : 0)));

		# And again, because shippingid is not saved after func_calculate
		$cart["shippingid"] = $shippingid;
	}
	elseif ($current_area == 'B' && $login_type == 'B' && func_query_first_cell("SELECT status FROM $sql_tbl[customers] WHERE login = '$login' AND usertype = '$login_type'") == 'Q') {
		$script = $xcart_catalogs['partner']."/home.php?mode=profile_created";
	}

	if (empty($av_error) || !empty($av_recheck)) {
		func_header_location($script);
	} else {
		$top_message = array();
	}
}
else {
	#
	# REQUEST_METHOD = GET
	#
	if ($mode == "update") {
		if (!empty($login)) {
			$userinfo = func_userinfo($login, $login_type, $allow_pwd_modify);

		} elseif (!defined("USER_MODIFY")) {
			func_header_location("register.php");
		}

	} elseif ($mode == "delete" && @$confirmed == "Y" && !empty($login)) {
		require $xcart_dir."/include/safe_mode.php";

		$olduser_info = func_userinfo($login, $login_type, true);

		$to_customer = $olduser_info["language"];

		# Clear last working URL to avoid automatic profile deletion within current session.
		func_url_unset_last_working_url($login_type);

		func_delete_profile($login, $login_type, true, true, (isset($next_provider) ? $next_provider : false));

		if (in_array($login_type, array('P', 'A')))
			x_log_flag('log_activity', 'ACTIVITY', "'$login' user has deleted '$login' profile");

		$login="";
		$login_type="";
		$smarty->clear_assign("login");
		#
		# Send mail notifications to customer department and signed customer
		#
		$mail_smarty->assign("userinfo",$olduser_info);

		#
		# Send mail to registered user
		#
		$anonymous_user = func_is_anonymous($olduser_info["login"]);

		if (!$anonymous_user && $config['Email_Note']['eml_profile_deleted'] == 'Y') {
			func_send_mail($olduser_info["email"], "mail/profile_deleted_subj.tpl", "mail/profile_deleted.tpl", $config["Company"]["users_department"], false);
		}

		#
		# Send mail to customers department
		#
		if (!$anonymous_user && $config['Email_Note']['eml_profile_deleted_admin'] == 'Y') {
			func_send_mail($config["Company"]["users_department"], "mail/profile_admin_deleted_subj.tpl", "mail/profile_admin_deleted.tpl", $olduser_info["email"], true);
		}

		$top_message = array(
			"content" => func_get_langvar_by_name("txt_profile_deleted")
		);
		func_header_location("home.php");
	}
}

if (!empty($active_modules['Special_Offers']) && $usertype=='C' && (defined('USER_MODIFY') || defined('USER_ADD'))) {
	include $xcart_dir."/modules/Special_Offers/register_customer.php";
}

if ($current_area == "C" && !empty($active_modules["UPS_OnLine_Tools"])) {
	#
	# Get the UPS OnLine Tools module settings
	#
	$params = func_query_first ("SELECT * FROM $sql_tbl[shipping_options] WHERE carrier='UPS'");

	$ups_parameters = unserialize($params["param00"]);
	if (!is_array($ups_parameters))
		$ups_parameters["av_status"] = "N";

	$smarty->assign("av_enabled", $ups_parameters["av_status"]);
}

if ($REQUEST_METHOD == "GET") {
	if (!empty($profile_modified_data) && !empty($profile_modified_data[$user])) {
		$userinfo = $profile_modified_data[$user];
	
		foreach (array('', 's_', 'b_') as $_prefix) {
			if ($default_fields[$_prefix.'title']['avail'] == 'Y') {
				$userinfo[$_prefix.'titleid'] = func_detect_title(addslashes($userinfo[$_prefix.'title']));
				$userinfo[$_prefix.'title'] = func_get_title(addslashes($userinfo[$_prefix.'titleid']));
			}
		}

	    if (defined("USER_MODIFY") && !empty($_GET["user"]) && ($current_area == 'A' || (!empty($active_modules['Simple_Mode']) && $current_area == "P"))) {
			$user_exists = func_query_first_cell("SELECT COUNT(*) FROM $sql_tbl[customers] WHERE login = '" . $_GET["user"] . "'");
			if ($user_exists > 0)
				$userinfo['login'] = $userinfo["uname"];
        }
	}

	if (!empty($profile_modified_add_field) && !empty($profile_modified_add_field[$user])) {
		$additional_fields = $profile_modified_add_field[$user];
	}
}

$ship2diff = false;

if (!empty($userinfo)) {

	foreach (array('title','firstname','lastname','city','state','country','zipcode','address','address_2','county') as $v) {
		if ($default_fields['s_'.$v]['avail'] == 'Y' && ($userinfo['s_'.$v] != $userinfo['b_'.$v] || ($default_fields['s_'.$v]['required'] == 'Y' && empty($userinfo['s_'.$v])))) {
			$ship2diff = true;
			break;
		}
	}

	# Open ship2diff section if there is wrong shipping zipcode #bt:83695
	if (!$ship2diff && $default_fields['s_zipcode']['avail'] == 'Y' && !empty($userinfo['s_zipcode']) && !empty($userinfo['s_country'])) {
		if (!func_check_zip($userinfo['s_zipcode'], $userinfo["s_country"]))	
			$ship2diff = true;
	}

	if (!empty($additional_fields)) {
		foreach ($additional_fields as $v_b) {
			if ($v_b['section'] == 'B') {
				foreach ($additional_fields as $v_s) {
					if ($v_s["section"] == "S" && $v_b["title"] == $v_s["title"] && $v_b["value"] != $v_s["value"]) {
						$ship2diff = true;
						break;
					}
				}
			}
		}
	}

	$userinfo['s_display_states'] = (func_query_first_cell("SELECT display_states FROM $sql_tbl[countries] WHERE code = '".addslashes($userinfo['s_country'])."'") == 'Y');
	$userinfo['b_display_states'] = (func_query_first_cell("SELECT display_states FROM $sql_tbl[countries] WHERE code = '".addslashes($userinfo['b_country'])."'") == 'Y');

	$smarty->assign("userinfo",$userinfo);

	if ($REQUEST_METHOD == "GET" && !empty($active_modules["News_Management"])) {
		if (empty($profile_modified_data[$user])) {
			$tmp = func_query("SELECT listid FROM $sql_tbl[newslist_subscription] WHERE email='".addslashes($userinfo['email'])."'");
			if (is_array($tmp)) {
				$subscription = array();
				foreach ($tmp as $v) {
					$subscription[$v["listid"]] = true;
				}
			}
		} else {
			$subscription = $profile_modified_data[$user]['subscription'];
		}
	}

} else {

	$share_fields = array("s_title", "s_lastname", "s_firstname", "s_address", "s_address_2", "s_city", "s_state", "s_county", "s_country", "s_zipcode");
	foreach ($default_fields as $k => $v) {
		if (in_array($k, $share_fields) && $v['avail'] && $v['required']) {
			$k = substr($k, 2);
			if (!$default_fields['b_'.$k]['avail'] || !$default_fields['b_'.$k]['required']) {
				$ship2diff = true;
				break;
			}
		}
	}

}

$share_fields = array("title", "lastname", "firstname", "address", "address_2", "city", "state", "county", "country", "zipcode");
foreach($share_fields as $v) {
	if ($default_fields["s_".$v]['avail'] && $default_fields["s_".$v]['required']) {
		if ($default_fields["b_".$v]['avail']) {
			$default_fields["s_".$v]['js_required_block'] = true;

		} elseif (in_array($v, array("title", "lastname", "firstname")) && $default_fields[$v]['avail']) {
			$default_fields["s_".$v]['js_required_block'] = true;

		}
	}
}


$smarty->assign("ship2diff", $ship2diff);

if (isset($subscription))
	$smarty->assign("subscription", $subscription);

$newslists = func_query("SELECT * FROM $sql_tbl[newslists] WHERE avail='Y' AND subscribe='Y' AND lngcode='$shop_language'");
$smarty->assign("newslists", $newslists);

if ($allow_pwd_modify)
	$smarty->assign("allow_pwd_modify", 'Y');

if (!empty($registered))
	$smarty->assign("registered", $registered);

if (!empty($reg_error)) {
	$smarty->assign("reg_error",$reg_error);
}

if (!empty($emailerror))
	$smarty->assign("emailerror",$emailerror);

if ($mode == "delete") {
	if (empty($login))
		func_header_location("home.php");

	$location[count($location)-1] = array(func_get_langvar_by_name("lbl_delete_profile"), "");
	$smarty->assign("main","profile_delete");

	if (in_array($login_type, array("A", "P"))) {
		$smarty->assign("provider_counters", func_get_provider_counters($login));
		$smarty->assign("is_provider_profile", ($login_type == "P" && !$single_mode));
		$smarty->assign("move_to_providers", func_get_next_providers($login));
	}

} elseif ($mode == "notdelete") {
	if (!empty($login))
		$top_message["content"] = func_get_langvar_by_name("txt_profile_not_deleted");

	func_header_location("home.php");

} else {
	$smarty->assign("main","register");
}

if (!empty($active_modules['XAffiliate']) && (($mode == 'update' && $login_type == 'B' ) || $current_area == 'B')) {
    $plans = func_query("SELECT * FROM $sql_tbl[partner_plans] WHERE status = 'A' ORDER BY plan_title");
    $smarty->assign("plans", $plans);
}

if (isset($_GET['parent'])) {
	$smarty->assign("parent", $parent);
}

# Hide section 'Username & Password' when anonymous customer updates his profile
if ($current_area == "C" && !empty($userinfo) && $userinfo["status"] == "A" && !empty($login)) {
	$smarty->assign("hide_account_section", "Y");
}


if ($submode == 'seller_address') {
	$default_fields = array(
		'address' => array('title'=>'address', 'field'=>'address', 'avail'=>'Y', 'required' => 'N'),
		'city' => array('title'=>'city', 'field'=>'city', 'avail'=>'Y', 'required' => 'Y'),
		'state' => array('title'=>'state', 'field'=>'state', 'avail'=>'Y', 'required' => 'Y'),
		'country' => array('title'=>'country', 'field'=>'country', 'avail'=>'Y', 'required' => 'Y'),
		'zipcode' => array('title'=>'zipcode', 'field'=>'zipcode', 'avail'=>'Y', 'required' => 'Y')
	);
	func_unset($additional_fields);
}

if (!defined('USER_MODIFY') && !defined('USER_ADD') && !empty($active_modules['Image_Verification'])) {
	x_session_register("antibot_reg_err");
	if ($antibot_reg_err) {
		$smarty->assign("reg_antibot_err", $antibot_reg_err);
		x_session_unregister("antibot_reg_err");
	}
	$smarty->assign("display_antibot", $display_antibot);
}
$smarty->assign("default_fields", $default_fields);
$smarty->assign("additional_fields", $additional_fields);
$smarty->assign("is_areas", $is_areas);
$m_usertype = (empty($_GET['usertype']) ? $current_area : $_GET['usertype']);
$membership_levels = func_get_memberships($m_usertype);
if (!empty($membership_levels))
	$smarty->assign("membership_levels", $membership_levels);
$smarty->assign("titles", func_get_titles());

x_session_save();
?>
