<?php
/*****************************************************************************\
+-----------------------------------------------------------------------------+
| X-Cart                                                                      |
| Copyright (c) 2001-2010 Ruslan R. Fazlyev <rrf@x-cart.com>                  |
| All rights reserved.                                                        |
+-----------------------------------------------------------------------------+
| PLEASE READ  THE FULL TEXT OF SOFTWARE LICENSE AGREEMENT IN THE "COPYRIGHT" |
| FILE PROVIDED WITH THIS DISTRIBUTION. THE AGREEMENT TEXT IS ALSO AVAILABLE  |
| AT THE FOLLOWING URL: http://www.x-cart.com/license.php                     |
|                                                                             |
| THIS  AGREEMENT  EXPRESSES  THE  TERMS  AND CONDITIONS ON WHICH YOU MAY USE |
| THIS SOFTWARE   PROGRAM   AND  ASSOCIATED  DOCUMENTATION   THAT  RUSLAN  R. |
| FAZLYEV (hereinafter  referred to as "THE AUTHOR") IS FURNISHING  OR MAKING |
| AVAILABLE TO YOU WITH  THIS  AGREEMENT  (COLLECTIVELY,  THE  "SOFTWARE").   |
| PLEASE   REVIEW   THE  TERMS  AND   CONDITIONS  OF  THIS  LICENSE AGREEMENT |
| CAREFULLY   BEFORE   INSTALLING   OR  USING  THE  SOFTWARE.  BY INSTALLING, |
| COPYING   OR   OTHERWISE   USING   THE   SOFTWARE,  YOU  AND  YOUR  COMPANY |
| (COLLECTIVELY,  "YOU")  ARE  ACCEPTING  AND AGREEING  TO  THE TERMS OF THIS |
| LICENSE   AGREEMENT.   IF  YOU    ARE  NOT  WILLING   TO  BE  BOUND BY THIS |
| AGREEMENT, DO  NOT INSTALL OR USE THE SOFTWARE.  VARIOUS   COPYRIGHTS   AND |
| OTHER   INTELLECTUAL   PROPERTY   RIGHTS    PROTECT   THE   SOFTWARE.  THIS |
| AGREEMENT IS A LICENSE AGREEMENT THAT GIVES  YOU  LIMITED  RIGHTS   TO  USE |
| THE  SOFTWARE   AND  NOT  AN  AGREEMENT  FOR SALE OR FOR  TRANSFER OF TITLE.|
| THE AUTHOR RETAINS ALL RIGHTS NOT EXPRESSLY GRANTED BY THIS AGREEMENT.      |
|                                                                             |
| The Initial Developer of the Original Code is Ruslan R. Fazlyev             |
| Portions created by Ruslan R. Fazlyev are Copyright (C) 2001-2010           |
| Ruslan R. Fazlyev. All Rights Reserved.                                     |
+-----------------------------------------------------------------------------+
\*****************************************************************************/

#
# $Id: func.php,v 1.6.2.3 2010/01/21 09:20:41 ferz Exp $
#

if ( !defined('XCART_START') ) { header("Location: ../../"); die("Access denied"); }

#
# Check if there are any manufacturer's products assigned to 
# a different $provider (needed to check permissions)
#
function func_manufacturer_is_used($manufacturerid, $provider) {
	global $sql_tbl;

	$result = func_query_first_cell("SELECT COUNT(manufacturerid) FROM $sql_tbl[products] WHERE manufacturerid = '".$manufacturerid."' AND provider != '".$provider."'");

    return ($result > 0);
}

#
# Set the "selected" flag for manufacturers and returns selected manufaturers IDs.
# Needed for advanced search
#
function func_manufacturer_selected_for_search(&$manufacturers, $selected_ids = false) {
	global $config;

	$ids = "";
	if (is_array($manufacturers)) {
		array_unshift($manufacturers, array("manufacturerid" => 0, "manufacturer" => func_get_langvar_by_name("lbl_no_manufacturer")));

		$ids = ($config["Search_products"]["search_products_manufacturers_d"] !== "" && 
				$config["Search_products"]["search_products_manufacturers_d"] !== NULL
				) ?
				explode("\n", $config["Search_products"]["search_products_manufacturers_d"]) :
				"";
		$ids_for_check = ($selected_ids !== false) ? $selected_ids : $ids;
		if ($ids_for_check !== "") {
			foreach ($manufacturers as $k => $v) {
				$manufacturers[$k]["selected"] = @in_array($v["manufacturerid"], $ids_for_check) ? "Y" : "N";
			}
			$ids = @implode(",", $ids);
		}
	}

	return $ids;
}

#
# Validate manufacturer's URL
#
function func_check_manufacturer_url($url) {
    global $xcart_http_host, $current_location;

    return func_check_url($url) || func_check_url("http://" . $url) || func_check_url("http://" . $xcart_http_host . $url) || func_check_url($current_location . $url);
}

?>
