<?php
/*****************************************************************************\
+-----------------------------------------------------------------------------+
| X-Cart                                                                      |
| Copyright (c) 2001-2010 Ruslan R. Fazlyev <rrf@x-cart.com>                  |
| All rights reserved.                                                        |
+-----------------------------------------------------------------------------+
| PLEASE READ  THE FULL TEXT OF SOFTWARE LICENSE AGREEMENT IN THE "COPYRIGHT" |
| FILE PROVIDED WITH THIS DISTRIBUTION. THE AGREEMENT TEXT IS ALSO AVAILABLE  |
| AT THE FOLLOWING URL: http://www.x-cart.com/license.php                     |
|                                                                             |
| THIS  AGREEMENT  EXPRESSES  THE  TERMS  AND CONDITIONS ON WHICH YOU MAY USE |
| THIS SOFTWARE   PROGRAM   AND  ASSOCIATED  DOCUMENTATION   THAT  RUSLAN  R. |
| FAZLYEV (hereinafter  referred to as "THE AUTHOR") IS FURNISHING  OR MAKING |
| AVAILABLE TO YOU WITH  THIS  AGREEMENT  (COLLECTIVELY,  THE  "SOFTWARE").   |
| PLEASE   REVIEW   THE  TERMS  AND   CONDITIONS  OF  THIS  LICENSE AGREEMENT |
| CAREFULLY   BEFORE   INSTALLING   OR  USING  THE  SOFTWARE.  BY INSTALLING, |
| COPYING   OR   OTHERWISE   USING   THE   SOFTWARE,  YOU  AND  YOUR  COMPANY |
| (COLLECTIVELY,  "YOU")  ARE  ACCEPTING  AND AGREEING  TO  THE TERMS OF THIS |
| LICENSE   AGREEMENT.   IF  YOU    ARE  NOT  WILLING   TO  BE  BOUND BY THIS |
| AGREEMENT, DO  NOT INSTALL OR USE THE SOFTWARE.  VARIOUS   COPYRIGHTS   AND |
| OTHER   INTELLECTUAL   PROPERTY   RIGHTS    PROTECT   THE   SOFTWARE.  THIS |
| AGREEMENT IS A LICENSE AGREEMENT THAT GIVES  YOU  LIMITED  RIGHTS   TO  USE |
| THE  SOFTWARE   AND  NOT  AN  AGREEMENT  FOR SALE OR FOR  TRANSFER OF TITLE.|
| THE AUTHOR RETAINS ALL RIGHTS NOT EXPRESSLY GRANTED BY THIS AGREEMENT.      |
|                                                                             |
| The Initial Developer of the Original Code is Ruslan R. Fazlyev             |
| Portions created by Ruslan R. Fazlyev are Copyright (C) 2001-2010           |
| Ruslan R. Fazlyev. All Rights Reserved.                                     |
+-----------------------------------------------------------------------------+
\*****************************************************************************/

#
# $Id: func.php,v 1.4.2.3 2010/01/21 09:20:43 ferz Exp $
# 
 
if ( !defined('XCART_START') ) { header("Location: ../../"); die("Access denied"); }

function func_get_subscription_dates($year, $pay_period_type, $pay_dates=array()) {

	switch($pay_period_type) {
	case "Annually":
		$pay_dates[] = mktime(0,0,0,1,1,$year);
		break;
	case "Quarterly":
		$pay_dates[] = mktime(0,0,0,1,1,$year);
		$pay_dates[] = mktime(0,0,0,4,1,$year);
		$pay_dates[] = mktime(0,0,0,7,1,$year);
		$pay_dates[] = mktime(0,0,0,10,1,$year);
		break;
	case "Monthly":
		for($i = 1; $i <= 12; $i++) {
			$pay_dates[] = mktime(0,0,0,$i,1,$year);  # for start of months
		}
		break;
	case "Weekly":
		$first_day = mktime(0,0,0,1,1,$year);
		$last_day = mktime(0,0,0,12,31,$year);
		for ($i = $first_day; $i <= $last_day; $i+=86400) {
			if (date("w",$i) == 1)
				$pay_dates[] = mktime(0,0,0,date("m",$i),date("d",$i),$year);
		}
		break;
	default: # By Period
		$first_day = time();
		$last_day = mktime(0,0,0,12,31,$year);
		$pay_period = intval($pay_period_type);
		if ($pay_period <= 0) {
			$pay_period = 1;
		}
		for ($i = $first_day; $i <= $last_day; $i += 86400 * $pay_period) {
			$pay_dates[] = mktime(0,0,0,date("m",$i),date("d",$i),date("y",$i));
		}
	}
	return $pay_dates;
}

?>
