<?php
/*****************************************************************************\
+-----------------------------------------------------------------------------+
| X-Cart                                                                      |
| Copyright (c) 2001-2010 Ruslan R. Fazlyev <rrf@x-cart.com>                  |
| All rights reserved.                                                        |
+-----------------------------------------------------------------------------+
| PLEASE READ  THE FULL TEXT OF SOFTWARE LICENSE AGREEMENT IN THE "COPYRIGHT" |
| FILE PROVIDED WITH THIS DISTRIBUTION. THE AGREEMENT TEXT IS ALSO AVAILABLE  |
| AT THE FOLLOWING URL: http://www.x-cart.com/license.php                     |
|                                                                             |
| THIS  AGREEMENT  EXPRESSES  THE  TERMS  AND CONDITIONS ON WHICH YOU MAY USE |
| THIS SOFTWARE   PROGRAM   AND  ASSOCIATED  DOCUMENTATION   THAT  RUSLAN  R. |
| FAZLYEV (hereinafter  referred to as "THE AUTHOR") IS FURNISHING  OR MAKING |
| AVAILABLE TO YOU WITH  THIS  AGREEMENT  (COLLECTIVELY,  THE  "SOFTWARE").   |
| PLEASE   REVIEW   THE  TERMS  AND   CONDITIONS  OF  THIS  LICENSE AGREEMENT |
| CAREFULLY   BEFORE   INSTALLING   OR  USING  THE  SOFTWARE.  BY INSTALLING, |
| COPYING   OR   OTHERWISE   USING   THE   SOFTWARE,  YOU  AND  YOUR  COMPANY |
| (COLLECTIVELY,  "YOU")  ARE  ACCEPTING  AND AGREEING  TO  THE TERMS OF THIS |
| LICENSE   AGREEMENT.   IF  YOU    ARE  NOT  WILLING   TO  BE  BOUND BY THIS |
| AGREEMENT, DO  NOT INSTALL OR USE THE SOFTWARE.  VARIOUS   COPYRIGHTS   AND |
| OTHER   INTELLECTUAL   PROPERTY   RIGHTS    PROTECT   THE   SOFTWARE.  THIS |
| AGREEMENT IS A LICENSE AGREEMENT THAT GIVES  YOU  LIMITED  RIGHTS   TO  USE |
| THE  SOFTWARE   AND  NOT  AN  AGREEMENT  FOR SALE OR FOR  TRANSFER OF TITLE.|
| THE AUTHOR RETAINS ALL RIGHTS NOT EXPRESSLY GRANTED BY THIS AGREEMENT.      |
|                                                                             |
| The Initial Developer of the Original Code is Ruslan R. Fazlyev             |
| Portions created by Ruslan R. Fazlyev are Copyright (C) 2001-2010           |
| Ruslan R. Fazlyev. All Rights Reserved.                                     |
+-----------------------------------------------------------------------------+
\*****************************************************************************/

#
# $Id: register.php,v 1.43.2.3 2010/01/21 09:20:49 ferz Exp $
#

require "./auth.php";
require $xcart_dir."/include/security.php";

$newbie = "Y";

# This script cannot be used to create provider
if ($mode!="update" && $mode!="delete" && $mode!="notdelete") {
	func_header_location("error_message.php?access_denied&id=47");
}

// Do not allow to provider registration when Simple_Mode is enabled
if (
    $config['General']['provider_register'] == 'Y'
    && empty($login)
    && !empty($active_modules['Simple_Mode'])
) {
	func_header_location("error_message.php?access_denied&id=102");
}

if (!empty($submode) && $single_mode && $submode == 'seller_address')
	func_header_location("register.php?mode=update");

if (func_empty_seller_address($login) && empty($submode) && $REQUEST_METHOD == "GET") {
	$top_message = array(
		'type' => 'W',
		'content' => func_get_langvar_by_name("msg_empty_seller_address")
	);
	$smarty->assign("top_message", $top_message);
	unset($top_message);
}

#
# Update seller address
#
if ($REQUEST_METHOD == "POST" && isset($_POST['submode']) && $_POST['submode'] == 'seller_address') {

	if ($config['General']['allow_change_seller_address'] != 'Y')
		func_header_location("register.php?mode=update&submode=seller_address");

	require $xcart_dir."/include/safe_mode.php";

	x_load('user');
	$_fields = array('address', 'address_2', 'city', 'state', 'country', 'zipcode');

	if (func_query_first_cell("SELECT active FROM $sql_tbl[shipping] WHERE active='Y' AND code='ARB' LIMIT 1") == 'Y') {
		$_fields = func_array_merge($_fields, array('arb_id', 'arb_password', 'arb_account', 'arb_shipping_key', 'arb_shipping_key_intl'));
	}

	$saved_data = $posted_data = array();
	$posted_data['login'] = $login;
	foreach($_fields as $_field)
		if (isset($_field)) {
			$posted_data[$_field] = $_POST[$_field];
			$saved_data['seller_'.$_field] = $posted_data[$_field];
		}

	$top_message = array();
	if (func_update_seller_address($posted_data)) {
		$top_message['content'] = func_get_langvar_by_name("msg_seller_address_upd");
	}
	else {
		x_session_register("profile_modified_data");
		$profile_modified_data[$login] = $saved_data;
		$top_message['content'] = func_get_langvar_by_name("msg_err_profile_upd");
		$top_message['type'] = 'E';
		$top_message["reg_error"] = 'Y';
	}

	func_header_location("register.php?mode=update&submode=seller_address");
	
}

#
# Where to forward <form action
#
$smarty->assign("register_script_name",(($config["Security"]["use_https_login"]=="Y")?$xcart_catalogs_secure['provider']."/":"")."register.php");

require $xcart_dir."/include/register.php";

$smarty->assign("newbie", $newbie);

# Assign the current location line
$smarty->assign("location", $location);

@include $xcart_dir."/modules/gold_display.php";
func_display("provider/home.tpl",$smarty);
?>
