<?php
/*****************************************************************************\
+-----------------------------------------------------------------------------+
| X-Cart                                                                      |
| Copyright (c) 2001-2010 Ruslan R. Fazlyev <rrf@x-cart.com>                  |
| All rights reserved.                                                        |
+-----------------------------------------------------------------------------+
| PLEASE READ  THE FULL TEXT OF SOFTWARE LICENSE AGREEMENT IN THE "COPYRIGHT" |
| FILE PROVIDED WITH THIS DISTRIBUTION. THE AGREEMENT TEXT IS ALSO AVAILABLE  |
| AT THE FOLLOWING URL: http://www.x-cart.com/license.php                     |
|                                                                             |
| THIS  AGREEMENT  EXPRESSES  THE  TERMS  AND CONDITIONS ON WHICH YOU MAY USE |
| THIS SOFTWARE   PROGRAM   AND  ASSOCIATED  DOCUMENTATION   THAT  RUSLAN  R. |
| FAZLYEV (hereinafter  referred to as "THE AUTHOR") IS FURNISHING  OR MAKING |
| AVAILABLE TO YOU WITH  THIS  AGREEMENT  (COLLECTIVELY,  THE  "SOFTWARE").   |
| PLEASE   REVIEW   THE  TERMS  AND   CONDITIONS  OF  THIS  LICENSE AGREEMENT |
| CAREFULLY   BEFORE   INSTALLING   OR  USING  THE  SOFTWARE.  BY INSTALLING, |
| COPYING   OR   OTHERWISE   USING   THE   SOFTWARE,  YOU  AND  YOUR  COMPANY |
| (COLLECTIVELY,  "YOU")  ARE  ACCEPTING  AND AGREEING  TO  THE TERMS OF THIS |
| LICENSE   AGREEMENT.   IF  YOU    ARE  NOT  WILLING   TO  BE  BOUND BY THIS |
| AGREEMENT, DO  NOT INSTALL OR USE THE SOFTWARE.  VARIOUS   COPYRIGHTS   AND |
| OTHER   INTELLECTUAL   PROPERTY   RIGHTS    PROTECT   THE   SOFTWARE.  THIS |
| AGREEMENT IS A LICENSE AGREEMENT THAT GIVES  YOU  LIMITED  RIGHTS   TO  USE |
| THE  SOFTWARE   AND  NOT  AN  AGREEMENT  FOR SALE OR FOR  TRANSFER OF TITLE.|
| THE AUTHOR RETAINS ALL RIGHTS NOT EXPRESSLY GRANTED BY THIS AGREEMENT.      |
|                                                                             |
| The Initial Developer of the Original Code is Ruslan R. Fazlyev             |
| Portions created by Ruslan R. Fazlyev are Copyright (C) 2001-2010           |
| Ruslan R. Fazlyev. All Rights Reserved.                                     |
+-----------------------------------------------------------------------------+
\*****************************************************************************/

#
# $Id: recommends.php,v 1.20.2.4 2010/05/04 13:54:09 aim Exp $
#
# Recommends list
#

if ( !defined('XCART_START') ) { header("Location: home.php"); die("Access denied"); }

$config["Recommended_Products"]["number_of_recommends"] = max(intval($config["Recommended_Products"]["number_of_recommends"]), 0);
#
# Defining the conditions for selecting products for the list
#
$avail_group_by = $avail_where = $avail_join = $avail_condition = "";
if ($config["General"]["unlimited_products"] != "Y" && $config["General"]["disable_outofstock_products"] == "Y") {
	if (!empty($active_modules['Product_Options'])) {
		$avail_join = "LEFT JOIN $sql_tbl[variants] ON $sql_tbl[variants].productid = $sql_tbl[products].productid";
		$avail_where = "IFNULL($sql_tbl[variants].avail, $sql_tbl[products].avail) > 0 AND";
		$avail_group_by = "GROUP BY $sql_tbl[products].productid";
	} else {
		$avail_condition = " AND $sql_tbl[products].avail>'0' ";
	}	
}

$_membershipid = intval($user_account['membershipid']);

$query_ids = array();
if ($config["Recommended_Products"]["select_recommends_list_randomly"] == "Y") {
	$rnd = rand();
	$query_ids = func_query_column("SELECT $sql_tbl[products].productid FROM ($sql_tbl[products] USE INDEX (fi,fia), $sql_tbl[categories] USE INDEX (ia), $sql_tbl[products_categories]) LEFT JOIN $sql_tbl[category_memberships] ON $sql_tbl[category_memberships].categoryid = $sql_tbl[products_categories].categoryid LEFT JOIN $sql_tbl[product_memberships] ON $sql_tbl[product_memberships].productid = $sql_tbl[products_categories].productid $avail_join WHERE $avail_where $sql_tbl[products].forsale='Y' AND $sql_tbl[products].productid = $sql_tbl[products_categories].productid AND $sql_tbl[products_categories].main = 'Y' AND $sql_tbl[categories].categoryid = $sql_tbl[products_categories].categoryid AND $sql_tbl[categories].avail = 'Y' AND ($sql_tbl[category_memberships].membershipid IS NULL OR $sql_tbl[category_memberships].membershipid = '$_membershipid') AND ($sql_tbl[product_memberships].membershipid IS NULL OR $sql_tbl[product_memberships].membershipid = '$_membershipid') AND $sql_tbl[products].productid != '$productid' $avail_group_by ORDER BY RAND(NOW()+$rnd) LIMIT ".$config["Recommended_Products"]["number_of_recommends"]);
} else {
	$query_ids = func_query_column($sql="SELECT DISTINCT sp2.productid, $sql_tbl[products].productid FROM ($sql_tbl[stats_customers_products] as sp1, $sql_tbl[stats_customers_products] AS sp2, $sql_tbl[products], $sql_tbl[categories], $sql_tbl[products_categories]) LEFT JOIN $sql_tbl[category_memberships] ON $sql_tbl[category_memberships].categoryid = $sql_tbl[products_categories].categoryid LEFT JOIN $sql_tbl[product_memberships] ON $sql_tbl[product_memberships].productid = $sql_tbl[products_categories].productid $avail_join WHERE $avail_where sp1.productid='$productid' AND sp1.login=sp2.login AND sp2.productid!='$productid' AND $sql_tbl[products].productid=sp2.productid AND $sql_tbl[products].forsale='Y' AND $sql_tbl[products].productid = $sql_tbl[products_categories].productid AND $sql_tbl[products_categories].main = 'Y' AND $sql_tbl[categories].categoryid = $sql_tbl[products_categories].categoryid AND $sql_tbl[categories].avail = 'Y' AND ($sql_tbl[category_memberships].membershipid = '$_membershipid' OR $sql_tbl[category_memberships].membershipid IS NULL) AND ($sql_tbl[product_memberships].membershipid IS NULL OR $sql_tbl[product_memberships].membershipid = '$_membershipid') $avail_group_by ORDER BY $sql_tbl[products].product LIMIT ".($config["Recommended_Products"]["number_of_recommends"]*2));
}

x_load("product");
$recommends = func_search_products(
	" AND $sql_tbl[products].productid IN ('".implode("','", $query_ids)."')",
	(isset($user_account) && isset($user_account["membershipid"])) ? max(intval($user_account["membershipid"]), 0) : 0,
	false,
	$config["Recommended_Products"]["number_of_recommends"]
);
if (!empty($recommends))
	$smarty->assign("recommends", $recommends);
?>
