



CREATE TABLE xcart_offers (
  offerid int(11) NOT NULL auto_increment,
  offer_name varchar(255) NOT NULL default '',
  offer_start int(11) NOT NULL default '0',
  offer_end int(11) NOT NULL default '0',
  offer_avail char(1) NOT NULL default 'N',
  provider varchar(32) NOT NULL default '',
  modified_time int(11) NOT NULL default '0',
  show_short_promo char(1) NOT NULL default 'Y',
  PRIMARY KEY  (offerid),
  KEY offer_avail (offer_avail,offer_start,offer_end,provider)
) TYPE=MyISAM;

CREATE TABLE xcart_offers_lng (
  offerid int(11) NOT NULL default '0',
  code char(2) NOT NULL default '',
  promo_short text,
  promo_long text,
  promo_checkout text,
  promo_items_amount text,
  PRIMARY KEY  (offerid,code)
) TYPE=MyISAM;

CREATE TABLE xcart_offer_product_sets (
  setid int(11) NOT NULL auto_increment,
  offerid int(11) NOT NULL default '0',
  set_type char(1) NOT NULL default '',
  cb_id int(11) NOT NULL default '0',
  cb_type char(1) NOT NULL default '0',
  name varchar(32) NOT NULL default '',
  avail char(1) NOT NULL default 'Y',
  appl_type char(1) NOT NULL default 'I',
  PRIMARY KEY (setid),
  UNIQUE KEY set_item_id (setid,cb_id),
  KEY set_incl_type (cb_id, set_type, appl_type)
) TYPE=MyISAM;

CREATE TABLE xcart_offer_product_params (
  productid int(11) NOT NULL default '0',
  sp_discount_avail char(1) NOT NULL default 'N',
  bonus_points int(11) NOT NULL default '0',
  PRIMARY KEY (productid)
) TYPE=MyISAM;

CREATE TABLE xcart_offer_conditions (
  conditionid int(11) NOT NULL auto_increment,
  offerid int(11) NOT NULL default '0',
  condition_type char(1) NOT NULL default '',
  amount_type char(1) NOT NULL default '',
  amount_min decimal(12,2) NOT NULL default '0.00',
  amount_max decimal(12,2) NOT NULL default '0.00',
  condition_data text,
  provider varchar(32) NOT NULL default '',
  avail char(1) NOT NULL default 'N',
  PRIMARY KEY  (conditionid),
  UNIQUE KEY c_type (offerid,condition_type)
) TYPE=MyISAM;

CREATE TABLE xcart_offer_condition_params (
  paramid int(11) NOT NULL auto_increment,
  conditionid int(11) NOT NULL default '0',
  setid int(11) NOT NULL default '0',
  param_type char(1) NOT NULL default '',
  param_id int(11) NOT NULL default '0',
  param_arg char(1) NOT NULL default '',
  param_qnty int(11) NOT NULL default '0',
  param_promo char(1) NOT NULL default 'N',
  PRIMARY KEY  (paramid),
  KEY args1 (param_type,param_id,param_arg),
  KEY conditionid (conditionid),
  KEY setid (setid)
) TYPE=MyISAM;

CREATE TABLE xcart_offer_bonuses (
  bonusid int(11) NOT NULL auto_increment,
  offerid int(11) NOT NULL default '0',
  bonus_type char(1) NOT NULL default '',
  amount_type char(1) NOT NULL default '',
  amount_min decimal(12,2) NOT NULL default '0.00',
  amount_max decimal(12,2) NOT NULL default '0.00',
  bonus_data text,
  provider varchar(32) NOT NULL default '',
  avail char(1) NOT NULL default 'N',
  PRIMARY KEY  (bonusid),
  UNIQUE KEY b_type (offerid,bonus_type),
  KEY b_sprice (bonusid,avail,bonus_type,amount_type,amount_min,amount_max)
) TYPE=MyISAM;

CREATE TABLE xcart_offer_bonus_params (
  paramid int(11) NOT NULL auto_increment,
  bonusid int(11) NOT NULL default '0',
  setid int(11) NOT NULL default '0',
  param_type char(1) NOT NULL default '',
  param_id int(11) NOT NULL default '0',
  param_arg char(1) NOT NULL default '',
  param_qnty int(11) NOT NULL default '0',
  param_promo char(1) NOT NULL default 'N',
  PRIMARY KEY  (paramid),
  KEY bonus_id_type (bonusid,param_type,param_id,param_arg),
  KEY bonusid (bonusid),
  KEY setid (setid)
) TYPE=MyISAM;

CREATE TABLE xcart_customer_bonuses (
  login varchar(32) NOT NULL default '',
  points int(11) NOT NULL default '0',
  memberships text NOT NULL,
  PRIMARY KEY  (login)
) TYPE=MyISAM;





CREATE TABLE xcart_images_S (
  imageid int(11) NOT NULL auto_increment,
  id varchar(16) NOT NULL default '',
  image mediumblob NOT NULL,
  image_path varchar(255) NOT NULL default '',
  image_type varchar(64) NOT NULL default 'image/jpeg',
  image_x int(11) NOT NULL default '0',
  image_y int(11) NOT NULL default '0',
  image_size int(11) NOT NULL default '0',
  filename varchar(255) NOT NULL default '',
  date int(11) NOT NULL default '0',
  alt varchar(255) NOT NULL default '',
  avail char(1) NOT NULL default 'Y',
  orderby int(11) NOT NULL default '0',
  md5 varchar(32) NOT NULL default '',
  PRIMARY KEY  (imageid),
  UNIQUE KEY id(id),
  KEY image_path (image_path)
) TYPE=MyISAM;





CREATE TABLE xcart_bonus_memberships (
  bonusid int(11) NOT NULL default '0',
  membershipid int(11) NOT NULL default '0',
  PRIMARY KEY  (bonusid,membershipid)
) TYPE=MyISAM;




 
CREATE TABLE xcart_condition_memberships (
  conditionid int(11) NOT NULL default '0',
  membershipid int(11) NOT NULL default '0',
  PRIMARY KEY  (conditionid,membershipid)
) TYPE=MyISAM;






INSERT INTO xcart_modules (module_name, module_descr, active) VALUES ('Special_Offers','This module enables create the special offers for your store','Y');

INSERT INTO xcart_config VALUES ('offers_bp_rate','Bonus points to Gift Certificate conversion rate','0.1','Special_Offers',10,'numeric','','','udoublez');
INSERT INTO xcart_config VALUES ('offers_bp_min','Minimum allowed amount of bonus points to convert','100','Special_Offers',15,'numeric','','','uint');
INSERT INTO xcart_config VALUES ('offers_per_row','Display offers list in multiple columns (1-3) (leave empty to use standard format)','3','Special_Offers',20,'numeric','','','^[0-3]?$');
INSERT INTO xcart_config VALUES ('offers_list_limit','Maximum number of offers in the list (at category and product pages)','3','Special_Offers',25,'numeric','','','uint');
INSERT INTO xcart_config VALUES ('offers_prod_sort_direction','If an offer\'s bonus includes products from the same category, the zero price will be assigned to the','E','Special_Offers',30,'selector','E','E:most expensive one\nC:cheapest one','');
INSERT INTO xcart_config VALUES ('offers_show_thumb_on_lists', 'Show the special offer thumbnail on the product lists', 'Y', 'Special_Offers', 35, 'checkbox', 'Y', '', '');

INSERT INTO xcart_setup_images VALUES ('S','DB','',0,'','./default_image.gif');

