



CREATE TABLE xcart_pconf_product_types (
  ptypeid int(11) NOT NULL auto_increment,
  provider varchar(32) NOT NULL default '',
  ptype_name varchar(255) NOT NULL default '',
  orderby int(11) NOT NULL default '0',
  PRIMARY KEY (ptypeid),
  UNIQUE KEY provider (provider, ptype_name)
) TYPE=MyISAM;





CREATE TABLE xcart_pconf_specifications (
  specid int(11) NOT NULL auto_increment,
  ptypeid int(11) NOT NULL default '0',
  spec_name varchar(255) NOT NULL default '',
  orderby int(11) NOT NULL default '0',
  PRIMARY KEY (specid),
  UNIQUE KEY name (ptypeid, spec_name)
) TYPE=MyISAM;





CREATE TABLE xcart_pconf_products_classes (
  classid int(11) NOT NULL auto_increment,
  productid int(11) NOT NULL default '0',
  ptypeid int(11) NOT NULL default '0',
  PRIMARY KEY (classid),
  UNIQUE KEY product_type (productid,ptypeid)
) TYPE=MyISAM;





CREATE TABLE xcart_pconf_class_specifications (
  classid int(11) NOT NULL default '0',
  specid int(11) NOT NULL default '0',
  PRIMARY KEY (classid,specid)
) TYPE=MyISAM;





CREATE TABLE xcart_pconf_class_requirements (
  classid int(11) NOT NULL default '0',
  ptypeid int(11) NOT NULL default '0',
  specid int(11) NOT NULL default '0',
  PRIMARY KEY (classid,ptypeid,specid)
) TYPE=MyISAM;





CREATE TABLE xcart_pconf_wizards (
  stepid int(11) NOT NULL auto_increment,
  productid int(11) NOT NULL default '0',
  step_name varchar(255) NOT NULL default '',
  step_descr text NOT NULL,
  orderby int(11) NOT NULL default '0',
  PRIMARY KEY (stepid),
  KEY product (productid, orderby, stepid)
) TYPE=MyISAM;





CREATE TABLE xcart_pconf_slots (
  slotid int(11) NOT NULL auto_increment,
  stepid int(11) NOT NULL default '0',
  slot_name varchar(255) NOT NULL default '',
  slot_descr text NOT NULL,
  status char(1) NOT NULL default 'O',
  multiple char(1) NOT NULL default '',
  amount_min int(11) NOT NULL default '1',
  amount_max int(11) NOT NULL default '1',
  default_amount int(11) NOT NULL default '1',
  default_productid int(11) NOT NULL default '0',
  orderby int(11) NOT NULL default '0',
  PRIMARY KEY (slotid),
  KEY product (stepid, orderby, slotid)
) TYPE=MyISAM;





CREATE TABLE xcart_pconf_slot_rules (
  slotid int(11) NOT NULL default '0',
  ptypeid int(11) NOT NULL default '0',
  index_by_and int(11) NOT NULL default '0',
  KEY slotid (slotid),
  KEY ptypeid (ptypeid),
  KEY index_by_and (index_by_and)
) TYPE=MyISAM;





CREATE TABLE xcart_pconf_slot_markups (
  markupid int(11) NOT NULL auto_increment,
  slotid int(11) NOT NULL default '0',
  markup decimal(12,2) NOT NULL default '0.00',
  markup_type char(1) NOT NULL default '%',
  membershipid int(11) NOT NULL default 0,
  PRIMARY KEY (markupid), 
  UNIQUE KEY (slotid, membershipid)
) TYPE=MyISAM;






INSERT INTO xcart_modules (module_name, module_descr, active) VALUES ('Product_Configurator','This module allows you to create and sell composite products or systems that can be assembled from various components.','Y');

